// ********************************************************************
//
//  Routine:      acLocalToGlobal.C
//  Author:       T. Oest
//
//  Description:  transformation from local to global ccordinates
//                input  rLocal[5]   x,y,z,tx,ty
//                output rGlobal[5]  x,y,z,tx,ty
//               
//
//  Modification:
//
// 08/12/00 (SKAG) - shift in z implemented
//
// ********************************************************************

// includes
#include <iostream.h>
#include <stdlib.h>
#include <math.h>
#include <algo.h>

#include "arte/arte.hh"

//****************************************************************
// function
//****************************************************************

int acLocalToGlobal(float * rLocal, float * rGlobal, int cmp){


 int flag = -1;

//----------------------------------------------------------------
// loop over ACGA table to get global alignment constants
//----------------------------------------------------------------
    for( ArteTable<ACGA>::iterator acga = ArteTable<ACGA>::begin();
         acga != ArteTable<ACGA>::end(); ++acga ) {

      if ((*acga)->cmp == cmp){

    float z0, dx, dy, dz, dtx, dty, cphi, sphi;
    float dz0, x, y, z, tx, ty;

    z0   = (*acga)->z;
    dx   = (*acga)->dx;
    dy   = (*acga)->dy;
    dz   = (*acga)->dz;
    dtx  = (*acga)->dtx;
    dty  = (*acga)->dty;
    cphi = (*acga)->rot[0];
    sphi = (*acga)->rot[3];


    x  = rLocal[0];
    y  = rLocal[1];
    z  = rLocal[2];
    tx = rLocal[3];
    ty = rLocal[4];

    dz0 = z + dz - z0;

    rGlobal[0] =  x * cphi -  y * sphi + dz0 * dtx + dx ;
    rGlobal[1] =  x * sphi +  y * cphi + dz0 * dty + dy ;
    rGlobal[2] =  z + dz ;
    rGlobal[3] = tx * cphi - ty * sphi + dtx ;
    rGlobal[4] = tx * sphi + ty * cphi + dty ;
 
      };

    flag = 0;
      };

  if (flag != 0){
    rGlobal[0] = rLocal[0];
    rGlobal[1] = rLocal[1];
    rGlobal[2] = rLocal[2];
    rGlobal[3] = rLocal[3];
    rGlobal[4] = rLocal[4];
  };


//----------------------------------------------------------------
// 
//----------------------------------------------------------------

 return flag;

};



