// ==================================================================
// 
// ackeybook.C
//
// Routine for ARTE (tested with ARTE-03-01-r2), started from KUIP
// user interface.
//
// Purpose: open keytable database for alignment & calibration
//
// Usage: keybook [return]
//                            REVISION (version, revision of table) 
//        asks for parameters KEYTABLEDB (db server with keytables)
//                            KEYTABLE (table name in db)
//
// Returns: nothing, sets global variable KeyBookWasCalled to 0
//          (opening of keytableDB successful) or 1 (no success)
//
// Files: CDF file alca/ackuip.cdf for parameter definitions
//
// Michael Hissmann, HERA-B Databases, 06.09.1999
// University of Heidelberg, 
// michael_hissmann@gmx.de
// changes:
// 01 Oct 2001 (JH) make CnArevision global so that can be written in EVHD
// ==================================================================


#include "arte/arte.hh"
#include "database/keytable.h"

extern "C" char *ku_gets();
extern "C" int ku_geti();

int KeyBookWasCalled = 0;
int CnArevision      = 0; // for online reconstruction

extern "C" void ackeybook_()
{
  char *keytabledb;
  char *keytable;
  int xe;

  CnArevision=ku_geti(); 
  keytabledb=ku_gets();
  keytable=ku_gets(); 

  xe = KeyBookTables(keytabledb,keytable,CnArevision); 
  if (xe <= 0) KeyBookWasCalled=0;
  else KeyBookWasCalled=1;
}

