// ********************************************************************
//
//  Routine:	alca/actaxxAdd.C
//  Author:		Dmitry Golubkov
//
//  Description:	Remembers selected hits,
//				called from actaxxSelectXXX
//
//  Modifications:
//   -- none yet					06/12/00 DG
//   -- added ARTE_mark					14/12/00 DG
//
// ********************************************************************

#include <iostream.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <fstream.h>
#include <iomanip.h>
#include "arte/arte.hh"
#include "arte/RSEG_cmp.hh"
#include "rang/rgExtDef.hh"
#include "rang/zfextse.hh"
#include "rang/zfparext.hh"
#include "rang/Fit.hh"
#include "Otr/OtrI.h"

#include "Otr/OtrEvent.h"


// ONLINE includes
#include "farm/farm.hh"
#include "table.h"
#include "esp.h"


#include "alca/actaxxComm.hh"





// Let's do without STL for the moment.
TaHitStruct *taHitIndices;
#define MAXHITS 100
int taHitDim = 0;
int taHitNum = 0;





// Add a hit to the list of 'good' ones

int actaxxAdd(	ArtePointer<HITB> hb,
		ArtePointer<RSEG> rs,
		unsigned int who
	     )
{
	ARTE_mark( "actaxxAdd 0", GRR_OK );

	if ( !hb.index() )
	{
		ARTE_mark( "actaxxAdd 1", GRR_OK );
		return 0;
	}

	if ( !taHitDim )
	{
		taHitDim	= MAXHITS;
		taHitIndices	= (TaHitStruct *) malloc(taHitDim*sizeof(TaHitStruct));
	}

	taHitNum++;
	if ( taHitNum >= taHitDim )
	{
		taHitDim	+= MAXHITS;
		taHitIndices	= (TaHitStruct *) realloc(taHitIndices, taHitDim*sizeof(TaHitStruct));
	}

	if ( !taHitIndices )
	{
		cout<<"actaxxAdd: *** Error, no taHitIndices available! \n";
		cout<<"actaxxAdd:		taHitDim="<<taHitDim<<endl;
		cout<<"actaxxAdd:		taHitNum="<<taHitNum<<endl;

		ARTE_mark( "actaxxAdd 1", GRR_FISHY );
		return -1;
	}


	taHitIndices[taHitNum-1].rs		= rs.index();
	taHitIndices[taHitNum-1].who		= who;

	ARTE_mark( "actaxxAdd 1", GRR_OK );
	return taHitIndices[taHitNum-1].hb	= hb.index();
}
