// ********************************************************************
//
//  Header:	alca/actaxxCommOTR.hh
//  Author:		Dirk Kruecker
//
//  Description:	TAXX command and selection - related stuff
//
//  Modifications:
//   -- creation					08/11/00 DK
//   -- remake						06/12/00 DG
//
// ********************************************************************

// Template of parameters for a detector-specific TAXX selection
extern struct TACommOTR
{
	int   nMC, nPC, nTC;	/* min number of hits per MCPCTC */
	float xcut;		/* inclusion region */
	float xexc;		/* exclusion region */

	float zcut;		/* maximal z-extrapolation length */
	float pcut;		/* momentum cut */

	float chi2_neighbour;	/* cut on chi2 with nearest track */

	int   userefit;		/* some mode switch for actaxxSelectOTRIO */


	enum {
		OtrI_st =    0x20000, /* fill time consuming OtrI statistics */
		OtrI_gd =   0x100000, /* restore OTR gede via OtrI */
	};

	unsigned int flg;	/* some internal TAXX flag for OTR */

} taCommOTR;
