*CMZ :          02/05/96  17.04.44  by  Hartwig Albrecht
*CMZ :  2.01/02 30/01/96  11.16.44  by  Hartwig Albrecht
*CMZ :  2.01/01 19/12/95  17.18.58  by  Hartwig Albrecht
*CMZ :  2.01/00 14/02/95  10.38.03  by  Hartwig Albrecht
*-- Author :    Hartwig Albrecht   04/02/95

      SUBROUTINE ALTOPP

************************************************************************
*
* Description: FILL Lund particle table
*
* called from: ALINIT
*
* External references:
*
* Arguments: none
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "auto/TOPP.fi"
#include "jets/LUDAT2.fi"
#include "jets/LUDAT3.fi"
#include "jets/LUDAT4.fi"
#include "jets/LUCODE.fi"

      INTEGER I, J, K, LUCOMP, LENOCC
      CHARACTER*12 CNAME

#include "arte/Arte.ff"
#include "auto/TOPP.ff"

C check uniqueness of the Lund code in ToPP

      DO 20 I = 1, NTOPP()
        IF (ITOPP_LUND(I) .EQ. 0)  GO TO 20
        DO 10 J = I + 1, NTOPP()
          IF (ITOPP_LUND(I) .NE. ITOPP_LUND(J))  GO TO 10
          C78 = 'ALTOPP: particles'
          CALL CHHTOC (IQ(HQTOPP_NAME(1,I)), CNAME)
          CALL CH78BC (CNAME)
          CALL CH78BC ('and')
          CALL CHHTOC (IQ(HQTOPP_NAME(1,J)), CNAME)
          CALL CH78BC (CNAME)
          CALL CH78BC ('have the same Lund code')
          CALL ME78WC (7612345)
 10     CONTINUE
 20   CONTINUE

C LCOD = pointer to Arte particle table

      DO 30 I = 1, 500
        LCOD(I) = 0
 30   CONTINUE

C relation between Arte and compressed Lund code

      DO 40 I = 1, NTOPP()
        IF (ITOPP_LUND(I) .LE. 0)  GO TO 40
        J = LUCOMP (ITOPP_LUND(I))
        IF (J .GT. 0 .AND. J .LE. 500)  THEN

C Lund code 84..90: "diquark", "c-hadron", etc.

          IF (LCOD(J) .EQ. 0 .OR.
     +      (ITOPP_LUND(I) .GE. 84 .AND. ITOPP_LUND(I) .LE. 90))  THEN
            LCOD(J) = I
          ELSE
            IF (ITOPP_LUND(LCOD(J)) .LT. 84 .OR.
     +          ITOPP_LUND(LCOD(J)) .GT. 90)  LCOD(J) = I
          END IF
        ELSE
          CALL CHHTOC (IQ(HQTOPP_NAME(1,I)), CNAME)
          C78 = 'ALTOPP:'
          CALL CH78BC (CNAME)
          CALL CH78BC ('(Lund code')
          CALL CH78BI (ITOPP_LUND(I))
          CALL CH78AC (') not accepted')
          CALL ME78SP ('P')
        END IF
 40   CONTINUE

C fill Lund table

      DO 50 J = 1, 500
        IF (LCOD(J) .GT. 0)  THEN
          I = LCOD(J)

          KCHG(J,1) = ITOPP_CHRG(I)
          KCHG(J,2) = ITOPP_COLO(I)
          KCHG(J,3) = 0
          IF (I .NE. ITOPP_ANTI(I))  KCHG(J,3) = 1

          PMAS(J,1) = FTOPP_MASS(I)
          PMAS(J,2) = FTOPP_WID(I)
          PMAS(J,3) = FTOPP_TRBW(I)
          PMAS(J,4) = 0.
          IF (PMAS(J,2) .NE. 0.)  PMAS(J,4) = FTOPP_LIFE(I) / 3.33E-12

          MDCY(J,1) = ITOPP_DECA(I)
          CALL CHHTOC (IQ(HQTOPP_NAME(1,I)), CHAF(J))

          K = LENOCC (CHAF(J))
          IF (INDEX ('.+-', CHAF(J)(K:K)) .NE. 0)  THEN
            CHAF(J)(K:K) = ' '
            IF (INDEX ('+-', CHAF(J)(K-1:K-1)) .NE. 0)
     +         CHAF(J)(K-1:K-1) = ' '
          END IF

        ELSE IF (CHAF(J) .NE. ' ')  THEN

          C78 = 'ALTOPP: Lund particle'
          CALL CH78BC (CHAF(J))
          CALL CH78BC ('cannot be accessed')
          CALL ME78SP ('P')

        END IF

 50   CONTINUE

      END

************************************************************************
* End of ALTOPP
************************************************************************
