//
// This file is part of the C++ interface for Arte
// the HERA-B reconstruction and analysis tool
//
// This is the definition of the ArtePointer class.
//
// ArtePointer allows access to the Arte data tables in
// a pointer-like way.
//
//
// .SS Usage // A Pointer to an GESL is declared as
//
// .ft B
//      ArteTableIterator<xxx> relPoint;
//
//
// .SS See Also
//
// ArtePointer.hh
//
// Author: Christoph Borgmeier
//

#ifndef _ARTE_TABLE_ITERATOR_HH_
#define _ARTE_TABLE_ITERATOR_HH_

//#ifdef __GNUC__
//#pragma interface
//#endif

#include "arte/Pointer.hh"

template <class t>
class ArteTableIterator: public ArtePointer<t>
{
public:
  inline ArteTableIterator();
  inline ArteTableIterator( unsigned int i );
  // Work around for GEPT etc.

  inline int valid() const;
  inline ArtePointer<t> next();
};

#include "arte/TableIterator.icc"

#endif
