//
//
// this routine copies tape files to disk.
// The disk is cleaned by calling the script clean.script (which must
// be located in the satging directory). The staging directory
// is by defaul /hb/OSMcache if the environment variable OSM_CACHE_DISK
// is not set.
//
// arguments: in   = -1 farm input file
//                 = 0 input file 
//                 = 1 output file (will be saved only) 
//                 = 2 copy to tape
//
//                                                       T. Oest
//
#include <sys/types.h>
#include <iostream.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <time.h>
#include <sys/stat.h>

// time limit for the staging procedure (sec)
#define WAITTIME 2000
// time since last change after which a file is supposed to be closed (sec)
#define LASTCHANGE 10
// time after which the disk space is checked (sec)
#define SLEEP system("sleep 10")


static int nrFiles = 0;
static char * filelist[50];

//*******************************************************************
// staging routine returns the destination or NULL
//*******************************************************************
extern "C" void ioosmcache_(int * in, char * sourcein, int * chlen){

struct stat filestatus;
struct stat * p_filestatus = &filestatus;

//-------------------------------------------------------------------
// copy source file
//-------------------------------------------------------------------
int search_char = 32;
char * filename = strchr(sourcein,search_char);
int length;


 if (filename != NULL){
  length = (filename-sourcein-1);
 } else {
  length = strlen(sourcein)+1;
 };
  char * sourcefile = (char*) malloc(length+1);
  strncpy(sourcefile,sourcein,length);
//-------------------------------------------------------------------
// get the file name, ascii code 47 = /
//-------------------------------------------------------------------
 search_char = 47;
 filename = strrchr(sourcefile,search_char);

 if (filename != NULL){
  filename++;
 } else {
  filename = sourcefile;
 };

//-------------------------------------------------------------------
// destination file
//-------------------------------------------------------------------
 char defaultcache[13];
 sprintf(defaultcache,"/hb/OSMcache");

 char * cachedisk;

 if (getenv("OSM_CACHE_DISK") == NULL){
   cachedisk = defaultcache;
 } else {
   cachedisk = getenv("OSM_CACHE_DISK");
 };

char * destination = (char*) malloc(strlen(cachedisk)+strlen(filename)+2) ;
sprintf(destination,"%s/%s",cachedisk,filename);

//-------------------------------------------------------------------
// stage file if in=0
//-------------------------------------------------------------------
 if (*in <= 0 || *in == 2){
//-------------------------------------------------------------------
// check if file exist on stage disk
//-------------------------------------------------------------------

 if (stat(destination,p_filestatus) != 0 ||
     time(NULL) - filestatus.st_ctime < LASTCHANGE || *in == 2){

//-------------------------------------------------------------------
// now stage the file (finished if last modification > 100 sec)
//-------------------------------------------------------------------
 char   ssh[12];

 const char * host = getenv("HOST");
 if ( host == NULL || strcmp(host,"hera-b") != 0 ) {
          sprintf(ssh,"rsh hera-b ");
 } else { sprintf(ssh," ");
 };

 char * command1 = 
  (char*) malloc(strlen(ssh)+strlen(sourcefile)+strlen(destination)+10);
 char * command2 = (char*) malloc(strlen(ssh)+strlen(destination)+12);
 char * command3 = (char*) malloc(strlen(ssh)+2*strlen(cachedisk)+28);

 if (*in <= 0 ){
  sprintf(command1,"%s osmcp %s %s&",ssh,sourcefile,destination);
 } else {
  sprintf(command1,"%s osmcp %s %s&",ssh,destination,sourcefile);
 };
 sprintf(command2,"%s chmod g+w %s",ssh,destination);
 sprintf(command3,"%s %s/clean.script %s > /dev/null",ssh,cachedisk,cachedisk);

// stage if file not existing
 if (stat(destination,p_filestatus) != 0 || *in == 2) system(command1);


// sleep if staging time < WAITTIME  and file is still open

 int t0    = time (NULL);
 while ( t0-time(NULL) < WAITTIME  &&
         (stat(destination,p_filestatus) != 0 ||
          time(NULL) - filestatus.st_ctime < LASTCHANGE ||
          filestatus.st_size == off_t(0)))
 { 
   SLEEP;
   // retry staging
   if ( 2.*(t0-time(NULL)) < WAITTIME && 2.*(t0-time(NULL)) > WAITTIME - 20) system(command1);
   system(command3);
 };

// change access rights of file

 system(command2);

 free(command1);
 free(command2);
 free(command3);
 };

//-------------------------------------------------------------------
// store file if in=1
//-------------------------------------------------------------------
 } else if (*in == 1){

   if (nrFiles < 50){
    filelist[nrFiles] = (char*) malloc(strlen(sourcefile)+1);
    sprintf(filelist[nrFiles],"%s",sourcefile);
    nrFiles++;
   };
 };

//-------------------------------------------------------------------
// return destination or NULL
//-------------------------------------------------------------------
 if ( (*in <= 0 && stat(destination,p_filestatus) == 0) || *in == 1){
   if (strlen(sourcein) > strlen(destination)){
     if (*in == -1) {
       sprintf(sourcein,"%s",destination);
     } else {
       char format[20];
       sprintf(format,"%s%i%s","%-",length,"s");
       sprintf(sourcein,format," ");
       sprintf(sourcein,"%s",destination);
     };
   };
  };

return;
};
//*******************************************************************
// copy output files to tape
//*******************************************************************
extern "C" void ioosmtape_(){
  int j = 2;
  for (int i=0; i<nrFiles; i++) {
   ioosmcache_(&j,filelist[i],&j);
   free (filelist[i]);
  };

};


