//                              -*- Mode: C++ -*-
//: CmdCareMinims.hh
//
//
// Author: Mauro Villa   
// ECAL group 
// HERA-B experiment, Desy
// e-mail: villa@bo.infn.it
//
// Created 12/6/97
// Last Update ........
//

#include "care/CmdCareMinims.hh"
#include "care/ECHitCellArray.hh"

/////////////// The function seen by kuip
#ifdef USEKUIP
extern "C" {
  void careminims_(){
    CmdCareMinims minCmd;
    minCmd.readAndExe();
  }
}; // end of extern
#endif
//////////////////////////////////////////////////////////


CmdCareMinims::CmdCareMinims() : inner(0.15), middle(0.1), outer(0.05), 
  minoffset(3) {}

CmdCareMinims::~CmdCareMinims(){}

void CmdCareMinims::defValues(){
  inner = 0.15;
  middle = 0.1;
  outer = 0.05;
  minoffset = 3;
}

//--
//   Execute stored command
void CmdCareMinims::execute(){
  ECHitCellArray::setMinimumEnergy(inner,middle,outer, minoffset);
}

# ifdef USEKUIP
//--
//   Read acommand from external
void CmdCareMinims::read(){
  inner = readFloat();
  middle = readFloat();
  outer = readFloat();
  minoffset = readInt();
}
# endif
                          
//--
//   Printout Information for the current MinimumEnergy data stored
void CmdCareMinims::dump(){
   ECHitCellArray::dumpCutOff();
}


//--
//    Set internal data
void CmdCareMinims::setMinims(Energy_t  inn, Energy_t mid, Energy_t out,
			      int offset){
  inner = inn;
  middle = mid;
  outer = out;
  minoffset = offset;
  execute();
}

