#!/bin/bash
#
# Script to do prepare index.html & to get change log information
#
# T.Glebe MPI fuer Kernphysik Heidelberg.
#
##########################################################################

DIR=`dirname $0`
LOGFILE=${DIR}/ChangeLog.txt
PKG=cluearte
CVSFILE=${DIR}/../../CVStag.${PKG}

if [ -f $LOGFILE ]; then
  rm -f $LOGFILE
else
  touch $LOGFILE
fi

if [ ! -f ${CVSFILE} ]; then
  echo "Error in htmlprep.sh: cannot find ${PKGFILE}"
  exit
fi

cp ${DIR}/indextempl.html ${DIR}/index.html

VRS=`awk '/xcvsVERSION_cluearte/ { print $3 }' ${CVSFILE} | tr -d '"' | cut -b2-`

# substitute project versions
echo "<pre>" >> $LOGFILE

( nxcvs.sh log $PKG $VRS | tr -d '<>'; echo) >> $LOGFILE

PKG=`echo $PKG | tr -d '+'`VERSION
mv ${DIR}/index.html ${DIR}/index.x
awk '{gsub("'$PKG'","'$VRS'",$0); print $0}' ${DIR}/index.x > ${DIR}/index.html
    
echo "</pre>" >> $LOGFILE
rm -f ${DIR}/index.x
