// *****************************************************************************
//
// source:    daqifwriteevent.C
//
// type:      source code
//
// created:   16 Mar 2001
//
// author:    Lars Soezueer
//            email: soezueer@mail.desy.de
//
// purpose:   write the daq formatted event to a file//            called by usevnt.C
//
// changes:   
//
// *****************************************************************************
#include "daqif/daqif.hh"
#include "daqif/kadaqif.hh"
#include "daqif/daq_mc_if.hh"

#include "arte/ArteMessage.hh"

#include <iostream.h>

int daqifwriteevent(EVENT_HDR* event) {
  static bool first=true;
  int stat;
  if (first) {
    first=false;
    stat=DAQ_MC_IF::init_file(kadaqif::get_daqfile());
    if (stat) {
      arteMsg << "daqifwriteevent: Couldn't open " << kadaqif::get_daqfile();
      arteMsg.warn();
      return 1;
    }
  }
  stat=DAQ_MC_IF::writeEvent(event);
  if (stat) {
    arteMsg << "daqifwriteevent: Error writing event to " << kadaqif::get_daqfile();
    arteMsg.warn();
  }
  return stat;
}
