// *****************************************************************************
//
// source:    daq_mctruth_if.hh
//
// type:      header file
//
// created:   14 Mar 2001
//
// author:    Lars Soezueer
//            email: soezueer@mail.desy.de
//
// purpose:   declaration of class DAQ_MCTRUTH_IF
//            and auxiliary stuff
//
// changes:   
//
// *****************************************************************************
#ifndef _DAQ_MCTRUTH_IF_
#define _DAQ_MCTRUTH_IF_

#include <hash_map>
#include <set>

#include "arte/arte.hh"

#include "daqif/daq_sparse_if.hh"

struct eqstr
{
  bool operator()(const char* s1, const char* s2) const
  {
    return strcmp(s1, s2) == 0;
  }
};

typedef hash_map<const char*, ArteRelationIterator<MIMP>, hash<const char*>, eqstr> omt;

class DAQ_MCTRUTH_IF : public DAQ_SPARSE_IF {

public:
  DAQ_MCTRUTH_IF() : DAQ_SPARSE_IF(COMP_N_MCTRUTH) {}

  unsigned int getFED_IDs(unsigned short *buf, unsigned int maxIDs);
  int getFED(unsigned short fedid, FED_HDR *buf, unsigned int maxSize);

  int prepareEvent(void); // status return

  int   lund;


protected:

private:

};

  static set<unsigned int> mctruth_feds;

#endif
