// *****************************************************************************
//
// source:    daq_otr_if.hh
//
// type:      header file
//
// created:   13 Mar 2001
//
// author:    Lars Soezueer
//            email: soezueer@mail.desy.de
//
// purpose:   declaration of class DAQ_OTR_IF
//            and auxiliary stuff
//
// changes:   
//
// *****************************************************************************
#ifndef _DAQ_OTR_IF_
#define _DAQ_OTR_IF_

#include <map>
#include <hash_map>

#include "daqif/daq_sparse_if.hh"
#include "arte/arte.hh"

typedef map<unsigned char, unsigned char> OTRFED_t ;

struct eqOTRFED
  {
   bool operator()(const unsigned short FedId1, const unsigned short FedId2) const
   {
    return FedId1 == FedId2;
   }
  };

typedef hash_map<const unsigned short, OTRFED_t, hash<unsigned short>, eqOTRFED> OTRmap_t ;

class DAQ_OTR_IF : public DAQ_SPARSE_IF {

public:
  DAQ_OTR_IF() : DAQ_SPARSE_IF(COMP_N_OTR) {}

  unsigned int getFED_IDs(unsigned short *buf, unsigned int maxIDs);
  int getFED(unsigned short fedid, FED_HDR *buf, unsigned int maxSize);

  int prepareEvent(void); // status return

protected:

private:

};

int MCGetFedIds(unsigned short *buf, unsigned int maxIDs);
int MCGetFedInfo(ArtePointer<HITB> hitb, unsigned short& fedid, 
		 unsigned char& chanid, unsigned char& tdccount);
static OTRmap_t OTRmap;

#endif
