// *****************************************************************************
//
// source:    kadaqif.hh
//
// type:      header file
//
// created:   21 Mar 2001
//
// author:    Lars Soezueer
//            email: soezueer@mail.desy.de
//
// purpose:   class declaration for the KUIP interface of daqif
//
// changes:   
//
// *****************************************************************************
#ifndef _KADAQIF_
#define _KADAQIF_

class kadaqif
{
public:
  static kadaqif* Instance();
  static unsigned int get_compmask()    { return Instance()->m_compmask; }
  static void         set_compmask(unsigned int arg)
                                        {Instance()->m_compmask     = arg; }
  static float        get_mctruth_Ecut(){ return Instance()->m_mctruth_Ecut; }
  static void         set_mctruth_Ecut(float arg)
                                        {Instance()->m_mctruth_Ecut = arg; }
  static char*        get_daqfile()     { return Instance()->m_daqfile; }
  static void         set_daqfile(char* arg)
                                        {Instance()->m_daqfile      = arg; }
protected:
  kadaqif();
private:
  static kadaqif* m_instance;
  unsigned int m_compmask;
  float        m_mctruth_Ecut;
  char*        m_daqfile;
};

#endif
