#ifndef __DGOCELL_HH__
#define __DGOCELL_HH__

#ifndef __SGI_STL_VECTOR
#include <vector>
#endif

#ifndef ARTE_HH
#include <arte/arte.hh>
#endif
#ifndef _ZGDIG_HH_
#include <digi/zgdig.hh>
#endif

namespace dgocell
{
  // Calculate teh path length through a honey comb cell
  float PathLengthHC(float pitch, float x, float tx, float ty) ;
  // Digitize MC hit. Returns tdc value.
  float CreateHit(float pit, float acc, float eff,float pathlen,float dd ) ;
  // Translate tdc value to hitb->q and hitb->r
  float EstimatedRadius(float time, float pit, float acc=-1) ; // t: drift time
  float EstimatedSigma(float time, float pit, float acc=-1) ;  // t: drift time
  // Generate cross-talk for module gf. Hits are appended to dgvec.
  void GenerateXTalkHits( vector<digx>& dgvec, ArtePointer<GEDE> gf) ;
  // Generate noise hits for module gf. Hits are appended to dgvec.
  void GenerateNoiseHits( vector<digx>& dgvec, ArtePointer<GEDE> gf) ;
  // Initialize dgocell
  void Initialize() ;
  // Force initialization dgocell on next call
  void ForceInitialization() ;
  // Calibrate the MC rt-relations
  void CalibrateRT() ;
} ;

#endif
