
// ******************************************************************
//
// D. Samtleben 10 Aug 1999
//
// Filling of histograms
//
// changes:
// 28 Oct 1999 (AG) use defines from DQ.h
//  1 Nov 1999 (AG) get rid of dq_hid.h
// 13 Nov 2001 (JH) Modifications by Mike Walter
//  8 Feb 2002 (MW) remove MC
//
// ******************************************************************

// standard includes
#include <stdlib.h>
#include <stdio.h>

// ONLINE includes
#include "rhp.h"
#include "event.h"

// Arte includes
#include "arte/arte.hh"
#include "dq/DQ.h"
#include "dq/DQ_OTR.h"
#include "arte/ArteMessage.hh"
#include "rang/Fit.hh"
#include "rang/HitWire.hh"
#include "rang/State.hh"
#include "rang/Node.hh"
#include "rang/Track.hh"
#include <string>
#include <map>
#include <set>
#include "arte/RSEG_cmp.hh"
#include "rang/zfconst.hh"
#include "rang/Geom.hh"
#include "OtrI.h"
#include "faHbook.h"
#include <fstream>
#include <iomanip>

//
// function code
//
int
DQ_OTR_rec_evnt()
{
  static float event=0 ;
  static float record=0 ;

  event++ ;
  record++ ;

  // =================ANALYSIS OF SINGLE SEGM===================
  float NSegmVxd=0 ;
  float NSegmPC=0 ;
  float NSegmTC=0 ;
  for( ArteTable<RSEG>::iterator rseg=ArteTable<RSEG>::begin(); 
       rseg!=ArteTable<RSEG>::end(); ++rseg) 
  { // ----------selection of segments-------------------------2 
    if(((*rseg)->cmp & Rsegc::bitsign) !=0 ) continue ;
    if((*rseg)->fit!=0) continue ;
    if(((*rseg)->cmp & Rsegc::vxd) !=0 )
    { // --------- selection vxd segments--------------------3
      NSegmVxd++ ;
      float NHpSvxd = (*rseg)->nhit ; 
      rhp_hf1(DQ_ID(COMP_OTR,LVL_REC,207),NHpSvxd,1);
    } // ------end selection vxd segments--------------------3

    if(((*rseg)->cmp & Rsegc::patt) !=0 )
    { // --------- selection pc segments --------------------3
      NSegmPC++ ;
      float zfirst  = (*rseg)->zf ;
      float zend    = (*rseg)->ze ;
      if(zfirst>700 && zend<1000) { // PC alone ---
      float NHpSpc = (*rseg)->nhit ; 
      rhp_hf1(DQ_ID(COMP_OTR,LVL_REC,210),NHpSpc,1);
      }
        //      cout << "ev " << event << " p " << PTrack 
        //   << " zf " << zfirst << " nhitseg " << nhitseg << endl ;
    } // ------end selection pc segments --------------------3

    if(((*rseg)->cmp & Rsegc::trit) !=0 )
    { // --------- selection tc segments --------------------3
      NSegmTC++ ;
      float NHpStc = (*rseg)->nhit ; 
      //      float zfirst  = (*rseg)->zf ;
      //      float zend    = (*rseg)->ze ;
      rhp_hf1(DQ_ID(COMP_OTR,LVL_REC,211),NHpStc,1);
    } // -----end  selection tc segments --------------------3
  } // ------end selection of segments-------------------------2 
  if(NSegmVxd> 0) rhp_hf1(DQ_ID(COMP_OTR,LVL_REC,203),NSegmVxd,1) ;
  if(NSegmPC > 0) rhp_hf1(DQ_ID(COMP_OTR,LVL_REC,205),NSegmPC,1) ;
  if(NSegmTC > 0) rhp_hf1(DQ_ID(COMP_OTR,LVL_REC,206),NSegmTC,1) ;
  // =================ANALYSIS OF RTRA==========================
  float qp ;
  float NTracks=0 ;
  float NTrSegmVxd=0 ;
  float NTrSegmPC=0 ;  
  for ( ArteTable<RTRA>::iterator rtra = ArteTable<RTRA>::begin();
        rtra != ArteTable<RTRA>::end(); ++rtra ) 
  { // ----------loop over tracks ------------------------------2
    if((*rtra)->hsi <= 0 || (*rtra)->hou <= 0) continue;
    qp  = 1./(*rtra)->pf ;
    //if(fabs(qp) < 3) continue ;
    NTracks++ ;
    //    fqp->Fill(qp) ;

    for( ArteRelationIterator<RSEG> rseg = rtra->rseg.begin(); 
         rseg != rtra->rseg.end(); ++rseg) 
    { // ----------selection of track segments----------------3 
      if(((*rseg)->cmp & Rsegc::bitsign) !=0 ) continue ;
      if((*rseg)->fit!=0) continue ;
      if(((*rseg)->cmp & Rsegc::vxd) !=0 )
      { // ----------vertex detector -----------------------4
        NTrSegmVxd++ ;
        float NHpRTRAvxd = (*rseg)->nhit ;
	rhp_hf1(DQ_ID(COMP_OTR,LVL_REC,201),NHpRTRAvxd,1) ;
      } // ------end vertex detector -----------------------4
      if(((*rseg)->cmp & Rsegc::patt) !=0 )
      { // ----------pc chambers     -----------------------4
        NTrSegmPC++ ;
        float NHpRTRApc = (*rseg)->nhit ;
	rhp_hf1(DQ_ID(COMP_OTR,LVL_REC,202),NHpRTRApc,1) ;
      } // ------end pc chambers     -----------------------4
    } // ------end selection of track segments----------------3 
  } // ------end loop over tracks ------------------------------2
  if(NTracks > 0) rhp_hf1(DQ_ID(COMP_OTR,LVL_REC,200),NTracks,1) ;   



  return 0; // return error code (0 = okay)
}
