// ********************************************************************
//
//  Routine:      kagageacga
//  Author:       T.Oest
//
//  Description:  fill row of acga table
//
//
// ********************************************************************

#include <iostream.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include "arte/arte.hh"

extern int acReadGlobalSwitch;


extern "C" void kugeti_(int*);
extern "C" void kugetr_(float*);
extern "C" void kugetc_( char*, int *, int );


// ********************************************************************
//  function
// ********************************************************************
extern "C" void kagageacga_() {

//---------------------------------------------------------------
//   read in component to be aligned
//---------------------------------------------------------------

  int cmp;
  float dx,dy,dz, dtx, dty, fz, z;
  float rot[9];

  kugeti_(&cmp);
  kugetr_(&dx);
  kugetr_(&dy);
  kugetr_(&dz);
  kugetr_(&dtx);
  kugetr_(&dty);
  kugetr_(&fz);
  kugetr_(&z);

  for (int i=0; i<=8; i++) kugetr_(&rot[i]);


//---------------------------------------------------------------
//   remove acga, switch off db reading
//---------------------------------------------------------------

  if (cmp < 0){

   acReadGlobalSwitch = 0;
   ArteTable<ACGA>::clear();

  } else if (cmp == 0) {
   
   acReadGlobalSwitch = 1;

  } else {

//---------------------------------------------------------------
//   fill acga row
//---------------------------------------------------------------
  ACGA acga;

    acga.cmp = cmp;
    acga.dx  = dx;
    acga.dy  = dy;
    acga.dz  = dz;
    acga.dtx = dtx;
    acga.dty = dty;
    acga.fz  = fz;
    acga.z   = z;
    for (int i=0; i<9; i++) acga.rot[i] = rot[i];

    ArteTable<ACGA>::push_back( acga );

  };

};
