/*************************************************************************
*
* CR_ARTE_USER
* written by Siegmund Nowak
*
* This routines gives the user the possibility to change data in the 
* last NEDE bank produced by cr_arte.C
*
*       called from G..MAIN
*
*************************************************************************/

#include "arte/arte.hh"
#include "arte/ArteFlag.h"
#include "arte/ArteMessage.hh"
#include "arte/ArteUtil.h"
#include "gean/ZGMOTH.h"
#include "gean/ZGESL.h"
#include "gean/Geant2Arte.hh"

    void tar_arte(const int,const int,const char*,const int*,const int);
    void rpot_arte(const int,const int,const char*,const int*,const int);
    void itr_arte(const int,const int,const char*,const int*,const int);
    void sil_arte(const int,const int,const char*,const int*,const int);
    void ric_arte(const int,const int,const char*,const int*,const int);
    void szh3_arte(const int,const int,const char*,const int*,const int);

void cr_arte_user(const int nede,const int nwal,const char *lvols,
                                 const int lcopy[],const int nlev) {

    ArtePointer<NESL> sl(zgmoth_.CURRSL);

    if(sl->cmp == LGESL_TAR)
       tar_arte(nede,nwal,lvols,lcopy,nlev);

    else if(sl->cmp == LGESL_RPOT)
      rpot_arte(nede,nwal,lvols,lcopy,nlev);

    else if(sl->cmp == LGESL_SIL) 
       sil_arte(nede,nwal,lvols,lcopy,nlev);

    else if(sl->cmp == LGESL_MSG) 
       itr_arte(nede,nwal,lvols,lcopy,nlev);

    else if(sl->cmp == LGESL_RIC) 
       ric_arte(nede,nwal,lvols,lcopy,nlev);

    else if(sl->cmp == LGESL_HOD3)
       szh3_arte(nede,nwal,lvols,lcopy,nlev);
  }
      
/* cr_arte_user */








