/***********************************************************************
*-- author :    siegmund nowak
*
* this routines selects randomly a wire for the  interaction vertex 
* this is done before the event generator is called, i.e. in alevnt
*
***********************************************************************/

#include <string.h>
#include "arte/arte.hh"
#include "arte/ArteFlag.h"
#include "arte/ArteMessage.hh"

extern "C" {
   int crwire_(int &);
   void ranecu_(float [],int *, int *);
}
static int  first_crwire=0;

int crwire_(int & iev) {  
   static float prob[14];
   static char tm[56];

   int ntarg = ArteTable<GTAR>::size();  
   if(ntarg <= 0) return 0;

   if(!first_crwire) {
      if(ntarg > 14) {
          arteMsg << "crwire: wire selection is limited to 14 wires "; 
          arteMsg.error();
      } 
      float probtot = 0.0; 
      memset(tm,' ',56);
      for(int iw=0; iw<ntarg; iw++) { 
         ArtePointer<GTAR> gt(iw+1);
         prob[iw] = gt->eff;
         probtot = probtot + prob[iw];
         ArtePointer<GMAT> gm(gt->cmp);
         if     (!strncmp(gm->name,"ALUMINIUM",9)) strncpy(&tm[4*iw],"AL  ",4);
         else if(!strncmp(gm->name,"CARBON",   6)) strncpy(&tm[4*iw],"C   ",4);
         else if(!strncmp(gm->name,"COPPER",   6)) strncpy(&tm[4*iw],"CU  ",4);
         else if(!strncmp(gm->name,"TUNGSTEN", 8)) strncpy(&tm[4*iw],"W   ",4);
         else if(!strncmp(gm->name,"TITAN",    5)) strncpy(&tm[4*iw],"TI  ",4);
         else if(!strncmp(gm->name,"BERYLLIUM",9)) strncpy(&tm[4*iw],"BE  ",4);
         else if(!strncmp(gm->name,"PALLADIUM",9)) strncpy(&tm[4*iw],"PD  ",4);
         else {
          arteMsg << "crwire: Targetmaterial " << gm->name <<" not foreseen"; 
          arteMsg.error();
	}
      }
      if(probtot <= 0.) {
        arteMsg << "crwire: no effectivity given for target wires "; 
	arteMsg.warn();
        arteMsg << "crwire: random distribution on all wires is taken "; 
	arteMsg.warn();
        for(int iw=0; iw<ntarg; iw++) { 
           prob[iw] = 1./float(ntarg);
           probtot = probtot + prob[iw];     
	 }
      }

      for ( int iw=0; iw<ntarg;iw++)  prob[iw] = prob[iw] / probtot;
      for ( int iw=1; iw<ntarg;iw++)  prob[iw] = prob[iw] + prob[iw-1];
      first_crwire = 1;
   }

   int i1 = 1, iw = 0;
   float ar[1];
   ranecu_(ar,&i1,&i1);
   while (ar[0] > prob[iw] )  iw++; 
   if(iw >= ntarg) iw = ntarg-1;
   strncpy(arteflag_.targetmat,&tm[4*iw],4);

   return ArtePointer<GTAR>(iw+1)->wnr;
 }
