/***********************************************************************
* Author :    Siegmund Nowak   22/12/95
*
* Description: Geant simulation for one event
*
* Called from: ATEVNT
*
* External references: GEANT
*
***********************************************************************/
#include "arte/arte.hh"
#include "arte/ArteFlag.h"
#include "arte/ArteMessage.hh"
#include "gean/gclink.h"
#include "gean/gcstak.h"
#include "gean/gcflag.h"

extern "C" {
  void hgevnt_();
  void mmbook_(int &, const int &);
  void crlosh_(char *,char *);
  void alrini_();
  void grndmq_(int *,int *,const int &,char *,int);
  void gtrigi_();
  void gtrig_();
  void hgkine_(); 
}

void hgevnt_() {

  if(arteflag_.geaninit <= 0) return;

  if(!ArteTable<EVHD>::booked() || !ArteTable<EVHD>::size()) 
                             mmbook_(ArtePointer<EVHD>::getLink().getRef(), 1);
  if(!ArteTable<MCIN>::booked()) 
                             mmbook_(ArtePointer<MCIN>::getLink().getRef(), 1);
  if(!ArteTable<MCME>::booked()) 
                             mmbook_(ArtePointer<MCME>::getLink().getRef(), 0);

// set version numbers   
  ArtePointer<MCIN> mcn(ArteTable<MCIN>::size()); 
  mcn->vgea = arteflag_.geanvers;
  mcn->vgeo = arteflag_.geomvers;

// set short/long detector configuration
  crlosh_(&mcn->fmcl[0],&mcn->fmcs[0]);

// set random number
  if(!mcn->rgea[0] || !mcn->rgea[1]) {
     alrini_();
     mcn->rgea[0] = arteflag_.lundseed[0];
     mcn->rgea[1] = arteflag_.lundseed[1];
  }
  grndmq_(&mcn->rgea[0],&mcn->rgea[1],1,"S",1);

// geant event initialization
   gtrigi_();

// fill geant banks kine and vert
   hgkine_();

// geant event processing
   gtrig_();

// really necessary ?
   if (gcstak_.njtmax < 0) gcstak_.njtmax = -gcstak_.njtmax;

   grndmq_(&mcn->rdig[0],&mcn->rdig[1],0,"G",1);
   float jx = float(gcflag_.ievent); 
   memcpy(gcbank_.iq + gclink_.jrung +28,&jx,4);

  if(gclink_.jstak) {
    jx = float(0);
    memcpy(gcbank_.iq + gclink_.jstak   ,&jx,4); 
    memcpy(gcbank_.iq + gclink_.jstak+2 ,&jx,4); 
  }

  if(gcflag_.ieorun) {
    arteMsg << "hgevnt: geant returns with error condition" ;
    arteMsg.error();
  }
}









