#ifndef _ZGVOL_HH_
#define _ZGVOL_HH_
#include "gean/zgeom.hh"
#include <vector.h>

  typedef struct {
    char  name  [4];
    int   type;
    int   imat;
    int   sens_flag;
    int   color;
    int   seen;
    char  shape[4];
    int   npar; 
    float dimension[11];
    int   ncomp, index_hgpos;
    int   index_hgdet;
    float rel_px,rel_py,rel_pz;
    char  long_name  [40];
    int   nuser;
    int   index_hguser;           
  } hgvol;

class zgvol : public zgeom {
public:

  friend class zgdet;
  friend class zgpos;
  friend class zgrot;
  friend class zguser;
 
  zgvol() {}
  ~zgvol() {} 
  
  void ini(int n);
  void fin();
 
  hgvol *volpointer(unsigned int i);  
  void  Read_vol(char*,int&);
  void  Read_shape(char*);
  void  Read_dimension(char*);
  void  Read_type(char*);  
  void  Read_sens_fl(char*);
  void  Read_material(char*);
  void  Read_rel_point(char*);
  void  Read_color(char*);
  void  Read_User(char *);
  void  Set_default();
  void  Copy_previous();
  int   RotateBox(int &);

  char* Get_volname(int &);
  char* Get_fullname(int &);
  int   Get_volnr(char *, int);
  char* Get_shape(int &) ;
  int   Get_dimension(int &,float *) ;
  int   Get_par(int &,float *) ;
  int   Get_type(int &) ;  
  int   Get_sens_flag(int &) ;
  int   Get_imat(int &) ;
  int   Get_imed(int &) ;
  void  Get_rel_point(int &, float*, float*, float*) ;
  int   Get_color(int &) ;
  int   Get_ncomp(int &);
  int   Get_nuser(int &);

  void  Create_Gvol(int); 
  int   Check_Gvol(char*);  

private:
  static  vector<hgvol>  *ptvol[33];
};


#endif
