        subroutine otrg10(xrot,yrot,z)
************************************************************************
*
* Declaration of G10 strips for an OTR chamber.
*
* Called from otrchm
*
* Arguments  in/out       Description
* xrot,yrot  in           X,Y rotated coordinates of chamber center
* z          in           Z  coordinates of chamber backplate
*
* Author: Alexander Lanyov     Aug 1999
*
************************************************************************
        implicit none

#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"
#include "gean/gclink.fi"
#include "gean/gcflag.fi"
#include "gean/gcnum.fi"
#include "gean/ZGMOTH.fi"
#include "gean/ZGBPIP.fi"
#include "gean/otrgeo.fi"
#include "gean/ZGDETV.fi"
#include "auto/GEO.fi"
#include "gean/ZGESL.fi"
#include "auto/CON.fi"

        integer il,idiv,iy,iy1,iy2,irg10
        real xrot,yrot,z,pit
        real par(10),xmin,xmax,zmin,xp,yp,zp,xp_,yp_
        character*4 matg10(2)
c functions
        integer lenocc

        data matg10/'WTGT','WTGM'/

#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/CON.ff"

c        pit = fnede_pit_l()
        pit = fnede_pit(nnede())


c------------------------------------- Install the dividing G10-strips
        if (istereo.le.0 .or. istereo.gt.maxstereo) then
           c78 = 'Illegal number of stereo layer ='
           call ch78bi(istereo)
           call meerro(c78)
        end if
        if (zstereo(iside,istereo).eq.0.) then
           c78 = 'Illegal zstereo('
           call ch78ai(iside)
           call ch78ac(',')
           call ch78ai(istereo)
           call ch78ac(') =')
           call ch78bf(zstereo(iside,istereo),-3)
           call meerro(c78)
        end if

        do il = 1,notlay(imod)          ! monolayers
           do idiv = 1,3                ! vertical divisions
              par(2) = 0.5 * dyg10
              par(3) = 0.5 * 0.01

              if (ttg10p(il,idiv,imod) .ne. 0.) then

                 if ((yrot + ttg10p(il,idiv,imod)) .gt. 0.) then
                    iy = 1
                 else
                    iy = 2
                 end if

                 if (ttcefi(il,iy,imod).eq.0.) then
                    c78 = 'For '//modtype(:lenocc(modtype))
                    call ch78ac(': ttcefi = 0. for il=')
                    call ch78ai(il)
                    call ch78ac(', iy=')
                    call ch78ai(iy)
                    call me78wa
                 end if

                 iy1 = iy
                 iy2 = iy
                 if (idiv.eq.2) then
                    iy1 = 1
                    iy2 = 2
                 end if

                 xmin = xrot + ttcefi(il,iy,imod) - pit/3.
                 xmax = xrot + ttcela(il,iy,imod) + pit/3.
                 do iy=iy1,iy2

                    xmin = min(xmin, xrot + ttcefi(il,iy,imod) - pit/3.)
                    xmax = max(xmax, xrot + ttcela(il,iy,imod) + pit/3.)
                 end do

                 par(1) = 0.5 * (xmax-xmin)

                 xp = 0.5 * (xmax + xmin)
                 yp = yrot + ttg10p(il,idiv,imod)

                 zmin = z + 0.5*il*otdiam(imod)
                 if (zstereo(iside,istereo).ne.0.)
     @              zmin = zstereo(iside,istereo)
     @                   - 0.01 / 0.25 * (zmin-zstereo(iside,istereo))

                 xp_ =  cosang * xp + sinang * yp - xp_sl
                 yp_ = -sinang * xp + cosang * yp - yp_sl
                 zp = zmin      - zp_sl

c                 if (fltmod(imod).eq.1) then
c                    irg10 = 0          ! div. G10 are along lab. x-axis
c                 else if (fltmod(imod).eq.2) then
                    irg10 = ir         ! div. G10 are along rot. x-axis
c                 else
c                    call meerro('Illegal fltmod')
c                 end if

                 call otrg10_store(matg10(imflag+1),nnwal()+1,slname,
     @                 xp_,yp_,zp,irg10,'ONLY',par,3)


              end if
           end do                       ! vertical divisions

c------------------------------------- Install e-beam G10-strips
           do idiv = 1,2                ! vertical divisions
              par(2) = 0.5 * dyg10
              par(3) = 0.5 * 0.01

              if (otbeam(il,idiv,imod) .ne. 0.) then

                 if ((yrot + otbeam(il,idiv,imod)) .gt. 0.) then
                    iy = 1
                 else
                    iy = 2
                 end if

                 if (ttcefi(il,iy,imod).eq.0.) then
                    c78 = 'For '//modtype(:lenocc(modtype))
                    call ch78ac(': ttcefi = 0. for il=')
                    call ch78ai(il)
                    call ch78ac(', iy=')
                    call ch78ai(iy)
                    call me78wa
                 end if

                 xmin = xrot + ttcefi(il,iy,imod) - pit/3.
                 xmax = xrot + ttcela(il,iy,imod) + pit/3.

                 par(1) = 0.5 * (xmax-xmin)

                 xp = 0.5 * (xmax + xmin)
                 yp = yrot + otbeam(il,idiv,imod)

                 zmin = z + 0.5*il*otdiam(imod)
                 if (zstereo(iside,istereo).ne.0.)
     @               zmin = zstereo(iside,istereo)
     @                     - 0.01 / 0.25 * (zmin-zstereo(iside,istereo))
                 xp_ =  cosang * xp + sinang * yp - xp_sl
                 yp_ = -sinang * xp + cosang * yp - yp_sl
                 zp = zmin      - zp_sl

                 irg10 = ir

                 call otrg10_store(matg10(imflag+1),nnwal()+1,slname,
     @                 xp_,yp_,zp,irg10,'ONLY',par,3)
c--------


              end if
           end do                       ! vertical divisions

c------------------------------------- Install the supporting G10-strips
           do idiv = 1,6                ! vertical divisions
              par(2) = 0.5 * 0.5   ! width of support strip = 5 mm
              par(3) = 0.5 * 0.01

              if (ttsupp(il,idiv,imod) .ne. 0.) then

                 if ((yrot + ttsupp(il,idiv,imod)) .gt. 0.) then
                    iy = 1
                 else
                    iy = 2
                 end if

                 if (ttcefi(il,iy,imod).eq.0.) then
                    c78 = 'For '//modtype(:lenocc(modtype))
                    call ch78ac(': ttcefi = 0. for il=')
                    call ch78ai(il)
                    call ch78ac(', iy=')
                    call ch78ai(iy)
                    call me78wa
                 end if

                 xmin = xrot + ttcefi(il,iy,imod) - pit/3.
                 xmax = xrot + ttcela(il,iy,imod) + pit/3.

                 par(1) = 0.5 * (xmax-xmin)

                 xp = 0.5 * (xmax + xmin)
                 yp = yrot + ttsupp(il,idiv,imod)

                 zmin = z + 0.5*il*otdiam(imod)
                 if (zstereo(iside,istereo).ne.0.)
     @               zmin = zstereo(iside,istereo)
     @                     - 0.01 / 0.25 * (zmin-zstereo(iside,istereo))
                 xp_ =  cosang * xp + sinang * yp - xp_sl
                 yp_ = -sinang * xp + cosang * yp - yp_sl
                 zp = zmin      - zp_sl

                 call otrg10_store(matg10(imflag+1),nnwal()+1,slname,
     @                 xp_,yp_,zp,ir,'ONLY',par,3)


              end if

           end do                       ! vertical divisions
        end do                          ! monolayers


        return
        end
c=======================================================================
        subroutine otrg10_store
     @       (mat,ndummy,sl,xp,yp,zp,irg10,only,par,npar)
************************************************************************
*
* Store declarations of G10 strips in arrays.
* Similar G10 strips will be grouped together and declared as one thick strip.
*
* Called from otrg10
*
* Arguments are the same as in gsposp
*
* Author: Alexander Lanyov     Aug 1999
*
************************************************************************
        implicit none

#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"
#include "gean/gclink.fi"
#include "gean/gcflag.fi"
#include "gean/gcnum.fi"
#include "gean/otrgeo.fi"
#include "gean/otrg10.fi"
#include "gean/ZGDETV.fi"
#include "auto/GEO.fi"
#include "gean/ZGESL.fi"
#include "auto/CON.fi"

        integer irg10,ndummy,npar,i
        real par(10),xp,yp,zp
        character*4 mat,only,sl,str*80

#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/CON.ff"

        if (declare_g10.ne.2) then
           call gsposp(mat,ndummy,sl,xp,yp,zp,irg10,only,par,3)
           call crgwal(mat,ndummy)
           return
        end if

        ng10s = ng10s+1

        do i=ng10,1,-1
           if (abs(xp     - xp_g10(i)) .lt. xp_cut
     @   .and. abs(yp     - yp_g10(i)) .lt. yp_cut
     @   .and. abs(zp     - zp_g10(i)) .lt. zp_cut
     @   .and. abs(par(1) - px_g10(i)) .lt. px_cut
     @   .and. abs(par(2) - py_g10(i)) .lt. py_cut
     @   .and. irg10 .eq. ir_g10(i)) goto 10
        end do

c--------------------------------- create new entry
        if (ng10.ge.maxg10) then
            call meerro('otrg10_store: Maximal No. G10 strips'//
     @       ' are stored for one superlayer')
            return
        end if

        ng10 = ng10 + 1
        i = ng10
        xp_g10(i) = xp
        yp_g10(i) = yp
        zp_g10(i) = zp

        px_g10(i) = par(1)
        py_g10(i) = par(2)
        pz_g10(i) = par(3)

        ir_g10(i) = irg10

        pz_max = max(pz_max,abs(par(3)))

        if (ng10.gt.1 .and. mat.ne.mat_g10) then
           write (str,*) 'Wrong material for OTR G10 strip mat = ',
     @        mat,', mat_g10 = ',mat_g10
           call meerro(str)
           return
        end if
        mat_g10 = mat
        return
        
c--------------------------------- update old entry
10      continue
        pz_g10(i) = pz_g10(i) + par(3)

        xp_max = max(xp_max,abs(xp-xp_g10(i)))
        yp_max = max(yp_max,abs(yp-yp_g10(i)))
        zp_max = max(zp_max,abs(zp-zp_g10(i)))

        px_max = max(px_max,abs(par(1)-px_g10(i)))
        py_max = max(py_max,abs(par(2)-py_g10(i)))
        pz_max = max(pz_max,pz_g10(i))

        return
        end

c=======================================================================
        subroutine otrg10_end
************************************************************************
*
* Use stored declarations of G10 strips in arrays to
* declared them as one thick strip.
*
* Called from otrgeo
*
* Author: Alexander Lanyov     Aug 1999
*
************************************************************************
        implicit none

#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"
#include "gean/gclink.fi"
#include "gean/gcflag.fi"
#include "gean/gcnum.fi"
#include "gean/ZGMOTH.fi"
#include "gean/ZGBPIP.fi"
#include "gean/otrgeo.fi"
#include "gean/otrg10.fi"
#include "gean/ZGDETV.fi"
#include "auto/GEO.fi"
#include "gean/ZGESL.fi"
#include "auto/CON.fi"

        integer irg10,i
        real par(10),xp,yp,zp
        character*4 mat

#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/CON.ff"

        write (*,*) ' '
        write (*,*) ' '
        write (*,*) 'otrg10_end is called for ',slname
        write (*,*) 'ng10 = ',ng10,' ng10s = ',ng10s,
     @     ', ratio =',real(ng10s)/real(ng10)
        write (*,*) ' '
        write (*,*) 'xp_max = ',xp_max
        write (*,*) 'yp_max = ',yp_max
        write (*,*) 'zp_max = ',zp_max
        write (*,*) ' '
        write (*,*) 'px_max = ',px_max
        write (*,*) 'py_max = ',py_max
        write (*,*) 'pz_max = ',pz_max

        if (ng10.le.0) call meerro('otrg10_end error')

        do i=1,ng10
           xp = xp_g10(i)
           yp = yp_g10(i)
           zp = zp_g10(i)
           
           par(1) = px_g10(i)
           par(2) = py_g10(i)
           par(3) = pz_g10(i)
           
           mat = mat_g10
           irg10 = ir_g10(i)

           call gsposp(mat,nnwal()+1,slname,xp,yp,zp,irg10,'ONLY',par,3)
           call crgwal(mat,nnwal()+1)
        end do

        ng10 = 0
        ng10s = 0

        return
        end

c=======================================================================
        subroutine otrg10_ini
************************************************************************
*
* Initialize the storing of declarations of G10 strips in arrays.
*
* Called from otrgeo
*
* Author: Alexander Lanyov     Aug 1999
*
************************************************************************
        implicit none

#include "gean/otrg10.fi"

        ng10 = 0
        ng10s = 0

        xp_max = 0.
        yp_max = 0.
        zp_max = 0.

        px_max = 0.
        py_max = 0.
        pz_max = 0.

        if (xp_cut.le.0.) xp_cut = 2.7
        if (yp_cut.le.0.) yp_cut = 0.5
        if (zp_cut.le.0.) zp_cut = 10.

        if (px_cut.le.0.) px_cut = 2.
        if (py_cut.le.0.) py_cut = 0.1

        return
        end
