
*-- Author : Valeri Saveliev, 15/04/97  00.12.05
C
C ************************************************************
C *       PROGRAM FOR DE/DX-SIMULATION WITHIN STRAWS         *
C ************************************************************
C
        SUBROUTINE TRSIDE
C
C... *** Simulation energy deposition within straw ***
C
#include "gean/gckine.fi"
#include "gean/gctrak.fi"
#include "gean/gcvolu.fi"
#include "gean/gccuts.fi"
C...
        COMMON /CLION/ NCLESTEP,CLESTEP(2,4000)
C...
        CHARACTER*4 CNAME
C...
        CALL UHTOC(NAMES(NLEVEL),4,CNAME,4)
        IF(ISTOP      .NE.0 .OR.STEP         .LE.0.    ) RETURN
        IF(ABS(CHARGE).NE.1.)                            RETURN
        IF(CNAME.NE.'TRTU')                              RETURN
C...
        GETOT   = GETOT+DESTEP
        GEKIN   = GEKIN+DESTEP
        GAMMA   = GETOT/AMASS
C...
        DE      = DERAND(GAMMA,DCUTE,STEP)
        IF(GEKIN-DE.GT.CUTELE) GO TO 1
C
C...Stop particle
C
        NCLESTEP = 0
        ISTOP   = 2
        DESTEP  = GEKIN
        DESTEL  = DESTEP
        GEKIN   = 0.
        GETOT   = AMASS
        VECT(7) = 0.
        CALL GEKBIN
        RETURN
C...
1       GEKIN   = GEKIN-DE
        GETOT   = GETOT-DE
        DESTEP  = DE
        DESTEL  = DESTEP
        VECT(7) = SQRT(GEKIN*(GEKIN+2.*AMASS))
C
        CALL GEKBIN
        RETURN
        E N D

*-- Author :Valeri Saveliev, 15/08/94  09.46.59 
C------------------------------------------------------------
        REAL FUNCTION D E R A N D (GAMMA,ECUT,STEP)
C
C... ***  Simulation of energy loss straggling within straw
C         with energy smaler then ECUT ***
C
        COMMON /DNDE  / NWE,WE(200),ANL(200,21),GAME(21)
        COMMON /CLION / NCLESTEP,CLESTEP(2,4000)
C
C NCLESTEP     - Total number clusters,
C CLESTEP(1,#) - energy of the # cluster,
C CLESTEP(2,#) - coordinate of the # cluster.
C
        DIMENSION ANGL(200),RNDM(2)
C...
        NCLESTEP = 0
        EC       = 1.E9*ECUT
        DERAND   = 0.
        IF(STEP.LE.0.) RETURN
C...
        GAML     = ALOG(GAMMA)
        IF(GAML.GE.GAME(21)) THEN
        CALL UCOPY(ANL(1,21),ANGL,NWE)
        GO TO 4
        END IF
C...
        DO 1 I  = 1,21
        IF(GAML.LE.GAME(I)) GO TO 2
1         CONTINUE
2       I       = MIN(21,MAX(I,2))
        DGG     = (GAML-GAME(I-1))/(GAME(I)-GAME(I-1))
C...
        DO 3 K  = 1,NWE
        ANGL(K) = ANL(K,I-1)+(ANL(K,I)-ANL(K,I-1))*DGG
3         CONTINUE
C...
4       ANMIN   = EXP(ANGL(NWE))
        ANMAX   = EXP(ANGL( 1 ))
C...
        DAN     = ANMAX-ANMIN
        AMU     = DAN*STEP
        CALL GPOISS(AMU,N,1)
        IF(N.LE.0.) RETURN
        DO 8 I  = 1,N
        K1      = 1
        K2      = NWE
        CALL GRNDM(RNDM,2)
        R       = ALOG(RNDM(1)*DAN+ANMIN)
6       K       = (K1+K2)/2
        IF(R.NE.ANGL(K)) GO TO 7
        EE      = EXP(WE(K))
        DERAND  = DERAND+EE
        GO TO 8
7       IF(R.GT.ANGL(K)) K2 = K
        IF(R.LT.ANGL(K)) K1 = K
        IF(K2-K1.GT.1  ) GO TO 6
C...
        E       = WE(K2)+(R-ANGL(K2))*(WE  (K1)-WE  (K2))/
     +                                (ANGL(K1)-ANGL(K2))
        EE      = EXP(E)
        IF(EE.GT.EC) GO TO 8
C
C..fill clusters bank
C
        NCLESTEP = MIN(4000,NCLESTEP+1)
        CLESTEP(1,NCLESTEP) = EE*1.E-9
        CLESTEP(2,NCLESTEP) = STEP*RNDM(2)
C
C...Total energy calculation
C
        DERAND  = DERAND+EE
8       CONTINUE
C...
        DERAND  = DERAND*1.E-9
        RETURN
        E N D

*-- Author : Valeri Saveliev, 27/03/94  12.17.14
C---------------------------------------------------------
        REAL FUNCTION S I M N O I S (E)
C
C... *** Electronic noise simulation ***
C
        DATA FWHM/.27/
C
C...Space charge effect simulation
C
        EE      = E*1.E6
        SIMNOIS = SPACECHAR(EE)
C...
        IF(FWHM.LE.0.) GO TO 1
        CALL GRANOR(R1,R2)
        SIMNOIS = SIMNOIS+R1*FWHM/2.35*SQRT(6.*SIMNOIS)
1       SIMNOIS = SIMNOIS*1.E-6
        RETURN
        E N D

*-- Author :  Valeri Saveliev,  27/03/94  12.17.14
C--------------------------------------------------------
        REAL FUNCTION S P A C E C H A R (E)
C
C... *** Space charge effect simulation (Sosnovcev gas gain
C        for mixture 50%Xe+25%CO2+25%CF4 ***
C
        SPACECHAR = E
        IF(E.LE.2.) RETURN
        SPACECHAR = AMAX1(.2*E,E*(1.0314-.0157*E))
        RETURN
        E N D
