/************************************************************************
* ITRSTEER
*
* called from  KUIP
***********************************************************************/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>

#define __ITR_STEER_C__
#include "ITR_steer.h"


extern "C" void kugeti_( int* );
extern "C" void kugetr_( float* );

extern "C" void itrhitr_() {
  float number = 0.01; 
  kugetr_( &number);
  ITR_HITRES=number;  
}  

extern "C" void itrsteer_() {
  int number = -999;
  kugeti_( &number);
  ITR_STEERDB_MAJ=number;
  kugeti_( &number);
  ITR_STEERDB_MIN=number;
} 

extern "C" void itrcluster_() {
  int number = 1;
  float thresh = 3.;
  kugeti_( &number);
  if (number==1 || number==2 || number==3)
    ITR_CLUSTER_ALG=number;
  kugetr_( &thresh);
  if (ITR_CLUSTER_ALG==1 || ITR_CLUSTER_ALG==2 || ITR_CLUSTER_ALG==3)
    ITR_THRESHOLD_A=thresh;
  thresh = 5.;
  kugetr_( &thresh);
  if (ITR_CLUSTER_ALG==1 || ITR_CLUSTER_ALG==2 || ITR_CLUSTER_ALG==3)
    ITR_THRESHOLD_B=thresh;    
} 

extern "C" void itrdyn_() {

  int number = 0;
  kugeti_( &number);
  ITR_DYNTHRESH=number;
} 

extern "C" void itrnevtmon_() {

  int number = 200;
  kugeti_( &number);
  ITR_NEVT_MON=number;
} 

extern "C" void itrnoise_() {
  float number = 9.;
  kugetr_( &number);
  ITR_HOTCUT=number;
  number = 25.;
  kugetr_( &number);
  ITR_MAXSIGNAL=number;
}

extern "C" void itroffset_() {
   int number = 0;
   kugeti_( &number);
   ITR_OFFS_1=number;
   number = 0;
   kugeti_( &number);
   ITR_OFFS_2=number;
   number = 0;
   kugeti_( &number);
   ITR_OFFS_3=number;
   number = 0;
   kugeti_( &number);
   ITR_OFFS_4=number;
   number = 0;
   kugeti_( &number);
   ITR_OFFS_5=number;
   number = 0;
   kugeti_( &number);
   ITR_OFFS_6=number;
   number = 0;
   kugeti_( &number);
   ITR_OFFS_7=number;
   number = 0;
   kugeti_( &number);
   ITR_OFFS_8=number;
   number = 0;
   kugeti_( &number);
   ITR_OFFS_9=number;
   number = 0;
   kugeti_( &number);
   ITR_OFFS_10=number;
}

extern "C" void itrdbvers_() {
  int maj = 8, min = 2;
  
  kugeti_ (&maj);
  kugeti_ (&min);

  ITR_DBVERS_MAJ = maj;
  ITR_DBVERS_MIN = min;
}

extern "C" void itralvers_() {
  int maj = 8, min = 2;
  
  kugeti_ (&maj);
  kugeti_ (&min);

  ITR_ALIGN_MAJ = maj;
  ITR_ALIGN_MIN = min;
}

extern "C" void itrmovers_() {
  int maj = 8, min = 2;
  
  kugeti_ (&maj);
  kugeti_ (&min);

  ITR_MONITOR_MAJ = maj;
  ITR_MONITOR_MIN = min;
}

extern "C" void itrhcut_() {
  float number = 99.;
  kugetr_( &number);
  ITR_HCUT=number;
}

extern "C" void itrmask_() {
  int number = 0;
  kugeti_( &number);
  ITR_MASK=number;
}
