*-- Author : Ulrich Husemann - September 26, 2001

      SUBROUTINE KAFRIT

************************************************************************
*
* Description: KUIP command /GENERATOR/REWEIGHT chooses between different
*              reweighting models for heavy flavour production
*
* Called from: KUIP 
*
* External references:
*
* Argument in/out description
*
************************************************************************

      IMPLICIT NONE

      INTEGER MES_ID1

      INTEGER MODE,NTRACKS,NGLUONS,NSTRINGS,NCOLL
      REAL IMPACT,EREST
      COMMON/FRMULT/MODE,NTRACKS,NGLUONS,NSTRINGS,NCOLL,IMPACT,EREST
      SAVE/FRMULT/  

      CALL KUGETI(MODE)
      
      IF (MODE.LE.0) THEN
         CALL MEPRIC(MES_ID1, 10,
     +        'Multiplicity tuning disabled.')
         MODE = 0
      ELSEIF (MODE.EQ.1) THEN
         CALL MEPRIC(MES_ID1, 10,
     +        'Multiplicity tuning with N/A.')
      ELSEIF (MODE.EQ.2) THEN
         CALL MEPRIC(MES_ID1, 10,
     +        'Multiplicity tuning with (N/A)**2.')
      ELSEIF (MODE.EQ.3) THEN
         CALL MEPRIC(MES_ID1, 10,
     +        'Multiplicity tuning with accepted charged tracks.')
      ELSEIF (MODE.EQ.4) THEN
         CALL MEPRIC(MES_ID1, 10,
     +        'Multiplicity tuning with number of gluons.')
      ELSEIF (MODE.GE.5) THEN
         CALL MEPRIC(MES_ID1, 10,
     +        'Multiplicity tuning: invalid mode, disabled.')
         MODE = 0
      ENDIF

      END

************************************************************************
* End of KAFRIT
************************************************************************
