*CMZ :  1.00/00 27/10/94  18.35.27  by  Dominik Ressing
*CMZ :  0.01/02 16/08/94  18.03.39  by  Dominik Ressing
*CMZ :  0.01/01 24/07/94  16.21.26  by  Dominik Ressing
*-- Author :    Dominik Ressing   22/07/94
************************************************************************
*
* L1ALLIN
* written by Dominik Ressing, 22/07/94 17.37.38
*
* This routines action:
* Initializes the complete package !!! should be the first call to any L1 routine !!
*
* Arguments   kind         description
*          (in,update,out)
*-----------------------------------------------------------------------
* InitialTime  in          initial time (in ns)
* ierr         update      set to nonzero on error (else preserved)
*
************************************************************************
c
      SUBROUTINE L1ALLIN(InitialTime,ierr)
c
      IMPLICIT NONE
c
#include "l1si/l1param.fi"
#include "l1si/l1runpa.fi"
c
      INTEGER InitialTime,ierr
c
c     --- read parameter definitions & geometry
      CALL l1defpc(ierr)
c
c     --- set run parameters
      L1RUNcutime = InitialTime  ! set current time
      L1RUNcuBX   = 0            ! no Bunch Crossing loaded
      L1RUNnextBX = InitialTime  ! time of next BunchCrossing
c
c     --- initialize the job queue
      CALL l1jobin
c     --- initialize the message chains
      CALL l1mesin
c     --- initialize the processor connections
      CALL l1prcin(InitialTime)
c     --- initialize and check the processor connections
      CALL l1conck
c     --- initialize the TFU to detector connections
      CALL l1tfuin(ierr)
c     --- call user initialization
      CALL l1usrin(InitialTime)
c
      RETURN
c
      END
