*CMZ :  1.00/00 03/01/95  11.05.31  by  Dominik Ressing
*CMZ :  0.01/02 26/08/94  17.24.27  by  Dominik Ressing
*CMZ :  0.01/01 25/07/94  15.27.35  by  Dominik Ressing
*-- Author :    Dominik Ressing   20/07/94
************************************************************************************
*
* L1MESNE
* written by Dominik Ressing, 20/07/94 17.37.58
*
* This routines action:
* Inserts a new message from the free to the used chain and returns its pointer
* The BX trace pointers L1MEbx are maintained.
*
* Variables   kind         description
*          (in,update,out)
*-----------------------------------------------------------------------------------
* iBX         in           BX of new message
* Lmess       out          pointer to message ( <=0 on error)
*
************************************************************************************
c
      SUBROUTINE L1MESNE(iBX,Lmess)
c
      IMPLICIT NONE
#include "l1si/l1param.fi"
#include "l1si/l1geodf.fi"
#include "l1si/l1mesdf.fi"
c
      INTEGER Lmess,iBX,nBX,nAct,iBXpo
c
      Lmess = L1MEstor(L1MEfree+L1MEnext)
c     --- if no more free messages return with error Lmess <= 0
      IF ( Lmess.le.0 ) THEN
            WRITE(L1LUNprn,*)
     &        'L1MESNE ==> Message memory exhausted'
       return
      ENDIF
c
      CALL l1mesdi(Lmess)
c
      nBX   = L1MEbx(L1MEBXn,iBX)
      iBXpo = L1MEbx(L1MEBXfipo,iBX)      ! previous first message for BX
      nAct  = L1MEbx(L1MEBXnact,iBX)
      IF ( iBXpo.eq.0 ) THEN
         iBXpo = L1MEused                 ! insert message at top of used chain
         IF ( nBX.ne.0 .or. nAct.ne.0 ) THEN
            WRITE(L1LUNprn,*)
     &        'L1MESNE ==> invalid message/BX count',
     &        nBX,nAct,iBXpo
            nBX  = 0
            nAct = 0
         END IF
         L1MEbx(L1MEBXfipo,iBX) = Lmess  ! first message for BX
      END IF
c
c     --- clear message contents (keep header):
      CALL VZERO(L1MEstor(Lmess),L1MElen-L1MEhead)
c
      CALL l1mesco(Lmess,iBXpo)          ! insert message behind iBXpo
c
c     --- maintain BX-trace counters
      L1MEbx(L1MEBXn,iBX)    = nBX + 1
      L1MEbx(L1MEBXnact,iBX) = nAct + 1
      L1MEstor(Lmess+L1MEprbx) = iBX     ! write BX into message structure
      L1MEstor(Lmess+L1HAprbx) = iBX     ! write BX into message structure
      L1MEstor(Lmess+L1MEactive) = L1MEacNEW   ! this message is indeed new+active
c
      RETURN
c
      END
