
// Boris Fominykh  6.05.2002
// member functions of class MuDbAlignNew

#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include <fstream.h>
#include <iostream.h>
#include <iomanip.h>

#include "arte/arte.hh"
#include "arte/ArteMessage.hh"

#include "murec/MuDbAlignNew.h"

//** Constructor */
MuDbAlignNew::MuDbAlignNew()
  :  MuDbTable::MuDbTable()
{
}

//** Destructor */
MuDbAlignNew::~MuDbAlignNew()
{
  Clear();
}

//## Methods

//** Initialization */
void MuDbAlignNew::Ini()
{
  MuDbTable::setDBname("/MUON_NEW");
  if(ArteTable<MTRA>::size() <= 0) MuDbTable::setName("MuonAlign");
  else                             MuDbTable::setName("MuonAlignMC");
  MuDbTable::setDesc("UB:type UB:msl UB:lay UB:ud UB:nx1 UB:nx2 F:dx F:dy F:dz F:xc F:yc F:angl");
  MuDbTable::setTitle("Muon Alignment Constants");

  Valid = -1;
  for(int sl=0; sl<SlM; sl++)
  {
    for(int lay=0; lay<LayM; lay++)
    {
      for(int ud=0; ud<UdM; ud++)
      {
        Ncont[sl][lay][ud] = 0;
      }  
    }  
  }  
  return;
}

void MuDbAlignNew::Clear()
{
  Valid = -1;
  for(int sl=0; sl<SlM; sl++)
  {
    for(int lay=0; lay<LayM; lay++)
    {
      for(int ud=0; ud<UdM; ud++)
      {
        if(Ncont[sl][lay][ud] > 0) Cont[sl][lay][ud].clear();
        Ncont[sl][lay][ud] = 0;
      }  
    }  
  }  
  return;
}


//** Read the table as it's defined in kumac*/
int MuDbAlignNew::Read()
{
  int ret = 0;

  if(getenv("MUON_ALIGN") != NULL) {
// read the table from the file
    MuDbTable::setFile(getenv("MUON_ALIGN"));
    ret=MuDbAlignNew::ReadFile();
  }

  else ret=MuDbAlignNew::ReadDB();

  MuDbAlignNew::Print();

  return ret;
}

 
//** Read the table from DB*/
int MuDbAlignNew::ReadDB()
{
  int ret=0;
  int nel=0;

// open
  ret=MuDbTable::Open(0);
  // cout << "MuDbAlignNew::ReadDB: " << DBtable << " is open, ret= " << ret << endl;
  if(ret > 0) return ret;
 
// fetch the table
  ret=MuDbTable::Fetch();
  // cout << "MuDbAlignNew::ReadDB: " << DBtable << " is fetched, ret= " << ret << endl;
  if(ret != 0)
  {
    MuDbTable::Close();
    return ret;
  }

// read the table fields 
  char* type  = new char[Size];
  char* msl   = new char[Size];
  char* lay   = new char[Size];
  char* ud    = new char[Size];
  char* nx1   = new char[Size];
  char* nx2   = new char[Size];
  float* dx   = new float[Size];
  float* dy   = new float[Size];
  float* dz   = new float[Size];
  float* xc   = new float[Size];
  float* yc   = new float[Size];
  float* angl = new float[Size];

  MuAlignNew con;

  ret=31;
  Nf=SkipTableField(X,1);
  nel = GetTableField(X,TABLEubyte,Size,type);
  // cout << "MuDbAlignNew::ReadDB: field 1 is read, nel= " << nel << endl;
  if(nel <= 0) goto labelexit;

  Nf=SkipTableField(X,2);
  nel = GetTableField(X,TABLEubyte,Size,msl);
  // cout << "MuDbAlignNew::ReadDB: field 2 is read, nel= " << nel << endl;
  if(nel <= 0) goto labelexit;

  Nf=SkipTableField(X,3);
  nel = GetTableField(X,TABLEubyte,Size,lay);
  // cout << "MuDbAlignNew::ReadDB: field 3 is read, nel= " << nel << endl;
  if(nel <= 0) goto labelexit;

  Nf=SkipTableField(X,4);
  nel = GetTableField(X,TABLEubyte,Size,ud);
  // cout << "MuDbAlignNew::ReadDB: field 4 is read, nel= " << nel << endl;
  if(nel <= 0) goto labelexit;

  Nf=SkipTableField(X,5);
  nel = GetTableField(X,TABLEubyte,Size,nx1);
  // cout << "MuDbAlignNew::ReadDB: field 5 is read, nel= " << nel << endl;
  if(nel <= 0) goto labelexit;

  Nf=SkipTableField(X,6);
  nel = GetTableField(X,TABLEubyte,Size,nx2);
  // cout << "MuDbAlignNew::ReadDB: field 6 is read, nel= " << nel << endl;
  if(nel <= 0) goto labelexit;

  Nf=SkipTableField(X,7);
  nel = GetTableField(X,TABLEfloat,Size,dx);
  // cout << "MuDbAlignNew::ReadDB: field 7 is read, nel= " << nel << endl;
  if(nel <= 0) goto labelexit;

  Nf=SkipTableField(X,8);
  nel = GetTableField(X,TABLEfloat,Size,dy);
  // cout << "MuDbAlignNew::ReadDB: field 8 is read, nel= " << nel << endl;
  if(nel <= 0) goto labelexit;

  Nf=SkipTableField(X,9);
  nel = GetTableField(X,TABLEfloat,Size,dz);
  // cout << "MuDbAlignNew::ReadDB: field 9 is read, nel= " << nel << endl;
  if(nel <= 0) goto labelexit;

  Nf=SkipTableField(X,10);
  nel = GetTableField(X,TABLEfloat,Size,xc);
  // cout << "MuDbAlignNew::ReadDB: field 10 is read, nel= " << nel << endl;
  if(nel <= 0) goto labelexit;

  Nf=SkipTableField(X,11);
  nel = GetTableField(X,TABLEfloat,Size,yc);
  // cout << "MuDbAlignNew::ReadDB: field 11 is read, nel= " << nel << endl;
  if(nel <= 0) goto labelexit;

  Nf=SkipTableField(X,12);
  nel = GetTableField(X,TABLEfloat,Size,angl);
  // cout << "MuDbAlignNew::ReadDB: field 12 is read, nel= " << nel << endl;
  if(nel <= 0) goto labelexit;

  // cout << "MuDbAlignNew::ReadDB: table is read, Size= " << Size << endl; 

// fill set of containers
  for(int i=0; i<Size; i++)
  {
    if(*(msl+i) > 0 && *(msl+i) < 5 && 
       *(lay+i) > 0 && *(lay+i) < 5 && *(ud+i) < 2)
    {
      con.IDnum = i;  
      con.type  = *(type+i);  // tube=1, pad=3, pix=4  
      con.sl    = *(msl+i);  
      con.ud    = *(ud+i);  

      int l =0;
      int u =0;
      int n1=0;
      int n2=0;
// tube & pad chambers
      if(*(type+i) < 4)
      {
        l  = *(lay+i);
        u  = *(ud+i);
        n1 = *(nx1+i);  
        n2 = *(nx2+i);  
      }

// pixel chambers
      else
      {
        l  = 4;
        u  = 0;
        n1 = *(lay+i);
        n2 = n1;
      }

      con.lay   = l;
      con.nx1   = n1;
      con.nx2   = n2;

      con.dx    = *(dx+i);  
      con.dy    = *(dy+i);  
      con.dz    = *(dz+i);  
      con.xc    = *(xc+i);  
      con.yc    = *(yc+i);  
      con.angl  = *(angl+i);
      con.Valid = 1;

      // con.Print();

      Cont[msl[i]-1][l-1][u].insert(con);
      Ncont[msl[i]-1][l-1][u] += 1;
    }
  }

  Valid = 1;
  ret = 0;
  arteMsg << "Muon alignment initialized from " << DBname << " major " << Major << " minor " << Minor;
  arteMsg.warn();

labelexit:
  delete []type;
  delete []msl;
  delete []lay;
  delete []ud;
  delete []nx1;
  delete []nx2;
  delete []dx;
  delete []dy;
  delete []dz;
  delete []xc;
  delete []yc;
  delete []angl;

// close DB;
  MuDbTable::Close();

  return ret;
}


//** Read the table from ASCII file*/
int MuDbAlignNew::ReadFile()
{
  FILE *hl = fopen(FileName, "r");
  if(!hl) 
  {
    arteMsg << "MuDbAlignNew::ReadFile - no input File" << endl;
    arteMsg.error();
    return 1;
  }

  char numb[11] = "0123456789";
  MuAlignNew A;
  int count=0;

// loops over lines: max 1000 lines
  int nline=0;
  char line[121];
  for(int il=0; il<5000; il++) 
  {
// read the line
    if(fgets(line,sizeof(line),hl) == NULL) 
    {
      fclose(hl);
      goto goodexit;

      // if(feof(hl)) goto goodexit;
      // else 
      // { 
      //   arteMsg << "MuDbAlignNew:::ReadFile -  error of file read";
      //   arteMsg.warn();
      //  return 2;
      // }
    }
    ++nline;

    // cout << nline << "  " << line << endl;

    char word[121];
    int nx1  = 0;
    int nx2  = 0;
    float dx  =0.;
    float dy  =0.;
    float dz  =0.;
    float xc  =0.;
    float yc  =0.;
    float angl=0.;

// decord the line
    int nitem=sscanf(line,"%s nx %d %d dx %f dy %f dz %f xc %f yc %f angl %f",
            word,&nx1,&nx2,&dx,&dy,&dz,&xc,&yc,&angl);

// pass  commented cards
    if(word[0]=='#' || word[0]=='*' || word[0]=='/') continue;

// end of file
    if(!strcmp(word,"END")) 
    {
      fclose(hl);
      goto goodexit;
    }

// pass  blank lines
    if(nitem != 9) continue;

// control 'M' and '.' in the first word
    if(word[0] == 'M' && word[3] == '.') 
    {
      // cout << nline << " " << count << "  "; 
      // cout << word << "  nx1 " << nx1 << " nx2 " << nx2;
      // cout << " dx " << dx << " dy " << dy << " dz " << dz;
      // cout << " xc " << xc << " yc " << yc << " angl " << angl << endl;

      A.Ini();

      int type = 0;
      int msl  = 0;
      int lay  = 0;
      int ud   = 0;
      int udi  = 0;

// decode type
      if(word[1] == 't') type=1;
      if(word[1] == 'p') type=3;
      if(word[1] == 'x') type=4;

      if(type > 0 && type < 5)
      {
// decode msl
        for(int i=0; i<10; i++) 
        {
          if(word[2] == numb[i])
          {
            msl = i;
            break;
          }
        }

        if(msl > 0 && msl < 5)
        {
// decode lay and ud
          int xxx =0;
          for(int i=0; i<10; i++) 
          {
            if(word[4] == numb[i])
            {
              xxx = i;
              break;
            }
          }

// interpretation of word[4]
// tube chambers
          if(msl < 3 && type == 1)
          {
            lay = (xxx+1)/2;
            ud  = xxx - (lay-1)*2 - 1;
            udi = ud;
          }      
// pad chambers
          if(msl > 2 && type == 3)
          {
            lay = 1;
            ud  = xxx - 1;
            udi = ud;
          }      
// pixel chambers
          if(type == 4)
          {
            lay = 4;
            nx1 = xxx;
            nx2 = nx1;
            if(nx1 == 1 || nx1 == 3) ud=0;
            else ud = 1;
            udi = 0;
          }      

	  // cout << " msl " << msl << " lay " << lay << " ud " << ud;
          // cout << " udi " << udi << " nx1 " << nx1 << " nx2 " << nx2 << endl;

// fill container
          A.IDnum = count;
          count += 1; 
          A.type = type;
          A.sl   = msl;
          A.lay  = lay;
          A.ud   = ud;
          A.nx1  = nx1;
          A.nx2  = nx2;
          A.dx   = dx;
          A.dy   = dy;
          A.dz   = dz;
          A.xc   = xc;
          A.yc   = yc;
          A.angl = angl;
          A.Valid = 1;

          // A.Print();

          Cont[msl-1][lay-1][udi].insert(A);
          Ncont[msl-1][lay-1][udi] += 1;
        } 
      } 
    } 
  } 
goodexit:
  if(count > 0) 
  {
    Valid = 1;

    arteMsg << "Muon alignment initialized from file: ";
    // arteMsg << FileName;
    arteMsg.warn();
    // cout << FileName << endl;

    return 0;
  }
  else return 3;
}


//** Print the alignment constants */
void MuDbAlignNew::Print()
{
// check print control in kumac
  if(getenv("MUON_ALIGN_PRINT") == NULL) return;
  if(strcmp(getenv("MUON_ALIGN_PRINT"),"YES")) return;

  ofstream fout("MuAlignNew.out");
  if (!fout) 
  {
    arteMsg << "MuDbAlignNew::Print - can not open file MuAlignNew.out";
    arteMsg.warn();
    return;
  }

  fout << "  " << endl;
  fout << "DataBase: " << DBname << " Table: " << DBtable;
  fout << " Title: <" << Title << ">" << endl;
  fout << "Desc: <" << Desc << ">" << endl;
  fout << "Size= " << Size;
  fout << " Major " << Major << " Minor " << Minor << endl;

// loops over sl, lay, ud, 
  for(int sl=0; sl<SlM; sl++)
  { 
    for(int lay=0; lay<LayM; lay++)
    { 
      for(int ud=0; ud<UdM; ud++)
      { 
        fout << " " << endl;
        fout << " Sl " << sl+1 << " Lay " << lay+1 << " Ud " << ud;
        fout << " #containers " << Ncont[sl][lay][ud] << endl;
        if(Ncont[sl][lay][ud] > 0)
	{
          int count =0;
          set<MuAlignNew>::iterator c1 = Cont[sl][lay][ud].begin();
          set<MuAlignNew>::iterator c2 = Cont[sl][lay][ud].end();
          for(set<MuAlignNew>::iterator i=c1; i != c2; i++)
	  {
            count += 1;
            fout << "  " << count << "  IDnum " << (*i).IDnum << " sl " << (*i).sl;
            fout << " lay " << (*i).lay << " ud " << (*i).ud << " nx1 " << (*i).nx1;
            fout << " nx2 " << (*i).nx2 << " type " << (*i).type;
            fout << " Valid " << (*i).Valid << endl;
            fout << "    dx " << (*i).dx << " dy " << (*i).dy << " dz " << (*i).dz;
            fout << " xc " << (*i).xc << " yc " << (*i).yc << " angl " << (*i).angl;
            fout << endl;
            fout << " " << endl;
          }
        }
      }
    }
  }
  return;
}


// Get the alignment constants of one frame from temporary space*/
const MuAlignNew* MuDbAlignNew::GetPar(int id[4])
{
  int sl  = id[0];
  int lay = id[1];
  int ud  = id[2];
  int nx  = id[3];
  if (sl<1 || sl >SlM || lay<1 || lay>LayM || ud<0 || ud>UdM) 
  {
    arteMsg << "MuDbAlignNew::GetPar - wrong sl " << sl << " lay " << lay << " ud " << ud;
    arteMsg.warn();
    return NULL;
  }
  if(Ncont[sl-1][lay-1][ud] > 0)
  {
    set<MuAlignNew>::iterator c1 = Cont[sl-1][lay-1][ud].begin();
    set<MuAlignNew>::iterator c2 = Cont[sl-1][lay-1][ud].end();
    for(set<MuAlignNew>::iterator i=c1; i != c2; i++)
    {
      if(nx >= (*i).nx1 && nx <= (*i).nx2) return &(*i);
    }
  }
  arteMsg << "MuDbAlignNew::GetPar - NO param for sl " << sl << " lay " << lay << " ud " << ud << " nx " << nx;
  arteMsg.warn();
  return NULL;
}



