
// Boris Fominykh  15.12.1999
// updated 6.05.2002  by B.Fominykh - /MUON_NEW instead of /MUON_DB
// updated 21.05.2002 by B.Fominykh - table MuonMaskMC for MC 
// member functions of class MuDbHots

#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include <fstream.h>
#include <iostream.h>
#include <iomanip.h>

#include "arte/arte.hh"
#include "arte/ArteMessage.hh"

#include "murec/MuDbHots.h"

//** Constructor */
MuDbHots::MuDbHots()
  :  MuDbTable::MuDbTable()
{
}

//** Destructor */
MuDbHots::~MuDbHots()
{
  MuDbHots::Release();
}

//## Methods

//** Initialization */
void MuDbHots::Ini()
{
  SizeMem=0;
  SizeS =0;
  SizeW =0;

// data base /MUON_DB
  if(MuDbTable::OldOrNew == 0)
  {
    strncpy(DBtable,"MuonHots",9);
    strncpy(Desc,"A:cablename US:status",22);
    strncpy(Title,"Muon Hot Channels",18);
  }

// data base /MUON_NEW
  if(MuDbTable::OldOrNew == 1)
  {
//  MC
    if(ArteTable<MTRA>::size() > 0)
    {
      strncpy(DBtable,"MuonMaskMC",11);
      strncpy(Title,"Muon Mask MC",13);
    }
// real data
    else
    {
      strncpy(DBtable,"MuonMask",9);
      strncpy(Title,"Muon Mask",10);
    }
    strncpy(Desc,"A:cablename US:mask US:deadhot US:muonmpre",43);
  }
}
 
//** Read the table into the booked temporary space*/
int MuDbHots::Read()
{

  int ret;
// read the table from the file
  if(KTstatus == -3)
  {
    MuDbTable::setFile(getenv("MUON_HOTS"));
    ret=MuDbHots::ReadFile();
    return ret;
  }

// open DB
  ret=MuDbTable::Open(0);
  if(ret > 0) return ret;
// fetch the table
  ret=MuDbTable::Fetch();
  if(ret > 0) return ret;
  SizeMem=Size+50;
  SizeS=Size;

// book the space
  Name = new char[10*SizeMem];
  if(Name == NULL) return 2;
  Stts = new Word[SizeMem];
  if(Stts == NULL)
  {
    delete []Name;
    return 3;
  }

// book the space for additional fields in /MUON_NEW
  DHst = new Word[SizeMem];
  if(DHst == NULL)
  {
    delete []Name;
    delete []Stts;
    return 4;
  }
  MPst = new Word[SizeMem];
  if(MPst == NULL)
  {
    delete []Name;
    delete []Stts;
    delete []DHst;
    return 5;
  }

// read the table from DB
  Nf=SkipTableField(X,1);
  int nel = GetTableField(X,TABLEascii,10*SizeMem,Name);
  if(nel <= 0) return 6;

  Nf=SkipTableField(X,2);
  nel = GetTableField(X,TABLEushort,SizeMem,Stts);
  if(nel <= 0) return 7;

// read the additional fields from /MUON_NEW
  if(MuDbTable::OldOrNew == 1)
  {
    Nf=SkipTableField(X,3);
    nel = GetTableField(X,TABLEushort,SizeMem,DHst);
    if(nel <= 0) return 8;

    Nf=SkipTableField(X,4);
    nel = GetTableField(X,TABLEushort,SizeMem,MPst);
    if(nel <= 0) return 9;
  }

// close DB;
  MuDbTable::Close();
  MuDbHots::Print();
  return 0;
}

//** Release the temporary space*/
void MuDbHots::Release()
{
  if(SizeMem > 0) 
  {
    delete []Name;
    delete []Stts;
    delete []DHst;
    delete []MPst;

    SizeMem=0;
    SizeS  =0;
  }
  return;
}

//** Print the table */
void MuDbHots::Print()
{
// check print control in kumac
  if(getenv("MUON_HOTS_PRINT") == NULL) return;
  if(strcmp(getenv("MUON_HOTS_PRINT"),"YES")) return;

  if(SizeMem < 1)
  {
    arteMsg << "MuDbHots::Print - table in not read" << endl;
    arteMsg.warn();
    return;
  }

  ofstream fout("MuHotDump.out");
  if (!fout) 
  {
    arteMsg << "MuDbHots::Print - can not open file MuHotDump.out";
    arteMsg << endl;
    arteMsg.warn();
    return;
  }

  //  cout << "print table MuonHots into file MuHotDump.out" << endl;
  //  cout << "DataBase: " << DBname << " Table: " << DBtable;
  //  cout << " Title: <" << Title << "> " << endl;
  //  cout << " Desc: <" << Desc << "> Size= " << SizeS;
  //  cout << " Major " << Major << " Minor " << Minor << endl;

  fout << "DataBase: " << DBname << " Table: " << DBtable;
  fout << " Title: <" << Title << "> " << endl;
  fout << " Desc: <" << Desc << "> Size= " << SizeS;
  fout << " Major " << Major << " Minor " << Minor << endl;

  char cablename[10];
  char* pname = Name;
  char* M = "M";
  for(int i=0; i<SizeMem; i++)
  {
    strncpy(cablename,pname,10);
    cablename[9]='\0';
    char chi = cablename[0];
    if(chi != *M) break;
    pname+=10;
    Word *pstat = Stts+i;

    fout << "  #" << i+1 << ": ";
    fout << cablename << " mask ";
    fout << hex << *pstat;

    if(MuDbTable::OldOrNew == 1)
    {
      Word *dhst  = DHst+i;
      Word *mpst  = MPst+i;
      fout << " Dead/Hot " << hex << *dhst;
      fout << " Muon/Pretr " << hex << *mpst;
    }
    fout << dec << endl; 
  }

  return;
}

//** Return the status of cable */
Word MuDbHots::Status(char* cable)
{
  if(SizeMem < 1)
  {
    arteMsg << "MuDbHots::Status - table in not read" << endl;
    arteMsg.warn();
    return 0xffff;
  }

  char cablin[10];
  strncpy(cablin,cable,10);
  char* pix = "x";
  char chi = cablin[1];
  if(chi == *pix) cablin[8]=' ';
  cablin[9]='\0';

  char* pname = Name;
  Word* pstat = Stts;
  char* M = "M";
  char www[10];
  for(int i=0; i<SizeMem; i++)
  {
    strncpy(www,pname,10);
    char chi = www[0];
    if(chi != *M) break;
    chi = www[1];
    if(chi == *pix) www[8]=' ';
    www[9]='\0';

    if(!strcmp(pname,cablin)) return *pstat;
    pname+=10;
    pstat+=1;
  }
  return 0xffff;
}

//** Return Dead/Hot status of cable */
Word MuDbHots::DHstat(char* cable)
{
  if(SizeMem < 1) 
  {
    arteMsg << "MuDbHots::DHstat - table in not read" << endl;
    arteMsg.warn();
    return 0xffff;
  }

  char cablin[10];
  strncpy(cablin,cable,10);
  char* pix = "x";
  char chi = cablin[1];
  if(chi == *pix) cablin[8]=' ';
  cablin[9]='\0';

  char* pname = Name;
  Word* pstat = DHst;
  char* M = "M";
  char www[10];
  for(int i=0; i<SizeMem; i++)
  {
    strncpy(www,pname,10);
    char chi = www[0];
    if(chi != *M) break;
    chi = www[1];
    if(chi == *pix) www[8]=' ';
    www[9]='\0';

    if(!strcmp(pname,cablin)) return *pstat;
    pname+=10;
    pstat+=1;
  }
  return 0xffff;
}


//** Return Muon/Pretrigger status of cable */
Word MuDbHots::MPstat(char* cable)
{
  if(SizeMem < 1)
  {
    arteMsg << "MuDbHots::MPstat - table in not read" << endl;
    arteMsg.warn();
    return 0;
  }

  char cablin[10];
  strncpy(cablin,cable,10);
  char* pix = "x";
  char chi = cablin[1];
  if(chi == *pix) cablin[8]=' ';
  cablin[9]='\0';

  char* pname = Name;
  Word* pstat = MPst;
  char* M = "M";
  char www[10];
  for(int i=0; i<SizeMem; i++)
  {
    strncpy(www,pname,10);
    char chi = www[0];
    if(chi != *M) break;
    chi = www[1];
    if(chi == *pix) www[8]=' ';
    www[9]='\0';

    if(!strcmp(pname,cablin)) return *pstat;
    pname+=10;
    pstat+=1;
  }
  return 0;
}


//** Read the table from ascii-file into temporary space*/
int MuDbHots::ReadFile()
{
  FILE *hl = fopen(FileName, "r");
  if(!hl)
  {
    arteMsg << "MuDbHots::Create - no input File" << endl;
    arteMsg.warn();
    return 1;
  }
// loops over lines: max 5000 lines
  int nline=0;
  char line[81];
  for(int il=0; il<5000; il++)
  {
// read the line
    if(fgets(line,sizeof(line),hl) == NULL)
    {
      fclose(hl);
      if(feof(hl)) goto goodexit;
      else
      { 
        arteMsg << "MuDbHots::ReadFile -  error of file read";
        arteMsg.warn();
        return 2;
      }
    }
    ++nline;
    char *card = &line[0];

// read the first word from the line
    char cablname[10];
    Word status;
    int nitem=sscanf(card,"%s",cablname);
    char* pix = "x";
    char chi = cablname[1];
    if(chi == *pix) cablname[8]=' ';
    cablname[9]='\0';
// pass  blank lines and commented cards
    if(nitem == -1) continue;
    if(cablname[0]=='#' || cablname[0]=='*' || cablname[0]=='/') continue;
    card+=Itl(card,nitem);

// end of file
    if(!strcmp(cablname,"END"))
    {
      fclose(hl);
      goto goodexit;
    }

// read the status and make the mask
    status = 0xffff;
    for(int i=0;i<16;i++)
    {
      int st = 0; 
      nitem=sscanf(card,"%d",&st);
      if(nitem != 1) break;
      card+=Itl(card,nitem);
      Word one    = 0x8000;
      status = status ^ (one >> st);
    }

// debug print of card to be added
//    cout << dec << nline << ":  " << cablname << " status ";
//    cout << hex << status << dec << endl;

    MuDbHots::Add(cablname,status);
  }
goodexit:
  if(SizeW > 0) 
  {
     SizeS   = SizeW;
     SizeMem = SizeW;
     Name    = NameW;
     Stts    = StatW;
     DHst    = DHstW;
     MPst    = MPstW;
     MuDbHots::Print();
     return 0;
  }
  else return 50;
}

//** Create the table in DB from temporary space*/
int MuDbHots::Create()
{
  int rt=MuDbHots::ReadFile();
  if(rt != 0) return rt;
  int ret=MuDbHots::Write();
  return ret;
}

//** Add one line to the temporary arrays */
int MuDbHots::Add(char* cablname, int status)
{
  if(SizeW%SizeWQ == 0) {
// book the space
    int size = SizeWQ; 
    if(SizeW > 0) size += SizeW; 

    char* name = new char[10*size];
    if(name == NULL) return 1;

    Word* stat = new Word[size];
    if(stat == NULL) {
      delete []name;
      return 2;
    }

    Word* dhst = new Word[size];
    if(dhst == NULL) {
      delete []name;
      delete []stat;
      return 3;
    }

    Word* mpst = new Word[size];
    if(mpst == NULL) {
      delete []name;
      delete []stat;
      delete []dhst;
      return 4;
    }

    if(SizeW > 0) {
// rewrite old into new
      for(int i=0; i<SizeW; i++) {
        strncpy(name+10*i,NameW+10*i,10);
        *(stat+i)=*(StatW+i);
        *(dhst+i)=*(DHstW+i);
        *(mpst+i)=*(MPstW+i);
      }
      delete []NameW;
      delete []StatW;
      delete []DHstW;
      delete []MPstW;
    }
    NameW=name;
    StatW=stat;
    DHstW=dhst;
    MPstW=mpst;
  }

// add the last line
  strncpy(NameW+10*SizeW,cablname,10);
  *(StatW+SizeW)=status;
  *(DHstW+SizeW)=0xffff;
  *(MPstW+SizeW)=0;
  SizeW += 1;

  return 0;
}

//** Write the table to DB */
int MuDbHots::Write()
{
  if(SizeW <= 0) return 1;

// open DB
  int ret=MuDbTable::Open(1);
  if(ret > 0) return ret;

// write the table to DB
  SkipTableField(X,1);
  int ret1=PutTableField(X,TABLEascii,10*SizeW,NameW);
  int ret2=PutTableField(X,TABLEushort,SizeW,StatW);
  int ret3=0; 
  int ret4=0; 
  int ret5=0; 
  if(MuDbTable::OldOrNew == 1)
  {
    ret3=PutTableField(X,TABLEushort,SizeW,DHstW);
    ret4=PutTableField(X,TABLEushort,SizeW,MPstW);
    ret5=StoreTable(X,T,0);
  }

// delete the temporary space
  delete []NameW;
  delete []StatW;
  delete []DHstW;
  delete []MPstW;
  SizeW=0;
  SizeMem=0;
  SizeS  =0;

// close DB;
  MuDbTable::Close();

//
  if(ret1 > 0 && ret2 > 0 && MuDbTable::OldOrNew == 0) return 0;
  if(ret1 > 0 && ret2 > 0 && ret3 > 0 && ret4 > 0 && ret5 > 0 && MuDbTable::OldOrNew == 1) return 0;
  if(ret1 <= 0) return 11; 
  if(ret2 <= 0) return 12; 
  if(MuDbTable::OldOrNew == 1)
  {
    if(ret3 <= 0) return 13; 
    if(ret4 <= 0) return 14; 
    if(ret5 <= 0) return 15; 
  }
  return 16;
}



