
//## Boris Fominykh  29.12.1999
// member functions of class MuDbPad
// history:
// bug correction 17.04.2000 by Jing-Ge 
// bug correction 25.05.2000 by Jing-Ge 
// replace /MUON_DB by /MUON_NEW  6.05.2002  by B.Fominykh

#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include <fstream.h>
#include <iostream.h>
#include <iomanip.h>

#include "arte/arte.hh"
#include "arte/ArteMessage.hh"

#include "murec/MuDbPad.h"

extern "C" 
{
int MuNameDecode(char*,int*,int*,int*,int*,int*,int*);
}

//** Constructor */
MuDbPad::MuDbPad()
  :   MuDbChamber::MuDbChamber()
{
  Ivalid=-1;
  Clear();
}

//** Destructor */
MuDbPad::~MuDbPad()
{
}

//## Methods

void MuDbPad::Clear()
{
  for(Word sl=0; sl<PadGeoSl; sl++) 
  {
    for(Word ud=0; ud<PadGeoUpDown; ud++) 
    {
      NchambP[sl][ud] = 0;
      for(Word nx=0; nx<PadGeoCh; nx++) 
      {
        char* name = "        ";
        strncpy(&ChamListP[sl][ud][nx][0],name,9);
        Npads[sl][ud][nx]    = 0;
        NconPP[sl][ud][nx]    = 0;
        PadGede[sl][ud][nx][0] = 0;
        PadGede[sl][ud][nx][1] = 0;
        NconnP[sl][ud][nx]=0;
        NconPP[sl][ud][nx]=0;
        CrateP[sl][ud][nx]=0;
        CratePP[sl][ud][nx]=0;
        StepP[sl][ud][nx] =0;
        for(Word nc=0; nc<Nconn; nc++) 
        {
          for(Word sd=0; sd<PadGeoSd; sd++) 
          {
            MaskP[sl][ud][nx][nc]=0;
            Wire1P[sl][ud][nx][nc][sd]=0;
            Nbit1P[sl][ud][nx][nc][sd]=0;
          }
        }
        for(Word nc=0; nc<NconP; nc++) 
        {
          MaskPP[sl][ud][nx][nc]=0;
          Pad1[sl][ud][nx][nc]=0;
          Nbit1PP[sl][ud][nx][nc]=0;
          NumbP[sl][ud][nx][nc]=0;
        }
      }
    }
  }
}


int MuDbPad::SetConnect()
{
  int ret=0;
  int NcabR=0;

// Config object
  MuDbConfig Conf;
  Conf.setDBname(DBname);
  Conf.Ini();
  Conf.setKTstatus(KTstatus);
  Conf.setMajor(Major);
  Conf.setMinor(Minor);
  ret=Conf.Read(&NcabR);
  if(ret != 0 || NcabR <= 0) 
  {
    arteMsg << "MuDbPad: cable configuration table is NOT read, ret= " << ret;
    arteMsg << " NcabR= " << NcabR << " DBname= " << DBname << " Major= " << Major;
    arteMsg << " Minor " << Minor << endl;
    arteMsg.warn();
    return 10+ret;
  }

// hot channel object
  MuDbHots Hots;
  Hots.setDBname(DBname);
  Hots.Ini();
  Hots.setKTstatus(KTstatus);
  Hots.setMajor(Major);
  Hots.setMinor(Minor);
  ret=Hots.Read();
  if(ret != 0) 
  {
    arteMsg << "MuDbPad: hot channel table is NOT read, ret= " << ret;
    arteMsg << " DBname= " << DBname << " Major= " << Major;
    arteMsg << " Minor " << Minor << endl;
    arteMsg.warn();
    return 20+ret;
  }

// loops over cables
  for(int ncb=0; ncb<NcabR; ncb++) 
  {
    char name[10];
    Word crate=0;
    Word ncabl=0;
// get the next cable connection
    ret=Conf.GetCabl(&ncb,name,&crate,&ncabl);
    if(ret != 0) return 30+ret;
// decode the cable name
    int type = 0;
    int msl  = 0;
    int lay  = 0;
    int ud   = 0;
    int nx   = 0;
    int ncab = 0;
    ret=MuNameDecode(name,&type,&msl,&lay,&ud,&nx,&ncab);
    if(msl > 2 && type > 1 && type < 4) 
    {
      int sl=msl-3;
      nx-=1;
      ncab-=1;

// get the cable hot channel mask

// correction 26.09.99 for pads
      char nm[10];
      strncpy(nm,name,9);
      nm[9]='\0';
// correction for pads
      if(nm[1] == 'p') 
      {
        char ch = nm[8];
        if(ch == 'A') nm[8] = 'B';
        if(ch == 'B') nm[8] = 'A';
        if(ch == 'C') nm[8] = 'D';
        if(ch == 'D') nm[8] = 'C';
      }
// end of correction 26.09.99

// get the cable hot channel mask
      Word status = 0;
// from data base /MUON_DB
      if(Hots.getOldOrNew() == 0) status=Hots.Status(nm);
// from data base /MUON_NEW
      if(Hots.getOldOrNew() == 1)
      {
        Word mask  =Hots.Status(nm);
        Word dhstat=Hots.DHstat(nm);
        Word mpstat=Hots.MPstat(nm);
        status = mask & (dhstat & (0xffff ^ mpstat));
      }

      // if(mask != 0xffff)
      // {
      //   cout << dec << ncb << "  " << name << "  " << nm;
      //   cout << " mask " << hex << mask << " dhstat " << dhstat;
      //   cout << " mpstat " << mpstat << " ~ " << (0xffff ^ mpstat);
      //   cout << " status " << status << dec << endl;
      // }

// cable bit position inside crate
      Word nbit = 16*ncabl; 
// the special case of chamber 99
      if(ud == 1 && nx == 98) nx=NchambP[sl][ud]-1;         
      if(nx > NchambP[sl][ud]-1 || nx < 0) 
      {
        arteMsg << "MuDbPad: wrong nx = " << nx << " ncb " << ncb << endl;
        arteMsg.warn();
        continue;
      }

//    cout << "MuDbTube: ncb= " << dec << ncb << " " << name;
//    cout << " ret " << ret << " type: " << type;
//    cout << " msl: " << msl << " lay: " << lay;
//    cout << " ud: " << ud << " nx: " << nx;
//    cout << " ncab: " << ncab << " mask " << hex << status;
//    cout << dec << endl;

// pad chamber wires
      if(type == 2) 
      {
        int nc = NconnP[sl][ud][nx];
        NconnP[sl][ud][nx] += 1;
        MaskP[sl][ud][nx][nc] = status;
        if(ud == 0) 
        {
          StepP[sl][ud][nx]=-2;
          StepP[sl][ud][nx]=-2;

          CrateP[sl][ud][nx]       =crate;
// 0505,2000 modified by physjg, first layer shift to -x 
          Nbit1P[sl][ud][nx][nc][0]=nbit+1;
          Nbit1P[sl][ud][nx][nc][1]=nbit;
          //Nbit1P[sl][ud][nx][nc][0]=nbit;
          //Nbit1P[sl][ud][nx][nc][1]=nbit+1;

          if(ncab == 0) 
          {
            Wire1P[sl][ud][nx][nc][0]=15;
            Wire1P[sl][ud][nx][nc][1]=15;
          }
          if(ncab == 1) 
          {
            Wire1P[sl][ud][nx][nc][0]=7;
            Wire1P[sl][ud][nx][nc][1]=7;
          }
        }
        if(ud == 1) 
        {
          StepP[sl][ud][nx]=2;
          StepP[sl][ud][nx]=2;

          CrateP[sl][ud][nx]       =crate;
// 0505,2000 modified by physjg, first layer shift to +x 
          Nbit1P[sl][ud][nx][nc][0]=nbit+1;
          Nbit1P[sl][ud][nx][nc][1]=nbit;
          //Nbit1P[sl][ud][nx][nc][0]=nbit;
          //Nbit1P[sl][ud][nx][nc][1]=nbit+1;

          if(ncab == 0) 
          {
            Wire1P[sl][ud][nx][nc][0]=0;
            Wire1P[sl][ud][nx][nc][1]=0;
          }
          if(ncab == 1) 
          {
            Wire1P[sl][ud][nx][nc][0]=8;
            Wire1P[sl][ud][nx][nc][1]=8;
          }
        }
      }

// pads
      if(type == 3) 
      {
        int nc = NconPP[sl][ud][nx];
        NconPP[sl][ud][nx] += 1;
        MaskPP[sl][ud][nx][nc] = status;
        CratePP[sl][ud][nx]    = crate;
        Nbit1PP[sl][ud][nx][nc]= nbit;
        NumbP[sl][ud][nx][nc]=15;
	
        if(ncab == 0 || ncab == 2) 
        {
          if(sl == 1) 
          {
            NumbP[sl][ud][nx][nc]=14;
            Nbit1PP[sl][ud][nx][nc]=nbit+1;
          }
        }
        
        Word padsh = 15;

// chambers Mp 15, 16, 17
        if(nx > 14 && nx < 18) 
        {
          if(ncab == 1 || ncab == 3) 
          {
            // NumbP[sl][ud][nx][nc]=12;
// added by Jing-Ge Shiu on May 10, 2000, since we have 13 pads here for mu4
            NumbP[sl][ud][nx][nc]=12 + (sl==1);
            if(sl == 1) Nbit1PP[sl][ud][nx][nc]=nbit;
          }
          // padsh=12 ;
          padsh=12 + (sl==1) ;
        }

// chamber 18 bottom 
        if(ud == 1 && nx == 18) 
        {
          if(ncab == 1 || ncab == 3) 
          {
            Nbit1PP[sl][ud][nx][nc]=nbit;
            NumbP[sl][ud][nx][nc]=4;
            if(sl == 1) NumbP[sl][ud][nx][nc]=5;
          }
          if(ncab == 0 || ncab == 2) 
          {
	    // Nbit1PP[sl][ud][nx][nc]=nbit+1;
// 2000.04.17 physjg, only Mp4 need to add 1.
            Nbit1PP[sl][ud][nx][nc]=nbit + (sl == 1);
          }
          padsh=4;
          if(sl == 1) padsh=5;
        }
        if(ud == 0) 
        {
          if(ncab == 1) Pad1[sl][ud][nx][nc]=Npads[sl][ud][nx];
          if(ncab == 0) Pad1[sl][ud][nx][nc]=Npads[sl][ud][nx]+padsh;
          if(ncab == 3) Pad1[sl][ud][nx][nc]=0;
          if(ncab == 2) Pad1[sl][ud][nx][nc]=padsh;
        }
        if(ud == 1) 
        {
          if(ncab == 1) Pad1[sl][ud][nx][nc]=0;
          if(ncab == 0) Pad1[sl][ud][nx][nc]=padsh;
          if(ncab == 3) Pad1[sl][ud][nx][nc]=Npads[sl][ud][nx];
          if(ncab == 2) Pad1[sl][ud][nx][nc]=Npads[sl][ud][nx]+padsh;
// add the link to chamber 99
          if(nx == 18) 
          {
            int nx99=int(NchambP[sl][ud])-1;         
            if(ncab == 1 || ncab == 3) 
            {
              int nc99 = int(NconPP[sl][ud][nx99]);
              NconPP[sl][ud][nx99] += 1;
              MaskPP[sl][ud][nx99][nc99] = status;
              CratePP[sl][ud][nx99]      = crate;
              Nbit1PP[sl][ud][nx99][nc99]= nbit+9;
	      NumbP[sl][ud][nx99][nc99]=Npads[sl][ud][nx99];
// 2000.04.17 physjg, there are 7 pad in one column for Mp3.2-99  
              // NumbP[sl][ud][nx99][nc99]=Npads[sl][ud][nx99]+(sl==0);
              if(ncab == 1) Pad1[sl][ud][nx99][nc99]=0;
              if(ncab == 3) Pad1[sl][ud][nx99][nc99]=Npads[sl][ud][nx99];
            }
          }
        }
      }
    }
  }
  Hots.Release();
  Conf.Release();
  return 0;
}


void MuDbPad::Print()
{
// check print control in kumac
  if(getenv("MUON_PAD_PRINT") == NULL) return;
  if(strcmp(getenv("MUON_PAD_PRINT"),"YES")) return;

// create the log-file and pipe the programm output
  ofstream fout("MuDbPad.out");
  if (!fout) 
  {
    arteMsg << "MuDbPad - can NOT open file for print" << endl;
    arteMsg.warn();
    return;
  }

  fout << "MuDbPad: Ivalid= " << Ivalid << endl;
  for(Word sl=0; sl<PadGeoSl; sl++) 
  {
    for(Word ud=0; ud<PadGeoUpDown; ud++) 
    {
      fout << "pad chamber sl " << dec << sl+2;
      fout << " UpDown " << ud << " Nchamb " << NchambP[sl][ud] << endl; 
      if(NchambP[sl][ud] > 0) 
      {
        for(Word nx=0; nx<NchambP[sl][ud]; nx++) 
        {
          char name[10];
          strncpy(name,&ChamListP[sl][ud][nx][0],9);
	  fout << name << " nx " << nx;
	  fout << " wires " << PadGeoWire << " Ncab " << NconnP[sl][ud][nx];
	  fout << " pads " << 2*Npads[sl][ud][nx] << " Ncab " << NconPP[sl][ud][nx] << endl;
          if(NconnP[sl][ud][nx] > 0) 
          {
            for(Word nc=0; nc<NconnP[sl][ud][nx]; nc++) 
            {
              for(Word sd=0; sd<PadGeoSd; sd++) 
              {
                fout << "   #cableW " << nc;
                fout << " mask " << hex << MaskP[sl][ud][nx][nc];
                fout << " side " << dec << sd;
                fout << " wire1 " << dec << Wire1P[sl][ud][nx][nc][sd] ;
                fout << " crate " << hex << CrateP[sl][ud][nx];
                fout << " Nbit1 " << dec << Nbit1P[sl][ud][nx][nc][sd] ;
                Word word = Nbit1P[sl][ud][nx][nc][sd] / 32 ;
                Word bit  = Nbit1P[sl][ud][nx][nc][sd] - word*32 ;
                fout << " (" << word << "-" << bit << ") ";
                fout << " step " << dec << StepP[sl][ud][nx];
                fout << " gede " << dec << PadGede[sl][ud][nx][sd] ;
                fout << endl;
              }
            }
          }
	  if(NconPP[sl][ud][nx] > 0) 
          {
            for(Word nc=0; nc<NconPP[sl][ud][nx]; nc++) 
            {
              fout << "   #cableP " << nc;
              fout << " mask " << hex << MaskPP[sl][ud][nx][nc];
              fout << " pad1 " << dec << Pad1[sl][ud][nx][nc];
              fout << " Npads " << dec << NumbP[sl][ud][nx][nc];
              fout << " crate " << hex << CratePP[sl][ud][nx];
              fout << " Nbit1 " << dec << Nbit1PP[sl][ud][nx][nc];
              Word word = Nbit1PP[sl][ud][nx][nc] / 32 ;
              Word bit  = Nbit1PP[sl][ud][nx][nc] - word*32 ;
              fout << " (" << word << "-" << bit << ") ";
              fout << " gede1 " << dec << PadGede[sl][ud][nx][0];
              fout << " gede2 " << dec << PadGede[sl][ud][nx][1];
              fout << endl;
            }
          }
        }
      }
    }
  }
}






