
//## Boris Fominykh  29.12.1999
// member functions of class MuDbPadArte
// updated 6.05.2002 by B.Fominykh - /MUON_NEW instead of /MUON_DB

#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include <iostream.h>
#include <iomanip.h>

#include "arte/arte.hh"
#include "arte/artefunc.h"
#include "arte/ArteMessage.hh"

#include "murec/MuDbPadArte.h"

extern "C" 
{
int MuNameDecode(char*,int*,int*,int*,int*,int*,int*);
}

//** Constructor */
MuDbPadArte::MuDbPadArte()
  :  MuDbPad::MuDbPad()
{
}

//** Destructor */
MuDbPadArte::~MuDbPadArte()
{
}

//## Methods

int MuDbPadArte::setStructArte()
{
  LWord Ngede = 0;
  char memo[10] = "         ";
// loops over GEDE
  for ( ArteTableIterator<GEDE> iv = ArteTable<GEDE>::begin(); 
        iv != ArteTable<GEDE>::end(); ++iv ) 
  {
    Ngede++;
    int   cmp  = (*iv)->cmp;
    if(cmp == 8) 
    {
      ArtePointer<GESL> gesl = (*iv)->gesl;
      int msl  = gesl->nsl;            // # muon superlayer
      if(msl > 2) 
      {
// chamber name
        char name[10];
        strncpy(name,(*iv)->hwc,9);
// decode the chamber name
        int type  = 0;
        int msld  = 0;
        int lay  = 0;
        int ud   = 0;
        int nx    = 0;
        int ncab  = 0;
        int ret=MuNameDecode(&name[0],&type,&msld,&lay,&ud,&nx,&ncab);
        if(ret == 0 && type == 3 && msl == msld) 
        {
// side
          int sd=0;
          if(!strcmp(name,memo)) sd = 1;
          strncpy(memo,name,9);
          int sl=msl-3;
          nx-=1;
// the special case of chamber 99
          if(ud == 1 && nx == 98) 
          {
            nx=PadGeoCh-1;         
          }
	  if(sd == 0) NchambP[sl][ud]+=1;
          PadGeoWire = (*iv)->nwi[0];  // number of wires
          Npads[sl][ud][nx] = (*iv)->nwi[2];
          strncpy(&ChamListP[sl][ud][nx][0],name,9);
          ChamListP[sl][ud][nx][8]='\0';
          PadGede[sl][ud][nx][sd] = Ngede;
        }
      }
    }
  }
// put chamber-99 to correct place
  Word ud=1;
  Word nx2=PadGeoCh-1;
  for(Word sl=0; sl<PadGeoSl; sl++) 
  {
    for(Word sd=0; sd<PadGeoSd; sd++) 
    {
      Word nx1=NchambP[sl][ud]-1;      
      strncpy(&ChamListP[sl][ud][nx1][0],&ChamListP[sl][ud][nx2][0],9);
      PadGede[sl][ud][nx1][sd]=PadGede[sl][ud][nx2][sd];
      Npads[sl][ud][nx1]=Npads[sl][ud][nx2];
    }
  }
  return 0;
}

int MuDbPadArte::Ini()
{
  Ivalid=-1;
  Clear();
  int ret = 0;
  ret=MuDbPadArte::setStructArte();
  if(ret != 0) return ret+10;
  ret=MuDbPad::SetConnect();
  if(ret != 0) return ret+20;
  Ivalid=1;
  return 0;
}
