
//## Boris Fominykh  19.01.2000
// member functions of base class MuDbTable
// updated 6.05.2002 by B.Fominykh - /MUON_NEW instead of /MUON_DB

#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include <iostream.h>
#include <iomanip.h>

#include "arte/arte.hh"
#include "arte/ArteMessage.hh"

#include "murec/MuDbTable.h"

//** Constructor */
MuDbTable::MuDbTable()
{
  Ini();
  setKTstatus(-2);
  setMajor(0);
  setMinor(0);
  if(getenv("MUON_DBNAME") != NULL) setDBname(getenv("MUON_DBNAME"));
  setName("xxxxxxxxx");
  setDesc("xxxxxxxxx");
  setTitle("xxxxxxxxx");
  setFile("xxxxxxxxx");
}

//** Destructor */
MuDbTable::~MuDbTable()
{
}

//## Methods

//** Initialization */
void MuDbTable::Ini()
{
  X=NULL;
  T=0;
  Size = 0;
  Nf   = 0;
  IvalT=-1;
  MUserver=-1;
  MUtable =-1;
  return;
}
 
//** Open DB and table*/
int MuDbTable::Open(int write)
{
  if(!strcmp(DBtable,"xxxxxxxxx")) {
    arteMsg << "MuDbTable::Open - table name is not defined";
    arteMsg.warn();
    return 1;
  }

  if(KTstatus < 0 && Major <= 0 && Minor != 0) {
    arteMsg << "MuDbTable::Open - Major is not defined, KTstatus " << KTstatus << " Major " << Major << " Minor " << Minor;
    arteMsg.warn();
    return 1;
  }

init:
// case KTstatus= 2, use keytable which structure changed, make initialization
  if(KTstatus == 2) {
    MUserver = KeyFindServer(DBname);
    if(MUserver == -1) {
      arteMsg << "MuDbTable: Open - server " << DBname << " not found";
      arteMsg.warn();
      return 2;
    }
    MUtable = KeyFindTable(MUserver,DBtable);
    if(MUtable == -1) {
      arteMsg << "MuDbTable: Open - table " << DBtable << " not found" << " in " << DBname;
      arteMsg.warn();
      return 3;
    }
    KTstatus=1;
  } 

// case KTstatus= 1, use updated keytable, assign key
  if(KTstatus == 1) {
    if(MUserver == -1 || MUtable == -1) {
      KTstatus=2;
      goto init;
    }
    char* dbsite = 0;
    dbsite = KeyServerName(MUserver);
    strncpy(&DBname[0],dbsite,256);    
    char* dbtab = 0;
    dbtab = KeyTableName(MUtable);
    strncpy(&DBtable[0],dbtab,256);    
  } 

  X=NULL;
  if(write == 1) X=OpenTables(DBname,0);
  else X=OpenTables(DBname,TABLEreadonly);
  if(X == NULL) {
    arteMsg << "MuDbTable::Open - " << DBname << " is not open";
    arteMsg.warn();
    return 4;
  }

  if(!strcmp(Desc,"xxxxxxxxx")) {
    arteMsg << "MuDbTable::Open - description of " << DBtable << " is not defined";
    arteMsg.warn();
    return 5;
  }
  if(!strcmp(Title,"xxxxxxxxx")) {
    arteMsg << "MuDbTable::Open - title of " << DBtable << " is not defined";
    arteMsg.warn();
    return 6;
  }

  // cout << "MuDbTable: table " << DBtable << " <" << Title;
  // cout << ">  KTstatus= " << KTstatus << endl;
  // PrintTables(X,1);

  T=BookTable(X,DBtable,Desc,Title);
  if(T <= 0) {
    arteMsg << "MuDbTable: " << DBtable << " is NOT open " << " Major " << Major << " Minor " << Minor;
    arteMsg.warn();
    return 7;
  }

  if(KTstatus > 0) {
    KeyTableStamp(X,DBname,DBtable);
    arteMsg << "MuDbTable: " << DBtable << " from " << DBname << " is stamped with keytable";
    arteMsg.warn();
  }
  else  {
    TableStamp(X,Major,Minor);

// only if read mode
    if(write == 0) {
      int check=MatchTable(X,T,0);

      if(check != 1) {
        check=MatchTable(X,T,2);
        if(check != 1) {
          arteMsg << "MuDbTable: NO table " << DBtable << " for major " << Major << " minor " << Minor;
          arteMsg.warn();
          return 8;
        } 
        else {
          Major=TableMajor(X);
          Minor=TableMinor(X);
          TableStamp(X,Major,Minor);
          arteMsg << DBtable << " from " << DBname << " is stamped with major " << Major << " minor " << Minor;
          arteMsg.warn();
        }
      } 
    } 
  }
  return 0;
}
 
//** Fetch the table */
int MuDbTable::Fetch()
{
  if(X == NULL) {
    arteMsg << "MuDbTable::Fetch - DB " << DBname << " is not open";
    arteMsg.warn();
    return 1;
  }
  if(T <= 0) {
    arteMsg << "MuDbTable::Fetch - " << DBtable << " is not booked";
    arteMsg.warn();
    return 2;
  }
  if(!FetchTable(X,T,0)) {
    arteMsg << "MuDbTable::Fetch - " << DBtable << " is not fetched";
    arteMsg.warn();
    CloseTables(X);
    return 3;
  }
// define the size
  Nf=SkipTableField(X,2);
  Size=TableFieldSize(X);
  if(Size < 1) {
    arteMsg << "MuDbTable::Fetch - zero size of " << DBtable;
    arteMsg.warn();
    CloseTables(X);
    return 3;
  }

  IvalT=1;
  return 0;
}

//** Close the table */
void MuDbTable::Close()
{
  if(X != NULL) {
    CloseTables(X);
    //  cout << "MuDbTable::Close - " << DBname << " is closed";
    //  cout << endl;
  }
  MuDbTable::Ini();
  return;
}

//** String anlysis */
int MuDbTable::Itl(char *s,int nitem)
{
  int i;
  char* s0=s;
  for (i=0;i<nitem;i++) {
    while (*s==' ') s++;
    while (*s!=' ' && *s != '\n' ) s++;
  }
  return s-s0;
}

void MuDbTable::setDBname(char* name)
{
  strncpy(DBname,name,256);
  setOldOrNew(1);
  if(!strncmp(getDBname(),"/MUON_DB",8)) setOldOrNew(0);
  return;
}

void MuDbTable::setName(char* name)
{
  strncpy(DBtable,name,256);
  return;
}

void MuDbTable::setTitle(char* title)
{
  strncpy(Title,title,64);
  return;
}

void MuDbTable::setDesc(char* description)
{
  strncpy(Desc,description,128);
  return;
}

void MuDbTable::setFile(char* filename)
{
  strncpy(FileName,filename,128);
  return;
}


