
//## Boris Fominykh  28.12.1999
// member functions of class MuDbTubeArte
// updated 6.05.2002 by B.Fominykh - /MUON_NEW instead of /MUON_DB

#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include <iostream.h>
#include <iomanip.h>

#include "arte/arte.hh"
#include "arte/artefunc.h"
#include "arte/ArteMessage.hh"

#include "murec/MuDbTubeArte.h"

extern "C"
{
int MuNameDecode(char*,int*,int*,int*,int*,int*,int*);
}

//** Constructor */
MuDbTubeArte::MuDbTubeArte()
  :  MuDbTube::MuDbTube()
{
}

//** Destructor */
MuDbTubeArte::~MuDbTubeArte()
{
}

//## Methods

int MuDbTubeArte::setStructArte()
{
  LWord Ngede = 0;
  char memo[10] = "         ";
// loops over GEDE
  for ( ArteTableIterator<GEDE> iv = ArteTable<GEDE>::begin(); 
        iv != ArteTable<GEDE>::end(); ++iv )
  {
    Ngede++;
    int   cmp  = (*iv)->cmp;
    if(cmp == 8)
    {
      ArtePointer<GESL> gesl = (*iv)->gesl;
      int msl  = gesl->nsl;            // # muon superlayer
      if(msl < 3)
      {
// chamber name
        char name[10];
        strncpy(name,(*iv)->hwc,9);
// decode the chamber name
        int type  = 0;
        int msld  = 0;
        int lay  = 0;
        int ud   = 0;
        int nx    = 0;
        int ncab  = 0;
        int ret=MuNameDecode(&name[0],&type,&msld,&lay,&ud,&nx,&ncab);
        if(ret == 0 && type == 1 && msl == msld)
        {
// side
          int sd=0;
          if(!strcmp(name,memo)) sd = 1;
          strncpy(memo,name,9);
          int sl=msl-1;
          lay-=1;
          nx-=1;
// the special case of chamber 99
          if(ud == 1 && nx == 98) 
          {
            nx=TubeGeoNx-1;         
          }
	  if(sd == 0) NchambT[sl][lay][ud]+=1;
          TubeGeoWire = (*iv)->nwi[0];  // number of wires
          strncpy(&ChamListT[sl][lay][ud][nx][0],name,9);
          TubeGede[sl][lay][ud][nx][sd] = Ngede;
        }
      }
    }
  }
  for(Word sl=0; sl<TubeGeoSl; sl++)
  {
    for(Word lay=0; lay<TubeGeoLay; lay++)
    {
      for(Word sd=0; sd<TubeGeoSd; sd++)
      {
        Word ud=1;
        Word nx1=NchambT[sl][lay][ud]-1;      
        Word nx2=TubeGeoNx-1;
        strncpy(&ChamListT[sl][lay][ud][nx1][0],&ChamListT[sl][lay][ud][nx2][0],9);
        TubeGede[sl][lay][ud][nx1][sd]=TubeGede[sl][lay][ud][nx2][sd];
      }
    }
  }
  return 0;
}

int MuDbTubeArte::Ini()
{
  Ivalid=-1;
  Clear();
  int ret = 0;
  ret=MuDbTubeArte::setStructArte();
  if(ret != 0) return ret+10;
  ret=MuDbTube::SetConnect();
  if(ret != 0) return ret+20;
  Ivalid=1;
  return 0;
}
