
// Boris Fominykh 25.01.2000
// fill muon GESL, GEDE from NESL, NEDE

#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include <iostream.h>
#include <iomanip.h>

#include "arte/arte.hh"
#include "arte/ArteMessage.hh"

#include "murec/MuNede.h"
#include "murec/MuNesl.h"

extern "C" {
  void MuCheckGesl(MuNesl*);
  void MuReadNesl(ArteTableIterator<NESL>,MuNesl*);
  void MuFillGesl(ArteTableIterator<GESL>,MuNesl*);
  void MuAddGesl(MuNesl*);

  void MuCheckGede(MuNede*);
  void MuReadNede(int,MuNede*);
  void MuFillGede(ArteTableIterator<GEDE>,MuNede*);
  void MuAddGede(MuNede*);
  void MuGeoPoint2();
}

extern "C" {
void MuNede2Gede()
{
  MuNesl   lnesl;
  MuNede   lnede;
// loops over NESL
  for ( ArteTableIterator<NESL> isl = ArteTable<NESL>::begin(); 
	isl != ArteTable<NESL>::end();
	++isl ) {
    int cmp  = (*isl)->cmp;
    if(cmp == 8 || cmp == 9) {
      MuReadNesl(isl,&lnesl);
      MuCheckGesl(&lnesl);
//      int msl  = (*isl)->nsl;  // # muon superlayer
      int iv1 = (*isl)->fpl;
      int iv2 = iv1 + (*isl)->npl - 1;
      if(iv2 >= iv1) {
// loops over muon NEDE
        for ( int iv=iv1; iv<=iv2; iv++) { 
          MuReadNede(iv,&lnede);
          MuCheckGede(&lnede);
        }
      }
    }
  }
  MuGeoPoint2();
  return;
}

void MuCheckGesl(MuNesl* pnesl)
{
// superlayer name
  char namsl[5];
  strncpy(namsl,&(pnesl->name[0]),5);
  namsl[4]='\0';
  int check=0;
// loops over ARTE superlayers
  for ( ArteTableIterator<GESL> isl = ArteTable<GESL>::begin(); 
	isl != ArteTable<GESL>::end();
	++isl ) {
    int cmp  = (*isl)->cmp;
    if(cmp == 8 || cmp == 9) {
// ARTE superlayer name
      char name[5];
      strncpy(name,(*isl)->name,5);
      name[4]='\0';
      if(!strcmp(namsl,name)) {
        check=1;
        MuFillGesl(isl,pnesl);
      }
    }
  }
  if(check == 0) MuAddGesl(pnesl);
  return;
}

void MuReadNesl(ArteTableIterator<NESL> isl,MuNesl* pnesl)
{
  char name[4];
  strncpy(name,(*isl)->name,4);
  strncpy(pnesl->name,name,4);

  pnesl->cmp = (*isl)->cmp;
  pnesl->shp = (*isl)->shp;
  pnesl->nsl = (*isl)->nsl;
  pnesl->mfl = (*isl)->mfl;
  pnesl->lay = (*isl)->lay;
  pnesl->npl = (*isl)->npl;
  pnesl->fpl = (*isl)->fpl;
  pnesl->nwl = (*isl)->nwl;
  pnesl->fwl = (*isl)->fwl;
  pnesl->ltyp= (*isl)->ltyp;
  pnesl->x1  = (*isl)->x1;
  pnesl->x2  = (*isl)->x2;
  pnesl->y1  = (*isl)->y1;
  pnesl->y2  = (*isl)->y2;
  pnesl->z1  = (*isl)->z1;
  pnesl->z2  = (*isl)->z2;
  pnesl->dx  = (*isl)->dx;
  pnesl->dy  = (*isl)->dy;
  return;
}


void MuFillGesl(ArteTableIterator<GESL> isl,MuNesl* pnesl)
{
  (*isl)->cmp = pnesl->cmp;
  (*isl)->shp = pnesl->shp;
  (*isl)->nsl = pnesl->nsl;
  (*isl)->mfl = pnesl->mfl;
  (*isl)->lay = pnesl->lay;
  (*isl)->npl = pnesl->npl;
  (*isl)->fpl = pnesl->fpl;
  (*isl)->nwl = pnesl->nwl;
  (*isl)->fwl = pnesl->fwl;
  (*isl)->ltyp= pnesl->ltyp;
  (*isl)->x1  = pnesl->x1;
  (*isl)->x2  = pnesl->x2;
  (*isl)->y1  = pnesl->y1;
  (*isl)->y2  = pnesl->y2;
  (*isl)->z1  = pnesl->z1;
  (*isl)->z2  = pnesl->z2;
  (*isl)->dx  = pnesl->dx;
  (*isl)->dy  = pnesl->dy;
  return;
}

void MuAddGesl(MuNesl* pnesl)
{
  struct GESL gesl;

  char nam[4];
  strncpy(&nam[0],pnesl->name,4);
  strncpy(gesl.name,nam,4);

  gesl.cmp = pnesl->cmp;
  gesl.shp = pnesl->shp;
  gesl.nsl = pnesl->nsl;
  gesl.mfl = pnesl->mfl;
  gesl.lay = pnesl->lay;
  gesl.npl = pnesl->npl;
  gesl.fpl = pnesl->fpl;
  gesl.nwl = pnesl->nwl;
  gesl.fwl = pnesl->fwl;
  gesl.ltyp= pnesl->ltyp;
  gesl.x1  = pnesl->x1;
  gesl.x2  = pnesl->x2;
  gesl.y1  = pnesl->y1;
  gesl.y2  = pnesl->y2;
  gesl.z1  = pnesl->z1;
  gesl.z2  = pnesl->z2;
  gesl.dx  = pnesl->dx;
  gesl.dy  = pnesl->dy;
  ArtePointer<GESL>::append(gesl);
  return;
}

void MuCheckGede(MuNede* pnede)
{
// chamber name
  char name[9];
  char namde[9];
  strncpy(namde,&(pnede->hwc[0]),9);
  namde[8]='\0';

  for ( ArteTableIterator<GEDE> iv = ArteTable<GEDE>::begin(); 
	iv != ArteTable<GEDE>::end();
	++iv) 
  {
    int cmp  = (*iv)->cmp;
    if(cmp == 8 || cmp == 9) {

      strncpy(name,(*iv)->hwc,9);
      if(cmp == 9) {
        for(int i=5; i< 8; i++) name[i]=' ';
      }
      name[8]='\0';

      if(!strcmp(namde,name)) {
        float dz = pnede->zmin-(*iv)->zmin;
        if(dz < 0.01 && dz > -0.01) {
          MuFillGede(iv,pnede);
          return;
        }
      }
    }
  }
  MuAddGede(pnede);
  return;
}

void MuReadNede(int iv,MuNede* pnede)
{
  ArtePointer<NEDE> nede(iv);
  pnede->cmp  = nede->cmp;
  pnede->lay  = nede->lay;
  pnede->sec  = nede->sec;
  pnede->shp  = nede->shp;
  pnede->xmin = nede->xmin;
  pnede->xmax = nede->xmax;
  pnede->ymin = nede->ymin;
  pnede->ymax = nede->ymax;
  pnede->zmin = nede->zmin;
  pnede->zmax = nede->zmax;
  pnede->sxmn = nede->sxmn;
  pnede->sxmx = nede->sxmx;
  pnede->symn = nede->symn;
  pnede->symx = nede->symx;
  pnede->cos  = nede->cos;
  pnede->sin  = nede->sin;
  for(int j=0; j<9; j++) pnede->rot[j]=nede->rot[j];
  pnede->acc  = nede->acc;
  pnede->eff  = nede->eff;
  pnede->dod  = nede->dod;
  pnede->pit  = nede->pit;
  pnede->ms   = nede->ms;
  for(int j=0; j<4; j++) pnede->xfw[j]=nede->xfw[j];
  for(int j=0; j<4; j++) pnede->zfw[j]=nede->zfw[j];
  for(int j=0; j<4; j++) pnede->nwi[j]=nede->nwi[j];
  pnede->nsl  = nede->nsl;
  pnede->nwl  = nede->nwl;
  pnede->fwl  = nede->fwl;
  pnede->xmad = nede->xmad;
  pnede->ymad = nede->ymad;
  pnede->zmad = nede->zmad;
  for(int j=0; j<4; j++) pnede->y1w[j]=nede->y1w[j];
  for(int j=0; j<4; j++) pnede->y2w[j]=nede->y2w[j];
  pnede->dedx = nede->dedx;
  pnede->gcop = nede->gcop;
  pnede->noise= nede->noise;
  pnede->ares = nede->ares;

  char buf[4];
  strncpy(buf,nede->gvol,4);
  strncpy(&(pnede->gvol[0]),buf,4);

  char name[9];
  strncpy(name,&(nede->hwc[0]),9);
  name[8]='\0';
  strncpy(&(pnede->hwc[0]),name,9);

  return;
}

void MuFillGede(ArteTableIterator<GEDE> iv,MuNede* pnede)
{
  (*iv)->cmp = pnede->cmp;
  (*iv)->lay = pnede->lay;
  (*iv)->sec = pnede->sec;
  (*iv)->shp = pnede->shp;
  (*iv)->xmin = pnede->xmin;
  (*iv)->xmax = pnede->xmax;
  (*iv)->ymin = pnede->ymin;
  (*iv)->ymax = pnede->ymax;
  (*iv)->zmin = pnede->zmin;
  (*iv)->zmax = pnede->zmax;
  (*iv)->sxmn = pnede->sxmn;
  (*iv)->sxmx = pnede->sxmx;
  (*iv)->symn = pnede->symn;
  (*iv)->symx = pnede->symx;
  (*iv)->cos  = pnede->cos;
  (*iv)->sin  = pnede->sin;
  for(int j=0; j<9; j++) (*iv)->rot[j]=pnede->rot[j];
  (*iv)->acc  = pnede->acc;
  (*iv)->eff  = pnede->eff;
  (*iv)->dod  = pnede->dod;
  (*iv)->pit  = pnede->pit;
  (*iv)->ms   = pnede->ms;
  for(int j=0; j<4; j++) (*iv)->xfw[j]=pnede->xfw[j];
  for(int j=0; j<4; j++) (*iv)->zfw[j]=pnede->zfw[j];
  for(int j=0; j<4; j++) (*iv)->nwi[j]=pnede->nwi[j];
  (*iv)->nsl = pnede->nsl;
  (*iv)->nwl = pnede->nwl;
  (*iv)->fwl = pnede->fwl;
  (*iv)->xmad= pnede->xmad;
  (*iv)->ymad= pnede->ymad;
  (*iv)->zmad= pnede->zmad;
  for(int j=0; j<4; j++) (*iv)->y1w[j]=pnede->y1w[j];
  for(int j=0; j<4; j++) (*iv)->y2w[j]=pnede->y2w[j];
  (*iv)->dedx = pnede->dedx;
  (*iv)->gcop = pnede->gcop;
  (*iv)->noise= pnede->noise;
  (*iv)->ares = pnede->ares;

  char buf[4];
  strncpy(buf,&(pnede->gvol[0]),4);
  strncpy((*iv)->gvol,buf,4);

  return;
}

void MuAddGede(MuNede* pnede)
{
  struct GEDE gede;

  gede.cmp = pnede->cmp;
  gede.lay = pnede->lay;
  gede.sec = pnede->sec;
  gede.shp = pnede->shp;
  gede.xmin = pnede->xmin;
  gede.xmax = pnede->xmax;
  gede.ymin = pnede->ymin;
  gede.ymax = pnede->ymax;
  gede.zmin = pnede->zmin;
  gede.zmax = pnede->zmax;
  gede.sxmn = pnede->sxmn;
  gede.sxmx = pnede->sxmx;
  gede.symn = pnede->symn;
  gede.symx = pnede->symx;
  gede.cos  = pnede->cos;
  gede.sin  = pnede->sin;
  for(int j=0; j<9; j++) gede.rot[j]=pnede->rot[j];
  gede.acc  = pnede->acc;
  gede.eff  = pnede->eff;
  gede.dod  = pnede->dod;
  gede.pit  = pnede->pit;
  gede.ms   = pnede->ms;
  for(int j=0; j<4; j++) gede.xfw[j]=pnede->xfw[j];
  for(int j=0; j<4; j++) gede.zfw[j]=pnede->zfw[j];
  for(int j=0; j<4; j++) gede.nwi[j]=pnede->nwi[j];
  gede.nsl = pnede->nsl;
  gede.nwl = pnede->nwl;
  gede.fwl = pnede->fwl;
  gede.xmad= pnede->xmad;
  gede.ymad= pnede->ymad;
  gede.zmad= pnede->zmad;
  for(int j=0; j<4; j++) gede.y1w[j]=pnede->y1w[j];
  for(int j=0; j<4; j++) gede.y2w[j]=pnede->y2w[j];
  gede.dedx = pnede->dedx;
  gede.gcop = pnede->gcop;
  gede.noise= pnede->noise;
  gede.ares = pnede->ares;

  char name[9];
  strncpy(name,pnede->hwc,9);
  if(pnede->cmp == 8) {
    name[8]='\0';
    strncpy(gede.hwc,name,9);
  }
  if(pnede->cmp == 9) {
    name[5]='\0';
    strncpy(gede.hwc,name,6);
  }

  char buf[4];
  strncpy(buf,pnede->gvol,4);
  strncpy(gede.gvol,buf,4);

  ArtePointer<GEDE>::append(gede);

  return;
}

// update GESL -> GEDE pointers
void MuGeoPoint2()
{
  for ( ArteTableIterator<GESL> isl = ArteTable<GESL>::begin(); 
        isl != ArteTable<GESL>::end();
        ++isl ) {
    int   cmp  = (*isl)->cmp;
    if(cmp == 8 || cmp == 9) {
      (*isl)->fpl=0;
      (*isl)->npl=0;
    }
  }
// loops over GEDE
  int gede=0;
  for ( ArteTableIterator<GEDE> iv = ArteTable<GEDE>::begin(); 
        iv != ArteTable<GEDE>::end();
        ++iv ) {
    gede++;
    int cmp = (*iv)->cmp;
    if(cmp == 8 || cmp == 9) {
      ArtePointer<GESL> gesl = (*iv)->gesl;
      if(gesl->fpl == 0) gesl->fpl=gede;
      gesl->npl += 1;
    }
  }
  return;
}
}


