
// Boris Fominykh  06.05.2002
// MuSetMajor sets major as a muon detector time from kumac or an actual time otherwise


// mode=0:  SETENV MUON_HOTS_TIME          21:16_12/03/2002
//          SETENV MUON_HOTS_MAJOR         101137717 - has higher priority
// mode=1:  SETENV MUON_ALIGN_TIME         21:16_12/03/2002
//          SETENV MUON_ALIGN_MAJOR        101137717 - has higher priority
// mode=2:  SETENV MUON_EFF_TUBE_TIME      21:16_12/03/2002
//          SETENV MUON_EFF_TUBE_MAJOR     101137717 - has higher priority
// mode=3:  SETENV MUON_GEO_EFF_TUBE_TIME  21:16_12/03/2002
//          SETENV MUON_GEO_EFF_TUBE_MAJOR 101137717 - has higher priority
// mode=4:  SETENV MUON_EFF_PAD_TIME       21:16_12/03/2002
//          SETENV MUON_EFF_PAD_MAJOR      101137717 - has higher priority
// mode=5:  SETENV MUON_GEO_EFF_PAD_TIME   21:16_12/03/2002
//          SETENV MUON_GEO_EFF_PAD_MAJOR  101137717 - has higher priority
// mode=6:  SETENV MUON_EFF_PIX_TIME       21:16_12/03/2002
//          SETENV MUON_EFF_PIX_MAJOR      101137717 - has higher priority
// mode=7:  SETENV MUON_GEO_EFF_PIX_TIME   21:16_12/03/2002
//          SETENV MUON_GEO_EFF_PIX_MAJOR  101137717 - has higher priority
// it prints the output value if ipr=1

// MuSetMinor sets minor from kumac or 0 otherwise
// mode=0:  SETENV MUON_HOTS_MINOR         0
// mode=1:  SETENV MUON_ALIGN_MINOR        0
// mode=2:  SETENV MUON_EFF_TUBE_MINOR     0
// mode=3:  SETENV MUON_GEO_EFF_TUBE_MINOR 0
// mode=4:  SETENV MUON_EFF_PAD_MINOR      0
// mode=5:  SETENV MUON_GEO_EFF_PAD_MINOR  0
// mode=6:  SETENV MUON_EFF_PIX_MINOR      0
// mode=7:  SETENV MUON_GEO_EFF_PIX_MINOR  0
// it prints the output value if ipr=1

#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <iostream.h>
#include <time.h>
#include "arte/arte.hh"

extern "C"
{
  int MuSetMajor(int mode,int ipr)
  {
    int check = 0;
// read major from kumac, it's higher priority 
    char chmajor[128];
    if(mode == 0 && getenv("MUON_HOTS_MAJOR") != NULL)
    {
      check=1;
      strncpy(chmajor,getenv("MUON_HOTS_MAJOR"),128);
    }
    if(mode == 1 && getenv("MUON_ALIGN_MAJOR") != NULL)
    {
      check=2;
      strncpy(chmajor,getenv("MUON_ALIGN_MAJOR"),128);
    }
    if(mode == 2 && getenv("MUON_EFF_TUBE_MAJOR") != NULL)
    {
      check=3;
      strncpy(chmajor,getenv("MUON_EFF_TUBE_MAJOR"),128);
    }
    if(mode == 3 && getenv("MUON_GEO_EFF_TUBE_MAJOR") != NULL)
    {
      check=4;
      strncpy(chmajor,getenv("MUON_GEO_EFF_TUBE_MAJOR"),128);
    }
    if(mode == 4 && getenv("MUON_EFF_PAD_MAJOR") != NULL)
    {
      check=5;
      strncpy(chmajor,getenv("MUON_EFF_PAD_MAJOR"),128);
    }
    if(mode == 5 && getenv("MUON_GEO_EFF_PAD_MAJOR") != NULL)
    {
      check=6;
      strncpy(chmajor,getenv("MUON_GEO_EFF_PAD_MAJOR"),128);
    }
    if(mode == 6 && getenv("MUON_EFF_PIX_MAJOR") != NULL)
    {
      check=7;
      strncpy(chmajor,getenv("MUON_EFF_PIX_MAJOR"),128);
    }
    if(mode == 7 && getenv("MUON_GEO_EFF_PIX_MAJOR") != NULL)
    {
      check=8;
      strncpy(chmajor,getenv("MUON_GEO_EFF_PIX_MAJOR"),128);
    }
// decode major
    if(check > 0)
    {
      int major = 0;
      char numb[11] = "0123456789";
      for(int j=0; j<10; j++) 
      {
        for(int i=0; i<10; i++) 
        {
          if(chmajor[j] == numb[i]) major = major*10 + i;
        }
      }
      if(ipr == 1)
      {
        cout << "MuSetMajor: set major " << major  << endl;       
      }    
      return major;
    }

    time_t timesec = time(NULL);
    check = 0;
// read time from kumac
    char timech[128];
    if(mode == 0 && getenv("MUON_HOTS_TIME") != NULL)
    {
      check=1;
      strncpy(timech,getenv("MUON_HOTS_TIME"),128);
    }
    if(mode == 1 && getenv("MUON_ALIGN_TIME") != NULL)
    {
      check=2;
      strncpy(timech,getenv("MUON_ALIGN_TIME"),128);
    }
    if(mode == 2 && getenv("MUON_EFF_TUBE_TIME") != NULL)
    {
      check=3;
      strncpy(timech,getenv("MUON_EFF_TUBE_TIME"),128);
    }
    if(mode == 3 && getenv("MUON_GEO_EFF_TUBE_TIME") != NULL)
    {
      check=4;
      strncpy(timech,getenv("MUON_GEO_EFF_TUBE_TIME"),128);
    }
    if(mode == 4 && getenv("MUON_EFF_PAD_TIME") != NULL)
    {
      check=3;
      strncpy(timech,getenv("MUON_EFF_PAD_TIME"),128);
    }
    if(mode == 5 && getenv("MUON_GEO_EFF_PAD_TIME") != NULL)
    {
      check=4;
      strncpy(timech,getenv("MUON_GEO_EFF_PAD_TIME"),128);
    }
    if(mode == 6 && getenv("MUON_EFF_PIX_TIME") != NULL)
    {
      check=3;
      strncpy(timech,getenv("MUON_EFF_PIX_TIME"),128);
    }
    if(mode == 7 && getenv("MUON_GEO_EFF_PIX_TIME") != NULL)
    {
      check=4;
      strncpy(timech,getenv("MUON_GEO_EFF_PIX_TIME"),128);
    }

    if(check > 0)
    {
// decode time and fill the structure
      struct tm timest;
      char num[11] = "0123456789";
// year
      int year = 0;
      int ifact = 10000;
      for(int i=0; i<4; i++)
      {
        ifact = ifact / 10;
        for(int j=0; j<10; j++)
        {
          if(timech[12+i] == num[j]) year += j * ifact;
        }
      }
      timest.tm_year = year - 1900;

// month,day,hour,min 
      int month = 0;
      int day   = 0;
      int hour  = 0;
      int min   = 0;
      ifact = 100;
      for(int i=0; i<2; i++)
      {
        ifact = ifact / 10;
        for(int j=0; j<10; j++)
        {
          if(timech[9+i] == num[j]) month += j * ifact;
          if(timech[6+i] == num[j]) day   += j * ifact;
          if(timech[3+i] == num[j]) min   += j * ifact;
          if(timech[i]   == num[j]) hour  += j * ifact;
        }
      }
      timest.tm_mon  = month-1;
      timest.tm_mday = day;
      timest.tm_hour = hour;
      timest.tm_min  = min;
      timest.tm_sec  = 0;

// convert time 
      timesec = mktime(&timest);
    }
    if(ipr == 1)
    {
      char* tmch = ctime(&timesec);
      cout << "MuGetMajor: set major= " << timesec << " = " << tmch << endl;       
    }    
    return timesec;
  }


  // ****************************

  int MuSetMinor(int mode,int ipr)
  {
    int minor = 0;
    int check = 0;
// read minor from kumac
    char chminor[128];
    if(mode == 0 && getenv("MUON_HOTS_MINOR") != NULL)
    {
      check=1;
      strncpy(chminor,getenv("MUON_HOTS_MINOR"),128);
    }
    if(mode == 1 && getenv("MUON_ALIGN_MINOR") != NULL)
    {
      check=2;
      strncpy(chminor,getenv("MUON_ALIGN_MINOR"),128);
    }
    if(mode == 2 && getenv("MUON_EFF_TUBE_MINOR") != NULL)
    {
      check=3;
      strncpy(chminor,getenv("MUON_EFF_TUBE_MINOR"),128);
    }
    if(mode == 3 && getenv("MUON_GEO_EFF_TUBE_MINOR") != NULL)
    {
      check=4;
      strncpy(chminor,getenv("MUON_GEO_EFF_TUBE_MINOR"),128);
    }
    if(mode == 4 && getenv("MUON_EFF_PAD_MINOR") != NULL)
    {
      check=5;
      strncpy(chminor,getenv("MUON_EFF_PAD_MINOR"),128);
    }
    if(mode == 5 && getenv("MUON_GEO_EFF_PAD_MINOR") != NULL)
    {
      check=6;
      strncpy(chminor,getenv("MUON_GEO_EFF_PAD_MINOR"),128);
    }
    if(mode == 6 && getenv("MUON_EFF_PIX_MINOR") != NULL)
    {
      check=7;
      strncpy(chminor,getenv("MUON_EFF_PIX_MINOR"),128);
    }
    if(mode == 7 && getenv("MUON_GEO_EFF_PIX_MINOR") != NULL)
    {
      check=8;
      strncpy(chminor,getenv("MUON_GEO_EFF_PIX_MINOR"),128);
    }

// decode minor
    if(check > 0)
    {
      char numb[11] = "0123456789";
      for(int j=0; j<3; j++) 
      {
        for(int i=0; i<10; i++) 
        {
          if(chminor[j] == numb[i]) minor = minor*10 + i;
        }
      }
    }
    if(ipr == 1) cout << "MuSetMinor: set minor= " << minor << endl;       
    return minor;
  }
}


