#ifndef MuDbAlignNew_h
#define MuDbAlignNew_h 1

//## Class: MuDbAlignNew
//      /**Author:        Boris Fominykh
//
//      Date:             May 6th, 2002
//
//      Class:            MuDbAlignNew
//
//      Base Class:       MuDbTable
//
//      Description:
//      This class is for operations with alignment constants in DB MUON_NEW*/

#include "murec/MuDbTable.h"
#include <set>
#include "murec/MuAlignNew.h"

typedef unsigned short Word;
typedef unsigned int   LWord;

/////////////////////////////////////
static bool
operator<(const MuAlignNew c1, const MuAlignNew c2)
{
      return c1.nx1 < c2.nx1;
}
/////////////////////////////////////

class MuDbAlignNew : public MuDbTable
{
  public:
    //## Constructor
           MuDbAlignNew();
    //## Destructor
           ~MuDbAlignNew();

    //public methods
      //        /** Initialization */
      void Ini();
      //        /**Clear the object*/
      void Clear();
      //        /**Read the table as it's defined in kumac */
      int Read();
      //        /**Read the table from DB */
      int ReadDB();
      //        /**Read the table from ascii-file*/
      int ReadFile();
      //        /**Print the alignment constants from temporary space*/
      void Print();
      //        /**Get the pointer to the container with alignment constants, */
      //        /**  inpar[4] = {sl,lay,ud,nx} */
      const MuAlignNew* GetPar(int inpar[4]);

    //## Get and Set Operations for Class Attributes

    int    Valid;

  protected:

  private:

    static const Word SlM  = 4;
    static const Word LayM = 4;
    static const Word UdM  = 2;

  // number of collected parameter containers
    Word Ncont[SlM][LayM][UdM];
  // containers
    set<MuAlignNew> Cont[SlM][LayM][UdM];

    //        /**Add the next container to object*/
      int Add(MuAlignNew* const);
};

#endif

