#ifndef MuDbChamber_h
#define MuDbChamber_h 1

//## Class: MuDbChamber
//      /**Author:        Boris Fominykh
//
//      Date:             December 26, 1999
//        updated         May 6th, 2002  - DB MUON_NEW instead of MUON_DB
//
//      Class:            MuDbChamber
//
//      Base Class:       none
//
//      Description:
//      This class is a base class for configuration of muon chambers*/

class MuDbChamber
{
  public:
    //## Constructor
           MuDbChamber();
    //## Destructor
           ~MuDbChamber();

    //public methods

    //## Get and Set Operations for Class Attributes
      void setDBname(char* name);
      char* getDBname();
      void setKTstatus(int value);
      int  getKTstatus();
      void setMajor(int value);
      int  getMajor();
      void setMinor(int value);
      int  getMinor();
      void setEndian();
      int  getEndian();

  protected:

    char DBname[256];
    int KTstatus;
    int Major;
    int Minor;
    int Endian;

  private:

};

//## Get and Set Operations for Class Attributes (inline)

inline char* MuDbChamber::getDBname()
{
  return DBname;
}

inline void MuDbChamber::setKTstatus(int value)
{
  KTstatus=value;
}

inline int MuDbChamber::getKTstatus()
{
  return KTstatus;
}

inline void MuDbChamber::setMajor(int value)
{
  Major=value;
}

inline int MuDbChamber::getMajor()
{
  return Major;
}

inline void MuDbChamber::setMinor(int value)
{
  Minor=value;
}

inline int MuDbChamber::getMinor()
{
  return Minor;
}

inline int MuDbChamber::getEndian()
{
  return Endian;
}

#endif
