#ifndef MuDbConfig_h
#define MuDbConfig_h 1

//## Class: MuDbConfig
//      /**Author:        Boris Fominykh
//
//      Date:             December 16, 1999
//
//      Class:            MuDbConfig
//
//      Base Class:       MuDbTable
//
//      Description:
//      This class is for cable configuration table in muon DB*/

#include "murec/MuDbTable.h"
typedef unsigned short Word;

class MuDbConfig : public MuDbTable
{
  public:
    //## Constructor
           MuDbConfig();
    //## Destructor
           ~MuDbConfig();

    //public methods
      //        /**Initialization*/
      void Ini();
      //        /**Create cable configuration table in DB from temporary space*/
      int Create();
      //        /**Read the cable configuration table to temporary space from ascii-file*/
      int ReadFile(int* ncable);
      //        /**Read the cable configuration table to temporary space from DB*/
      int Read(int* ncable);
      //        /**Print cable configuration table from temporary space*/
      void Print();
      //        /**Get all cable atributes*/
      int GetCabl(int* ncab,char* cablename,Word* fed,Word* ncab);
      //        /**Get the cable connection*/
      int GetConn(char* cablename,Word* fed,Word* ncab);
      //        /**Get the cable name*/
      int GetName(Word* fed,Word* ncab,char* cablename);
      //        /**release the temporary space*/
      void Release();

  protected:

  private:

      int SizeS; 
      int SizeMem; 
      char* Name;
      Word* Fed;
      Word* Ncab;
      int SizeW; 
    static const int SizeWQ = 500; 
      char* NameW;
      Word* FedW;
      Word* NcabW;

    //        /**Add the next table line to temporary space*/
      int Add(char* name,Word fed,Word ncab);
    //        /**Write the table from temporary space to DB*/
      int Write();
};

#endif





