#ifndef MuDbEffPad_h
#define MuDbEffPad_h 1

//## Class: MuDbEffPad
//      /**Author:        Boris Fominykh
//
//      Date:             May  6th, 2002
//
//      Class:            MuDbEffPad
//
//      Base Class:       MuDbTable
//
//      Description:
//      This class is to read the pad efficiencies from DB MUON_NEW*/

#include "murec/MuDbTable.h"
#include <set>
#include "murec/MuEffPad.h"

typedef unsigned short Word;
typedef unsigned int   LWord;

/////////////////////////////////////
static bool
operator<(const MuEffPad c1, const MuEffPad c2)
{
      return c1.key <= c2.key;
}
/////////////////////////////////////

class MuDbEffPad : public MuDbTable
{
  public:
    //## Constructor
           MuDbEffPad();
    //## Destructor
           ~MuDbEffPad();

    //public methods
      //        /** Initialization */
      void Ini(int rormc);
      //        /**Clear the object*/
      void Clear();
      //        /**Read the table as it's defined in kumac */
      int Read();
      //        /**Read the table from DB */
      int ReadDB();
      //        /**Read the table from ascii-file*/
      int ReadFile();
      //        /**Print the efficiencies collected in set */
      void Print();
      //        /**Get the efficiency */
      const float GetEff(int gede,int nrow,int npad);

    //## Get and Set Operations for Class Attributes
      void MuDbEffPad::setRorMC(int value);

    int    Valid;
    int    RorMC;      // 0- real measured efficiency, 1- MC efficiency

  protected:

  private:

    static const Word SlM  = 2;
    static const Word UdM  = 2;

  // number of collected containers
    Word Ncont[SlM][UdM];
  // set of containers
    set<MuEffPad> Cont[SlM][UdM];

  //        /**Add the next container to object*/
    int Add(MuEffPad* con);
};

//## Get and Set Operations for Class Attributes (inline)

inline void MuDbEffPad::setRorMC(int value)
{
  RorMC=value;
}

#endif

