
// Boris Fominykh 6.05.2002
// returns efficiency of pads

#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <iostream.h>
#include <iomanip.h>

#include "arte/arte.hh"
#include "arte/ArteMessage.hh"

#include "murec/MuDbEffPad.h"

  static MuDbEffPad EffPR;
  static MuDbEffPad EffPMC;
  static int First = 0;

extern "C"
{
  void mueffp_(int* gede,int* row,int* pad,float* eff)
  {
// initialization in first call
    if(First == 0)
    {
      First = 1;

      EffPR.Ini(0);
      int rr = EffPR.Read();
      if(rr != 0)
      {
	arteMsg << "mueffp: EffPR.Read() return= " << rr << endl;
        arteMsg.error();
        *eff = -1.;
        return;
      }
      EffPR.Print();

      EffPMC.Ini(1);
      int rm = EffPMC.Read();
      if(rm != 0)
      {
	arteMsg << "mueffp: EffPMC.Read() return= " << rm << endl;
        arteMsg.error();
        *eff = -1.;
        return;
      }
      EffPMC.Print();
    }

// check that objects are initialized
    if(EffPR.Valid != 1 || EffPMC.Valid != 1)
    {
      arteMsg << "mueffp: objects are not initialized " << EffPR.Valid << " " << EffPMC.Valid << endl;
      arteMsg.error();
      *eff = -1.;
      return;
    }

// get efficiency
    const float efr = EffPR.GetEff(*gede,*row,*pad);
    const float efm = EffPMC.GetEff(*gede,*row,*pad);
    float ef = 0.;
    if(efm > 1.e-5) ef=efr/efm;
    if(ef > 1.) ef=1.;
    *eff = ef;

    // cout << "mueffp: gede " << *gede << " row " << *row << " pad " << *pad;
    // cout << " efr= " << efr << " efm= " << efm << " eff " << ef << endl;

    return;
  }
}
