
// Boris Fominykh 6.05.2002
// returns efficiency of wires

#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <iostream.h>
#include <iomanip.h>

#include "arte/arte.hh"
#include "arte/ArteMessage.hh"

#include "murec/MuDbEffTube.h"

  static MuDbEffTube EffTR;
  static MuDbEffTube EffTMC;
  static int First = 0;

extern "C"
{
  void mueffw_(int* gede,int* wir,float* eff)
  {
// initialization in first call
    if(First == 0)
    {
      First = 1;

      EffTR.Ini(0);
      int rr = EffTR.Read();
      if(rr != 0)
      {
	arteMsg << "mueffw: EffTR.Read() return= " << rr << endl;
        arteMsg.error();
        *eff = -1.;
        return;
      }
      EffTR.Print();

      EffTMC.Ini(1);
      int rm = EffTMC.Read();
      if(rm != 0)
      {
	arteMsg << "mueffw: EffTMC.Read() return= " << rm << endl;
        arteMsg.error();
        *eff = -1.;
        return;
      }
      EffTMC.Print();

    }

// check that objects are initialized
    if(EffTR.Valid != 1 || EffTMC.Valid != 1)
    {
      arteMsg << "mueffw: objects are not initialized" << endl;
      arteMsg.error();
      *eff = -1.;
      return;
    }

// get efficiency
    const float efr = EffTR.GetEff(*gede,*wir);
    const float efm = EffTMC.GetEff(*gede,*wir);
    float ef = 0.;
    if(efm > 1.e-5) ef=efr/efm;
    if(ef > 1.) ef=1.;
    *eff = ef;

    // cout << "mueffw: gede " << *gede << " wir " << *wir;
    // cout << " efr= " << efr << " efm= " << efm << " eff " << ef << endl;

    return;
  }
}
