
* B.Fominykh  7.11.96
* the program of the MUREC-A package
* creates temporary working tables for muon reconstruction
C
      SUBROUTINE MURBWT
C-    =================
      IMPLICIT NONE
*
#include "murec/MUCTAB.fi"
#include "arte/Arte.fi"

#include "arte/Arte.ff"
C----+===1=========2=========3=========4=========5=========6=========7==********
*
* table of muon hits - MUHT
*  1 I - JLMHH - link to table HITB
*  2 I - RLAY  - reconstruction layer
*  3 I - MUSL  - muon superlayer
*  4 I - LAY   - muon layer inside superlayer
*  5 I - IHTP  - hit type (1-wire,2-pad,3-pixel)
*  6 R - Z     - z-coordinate
*  7 R - SINR  - sin_rotation
*  8 R -  D,X  - d for wires and x for pads and pixels
*  9 R - Y1,Y  - Y_min for wires and y for pads and pixels
* 10 R - Y2,0. - Y_max for wires and 0. for pads and pixels
* 11 R - SIG1  - sigma_d for wires and sigma_x for pads and pixels
* 12 R - SIG2  - 0. for wires and sigma_y for pads and pixels
* 13 I - NCLUS - cluster number
* 14 I - NMCTR - number of MC-tracks produced this hit
* 15 I - MCT1  - 1st MC track number
* 16 I - MCT2  - 2nd MC track number
* 17 I - MCT3  - 3rd MC track number
* 18 I - MCT4  - 4th MC track number
* 19 I - MCT5  - 5th MC track number
* 20 I - STAT  - status of hit (0-dead,1-active)
*
* max number of muon hits
      NMUHMX=NMHMXP
      CALL MMBWRK(JTMP9,0,20,500)
*
*
* table of muon clusters - MUCL
*  1 I - JSCL  - status of cluster (0-dead,1-active)
*  2 I - LATR  - inner layer number for grouth of tree
*  3 I - MUSL  - muon superlayer
*  4 I - LAY   - muon layer inside superlayer
*  5 I - ICTP  - cluster type (1-wire,2-pad,3-pixel)
*  6 R - Z     - z-coordinate
*  7 R - SINR  - sin_rotation
*  8 R -  D,X  - d for wires and x for pads and pixels
*  9 R - Y1,Y  - Y_min for wires and y for pads and pixels
* 10 R - Y2,0. - Y_max for wires and 0. for pads and pixels
* 11 R - SIG1  - sigma_d for wires and sigma_x for pads and pixels
* 12 R - SIG2  - 0. for wires and sigma_y for pads and pixels
* 13 I - NHTCL - number of hits in cluster
* 14 I - NCLUS - number of cluster in the reco layer
* 15 I - JLHST - link to 1st hit of cluster
* 16 I - JLHLS - link to last hit of cluster
* 17 I - ISEED - seed number
*
* max number of muon clusters
      NMUCMX=NMHMXP
      CALL MMBWRK(JTMP8,0,17,500)
*
* temporary working table for tree branchs
*  1 I -  ITRST - branch status (>0 - active or =0 - dead)
*  2 F -  EST   - estimator
*  3 I -  NHIT  - accumulated number of hits
*  4 F -  SCHI  - sum of hit chi**2
*  5 F - Z0  - parameter of track
*  6 F - par1 =CX- parameter of line fit x=tx*(z-z0)+cx
*  7 F - par2 =CY- parameter of line fit y=ty*(z-z0)+cy
*  8 F - par3 =TX- parameter of line fit x=tx*(z-z0)+cx
*  9 F - par4 =TY- parameter of line fit y=ty*(z-z0)+cy
* 10 F -  COV11 - covariance
* 11 F -  COV12 - covariance
* 12 F -  COV13 - covariance
* 13 F -  COV14 - covariance
* 14 F -  COV21 - covariance
* 15 F -  COV22 - covariance
* 16 F -  COV23 - covariance
* 17 F -  COV24 - covariance
* 18 F -  COV31 - covariance
* 19 F -  COV32 - covariance
* 20 F -  COV33 - covariance
* 21 F -  COV34 - covariance
* 22 F -  COV41 - covariance
* 23 F -  COV42 - covariance
* 24 F -  COV43 - covariance
* 25 F -  COV44 - covariance
* 26 I -   IHBP - pointer to clust 1
* .....................................
* 75 I -   IHBP - pointer to clust 50
*
* length of constant part
      LCMUTR=25
* max number of clusters per branch
      NHMUTR=50
* max number of branchs in the tree
      NBMUTR=NBMTRP
* first free branch
      IFREE=1
*
      CALL MMBWRK(JTMP7,0,75,300)
*
 200  CONTINUE
      RETURN
      END




