*
* B.Fominykh  16.08.99
*
* the program of the MUREC-A package
* z-positions of existing detectors
* reco layers: 10+8+10+10=38
* 
      SUBROUTINE MURZDIN
*     ==================
      IMPLICIT NONE
      INTEGER IV,ICMP,ISL,MGSL,MUSL,LAY,I,IJ,IUD,IR,IRZ
      REAL ZD1,ZD2,DZ,YD1,YD2
      REAL Z1(15),Z2(15)
*
#include "murec/MUCZDT.fi"
#include "arte/Arte.fi"
#include "auto/GEO.fi"

#include "arte/Arte.ff"
#include "auto/GEO.ff"
C----+===1=========2=========3=========4=========5=========6=========7==********
*
      DO I=1,15
        Z1(I)=10000.
        Z2(I)=0.
      ENDDO
      DO I=1,NMRLAY
        ZMUDT1(I)=0.
        ZMUDT2(I)=0.
      ENDDO

* number of superlayers
      MGSL = IQ(JGESL+2)
* preliminary Z regions - loops over all  superlayers
      DO 10 ISL = 1,MGSL
* type of superlayer, muon types (8 and 9) are only acceptable
        ICMP = IGESL_CMP(ISL)
        IF(ICMP.NE.8.AND.
     +     ICMP.NE.9) GOTO 10
* muon superlayer number
        MUSL = IGESL_NSL(ISL)
* loops over detectors inside superlayer
        DO 5 IJ = 1, IGESL_NPL(ISL)
          IV = IGESL_FPL(ISL)+IJ-1
* layer number inside superlayer
          LAY=IGEDE_LAY(IV)
          IF(LAY.LT.1.OR.LAY.GT.4) GOTO 5
          IF(MUSL.LT.3) THEN
            I=4*(MUSL-1)+LAY
          ELSE
            I=2*(MUSL+1)+LAY
          ENDIF 
* get parameters of volume IV
          ZD1 =  FGEDE_ZMIN(IV)
          ZD2 =  FGEDE_ZMAX(IV)
          YD1 =  FGEDE_YMIN(IV)
          YD2 =  FGEDE_YMAX(IV)
* UpDown (0 - up, 1 - down)
          IUD=0
          IF(ABS(YD1).GT.ABS(YD2)) IUD=1
* 
          IF(MUSL.EQ.1) THEN
            IF(LAY.EQ.1.AND.IUD.EQ.0) IRZ=1
            IF(LAY.EQ.1.AND.IUD.EQ.1) IRZ=2
            IF(LAY.GT.1) IRZ=LAY+1
          ENDIF
          IF(MUSL.EQ.2) IRZ=LAY+5
          IF(MUSL.GE.3) THEN
            IF(LAY.EQ.1) IRZ=MUSL*3+IUD+1
            IF(LAY.EQ.2) IRZ=MUSL*3+3
          ENDIF
          IF(ZD1.LT.Z1(IRZ)) Z1(IRZ)=ZD1
          IF(ZD2.GT.Z2(IRZ)) Z2(IRZ)=ZD2

  5     CONTINUE
 10   CONTINUE

*      print*,' '
*      PRINT 1001, (Z1(I),I=1,15)
*      WRITE(LLOGF,1001) (Z1(I),I=1,15)
* 1001 FORMAT(2X,'Z1:',10F7.1)
*      print*,' '
*      PRINT 1002, (Z2(I),I=1,15)
*      WRITE(LLOGF,1002) (Z2(I),I=1,15)
* 1002 FORMAT(2X,'Z2:',10F7.1)
*      print*,' '

* reconstruction layers
      DO 30 IRZ=1,15
        MUSL=1
        IF(IRZ.GT.5.AND.IRZ.LE.9)  MUSL=2
        IF(IRZ.GT.9.AND.IRZ.LE.12) MUSL=3
        IF(IRZ.GT.12)              MUSL=4
* tube and pixel chambers
        IF(IRZ.EQ.10.OR.IRZ.EQ.11.OR.
     +     IRZ.EQ.13.OR.IRZ.EQ.14) GOTO 15
        IR=2*IRZ-1
        IF(IRZ.EQ.12) IR=27
        IF(IRZ.EQ.15) IR=37
        ZMUDT1(IR)  = Z1(IRZ)
        ZMUDT2(IR)  = 0.5*(Z1(IRZ)+Z2(IRZ))
        ZMUDT1(IR+1)= ZMUDT2(IR)
        ZMUDT2(IR+1)= Z2(IRZ)
        MUSLDT(IR)  =MUSL
        MUSLDT(IR+1)=MUSL
 15   CONTINUE
* pad chambers
        IF(IRZ.EQ.10.OR.IRZ.EQ.11.OR.
     +     IRZ.EQ.13.OR.IRZ.EQ.14) THEN
          IR=4*IRZ-21
          IF(IRZ.GT.12) IR=IR-2
          DZ=0.25*(Z2(IRZ)-Z1(IRZ))
          ZMUDT1(IR)  = Z1(IRZ)
          ZMUDT2(IR)  = Z1(IRZ)+DZ
          ZMUDT1(IR+1)= ZMUDT2(IR)
          ZMUDT2(IR+1)= 0.5*(Z1(IRZ)+Z2(IRZ))
          ZMUDT1(IR+2)= ZMUDT2(IR+1)
          ZMUDT2(IR+2)= ZMUDT1(IR+2)+DZ
          ZMUDT1(IR+3)= ZMUDT2(IR+2)
          ZMUDT2(IR+3)= Z2(IRZ)
          DO I=0,3
            MUSLDT(IR+I)=MUSL
          ENDDO
        ENDIF
 30   CONTINUE

*      PRINT 1011, (ZMUDT1(I),I=1,NMRLAY)
*      WRITE(LLOGF,1011) (ZMUDT1(I),I=1,NMRLAY)
* 1011 FORMAT(2X,'ZMUDT1:',10F7.1)
*      print*,' '
*      PRINT 1012, (ZMUDT2(I),I=1,NMRLAY)
*      WRITE(LLOGF,1012) (ZMUDT2(I),I=1,NMRLAY)
* 1012 FORMAT(2X,'ZMUDT2:',10F7.1)
*      print*,' '
*      PRINT 1013, (MUSLDT(I),I=1,NMRLAY)
*      WRITE(LLOGF,1013) (MUSLDT(I),I=1,NMRLAY)
* 1013 FORMAT(2X,'MUSLDT:',40I2)
*      print*,' '

      RETURN
      END
