*-- Author :    Rainer Mankel   01/06/96
*-- Updated: Alexander Lanyov   24/02/02: Additional points for photons

      subroutine di1mc(imc,islsta,islend,chopt)

*     **** display MC track
      implicit none
#include "arte/Arte.fi"

#include "pris/zgraf.fi"
      integer islsta, islend, iso, ipl, imc, indx_mimp, iso1, iso9, dso
      integer nsomax, nprim, mtcp, bver
      parameter (nsomax=900)
      integer isl, imim, npoint, segment, segment_begin(3),
     +     segment_size(3), v, gcode, magflag(nsomax), ipoint,
     +     startpoint, endpoint, last_mimp, mimp_prim_sort(nsomax)
      real xxx(nsomax), yyy(nsomax), zzz(nsomax), oin(nsomax), wh(3), 
     +     ltyp, lwid, xx, yy, txci, p
      logical charged,spl
      character*(*) chopt
      character*1 cgraph
      character*10 cnpart
      integer message_id_1
#include "auto/MIMP.fi"
#include "auto/MTRA.fi"
#include "auto/MTCP.fi"
#include "auto/GEO.fi"
#include "auto/HITB.fi"
#include "auto/MVER.fi"
#include "auto/TOPP.fi"
#include "gean/ZGESL.fi"
      integer maxgcode
      parameter (maxgcode=60)
      character*8 cn(maxgcode)
      data cn / '[g]','e^+!','e^-!',' ','[m]^+!',
     +     '[m]^-!',' ','[p]^+!','[p]^-!','K^0!?L!',
     +     'K^+!','K^-!','n','p','p&^-!',
     +     'K^0!?S!',4*' ',
     +     4*' ','n&^-!',
     +     5*' ',
     +     2*' ','[t]^+!','[t]^-!','D^+!',
     +     'D^-!','D^0!','D&_^0','D?s!^+!','D?s!^-!',
     +     5*' ',
     +     3*' ','J/[y]',' ',
     +     'B^+!','B^-!','B^0!','B&_^0','B?s!',
     +     'B&_?s!',4*' '/
      data message_id_1 /1/
      save cn
      save message_id_1

#include "arte/Arte.ff"
#include "auto/MIMP.ff"
#include "auto/MTRA.ff"
#include "auto/MTCP.ff"
#include "auto/GEO.ff"
#include "auto/HITB.ff"
#include "auto/MVER.ff"
#include "auto/TOPP.ff"

*     **** polyline/curve option
      if (lsplinezg) then
         cgraph = 'C'
      else
         cgraph = 'L'
      endif

*     **** check id
      gcode = itopp_gean(omtra_topp(imc))

      if (
     +     (gcode.eq.8)  .or. (gcode.eq.9)
     +     .or. (gcode.eq.11) .or. (gcode.eq.12)
     +     .or. (gcode.eq.14) .or. (gcode.eq.15)
     +     .or. (gcode.eq.2)  .or. (gcode.eq.3)
     +     .or. (gcode.eq.5)  .or. (gcode.eq.6)
     +     ) then
         charged = .true.
         ltyp = 1.
      elseif (gcode.eq.1) then
         charged = .false.      ! gamma
         ltyp = 12.

      elseif (gcode.eq.10.or.gcode.eq.16) then
         charged = .false.      ! K0L, K0S
         ltyp = 15.

      elseif (gcode.eq.13 .or. gcode.eq.25) then
         charged = .false.      ! n, n~
         ltyp = 13.

      elseif (gcode.eq.53.or.gcode.eq.54 ! b0, b0=
     +        .or.gcode.eq.37.or.gcode.eq.38 ! d0, d0=
     +        .or.gcode.eq.49) then ! J/Psi
         charged = .false.
         ltyp = 14.
      else
         go to 999
      endif

      if ((.not.charged) .and. (.not.lneutzg)) go to 999

*     **** printing headline
      if (index(chopt,'P').gt.0) then
         write(*,'(2x,a6,a8  ,2a9  ,2a8  ,''('',a8  ,'')'',a8  )')
     +        'imim', ' z ', ' x0 ', ' y0 ', ' mx ', ' my ', ' myp ',
     +        ' p '
      endif


      npoint = 0
      last_mimp = 0

*     **** find vertex
      if (lmverzg) then
         if (omtra_bver(imc).gt.0.and.omtra_bver(imc).le.iq(jmver+2))
     +        then
            v = omtra_bver(imc)
            npoint = npoint + 1

*           **** 3D point
            wh(1) = fmver_x(v)
            wh(2) = fmver_y(v)
            wh(3) = fmver_z(v)

*           **** projection
            call dipro(wh,xxx(npoint),yyy(npoint))
            zzz(npoint) = wh(3)
            oin(npoint) = -100.

            if (index(chopt,'P').gt.0) then
               write(*,'(2x,i6,3f9.3,i6)')
     +              v,fmver_x(v), fmver_y(v), fmver_z(v), omver_btra(v)
            endif
         else
            print *,' () di1mc: no vertex for mc=', imc
         endif
      endif

*     **** locate the mimps: 
*     **** use temporary array because we must revert the z order
      nprim = 0

      do 20 iso=1,9999
         if (iso.eq.1) then
            indx_mimp = pmtra_mimp(imc)
         else
            indx_mimp = xmtra_mimp(indx_mimp)
         endif
         if (indx_mimp.le.0) go to 21
         
         imim = mmtra_mimp(indx_mimp)
         if (imim.le.0.or.imim.gt.iq(jmimp+2)) then
            print *,' () di1mc: invalid imim=',imim,' iq(jmimp+2)=',
     +           iq(jmimp+2)
            stop 'di1mc'
         endif

         ipl = imimp_gede(imim) ! prepare SL check
         if (ipl.gt.iq(jgede+2)) go to 20 ! avoid packed IPLs in ECAL
         isl = ogede_gesl(ipl)
         if (isl.lt.islsta.or.isl.gt.islend) go to 20
         if (modezg.eq.1) then
            if (isl.gt.scmxzg) go to 20
            if (.not.lscopzg(isl)) go to 20
         endif

         if (igesl_cmp(isl).eq.lgesl_ric) go to 20 ! no mimps from RICH

         if (omimp_mtra(imim).eq.0) go to 20 ! no merged points

         if (nprim.ge.nsomax) then
            print *,' () di1mc: overflowing nprim=', nprim,
     +           ' imc=', imc
            go to 21
         endif
         if (last_mimp.eq.0) last_mimp = imim

#ifdef MIMPPRT
         print '((a),i7,(a),f12.3,(a),a4)',
     +        ' mimp located=',imim,' z=',fmimp_z(imim),
     +        ' sl=',hgesl_name(ogede_gesl(imimp_gede(imim))),
     +        ' cmp=',igesl_cmp(isl)
#endif
         nprim = nprim + 1
         mimp_prim_sort(nprim) = imim 

 20   continue                     
      call mepric(message_id_1,1,
     +      'di1mc: overflowing nMimps, part of trajectory not drawn')

      
 21   continue

      if (nprim.gt.0) then
         if (fmimp_z(mimp_prim_sort(1))
     +        .gt.fmimp_z(mimp_prim_sort(nprim))) then ! must revert
            iso1 = nprim
            iso9 = 1
            dso  = -1
         else
            iso1 = 1
            iso9 = nprim
            dso  = 1
         endif
         last_mimp = mimp_prim_sort(iso9)

*        **** access the mimps in rising-z order
         do 30 iso=iso1,iso9,dso
            imim = mimp_prim_sort(iso)
            if (imim.le.0.or.imim.gt.iq(jmimp+2)) then
               print *,' () di1mc: invalid imim=',imim,' iq(jmimp+2)=',
     +              iq(jmimp+2)
               stop 'di1mc'
            endif

            wh(1) = fmimp_x(imim) ! 3D point
            wh(2) = fmimp_y(imim)
            wh(3) = fmimp_z(imim)

            call dipro(wh,xx,yy) ! projection

            if (npoint.ge.nsomax) then
               print *,' () di1mc: overflowing npoint=', npoint,
     +              ' imc=', imc
               go to 31
            endif
            npoint = npoint + 1

            xxx(npoint) = xx
            yyy(npoint) = yy
            zzz(npoint) = wh(3)
            oin(npoint) = fmimp_time(imim)

            if (index(chopt,'P').gt.0) then
               write(*,'(2x,i6,f8.2,2f9.3,2f8.5,''('',f8.5,'')'',f8.3)')
     +              imim,fmimp_z(imim), fmimp_x(imim), fmimp_y(imim),
     +              fmimp_tx(imim), fmimp_ty(imim),
     +              fmimp_ty(imim)/sqrt(1.+fmimp_tx(imim)**2),
     +              fmimp_p(imim)
            endif

 30      continue
 31      continue
      endif

      if (leverzg) then          ! look for end vertex
         if (pmtra_ever(imc).gt.0) then
            if (.not.charged.or.(imtra_flag(imc).ne.5.and.
     +           imtra_flag(imc).ne.6)) then
               v = mmtra_ever(pmtra_ever(imc))
               if (v.le.0.or.v.gt.iq(jmver+2)) then
                  print *,' () di1mc: invalid ever=',v,
     +                 ' mtra=',imc,' flag=',imtra_flag(imc)
                  go to 39
               endif

               if (omver_btra(v).ne.imc) then
                  print *,' () di1mc: invalid vertex point-back ',
     +                 ' imc=', imc,' mver=', v
                  go to 39
               endif

*              **** the following solution is very dissatisfying:
*              **** it is still impossible to tell if a EVER vertex
*              **** is really the decay point of the particle.
*              **** Frequently it is just a point of radiation

               if (last_mimp.gt.0) then ! check if end vertex is really
     +                                  ! downstream of mimp
                  if (fmver_z(v).lt.fmimp_z(last_mimp)) go to 39
               endif

               if (npoint.ge.nsomax) then
                  print *,' () di1mc: overflowing npoint=', npoint,
     +                 ' imc=', imc
                  go to 999
               endif
               npoint = npoint + 1

*              **** 3D point
               wh(1) = fmver_x(v)
               wh(2) = fmver_y(v)
               wh(3) = fmver_z(v)

*              **** projection
               call dipro(wh,xxx(npoint),yyy(npoint))
               zzz(npoint) = wh(3)
               oin(npoint) = 10000.
 39            continue
            endif
         endif
      endif

c=================== Add also mtra->mtcp (MC-Track-Entry-Point in calorimeter)
c A.Lanyov 24.02.2002

      mtcp = omtra_mtcp(imc)
      if (mtcp.gt.0) then
         if (npoint.ge.nsomax) then
            print *,' () di1mc: overflowing npoint=', npoint,
     +           ' imc=', imc
            go to 999
         endif
         npoint = npoint + 1
         
*     **** 3D point
         wh(1) = fmtcp_x(mtcp)
         wh(2) = fmtcp_y(mtcp)
         wh(3) = fmtcp_z(mtcp)
         
*     **** projection
         call dipro(wh,xxx(npoint),yyy(npoint))
         zzz(npoint) = wh(3)
         oin(npoint) = 10000.
 399     continue
      endif

c=================== If still there is only one point, just use mtra->leng
c A.Lanyov 24.02.2002

      if (npoint.eq.1 .and. fmtra_leng(imc).ge.0.) then
         npoint = npoint + 1
         
*     **** 3D point
         bver = omtra_bver(imc)
         p = sqrt(fmtra_px(imc)**2+fmtra_py(imc)**2+fmtra_pz(imc)**2)
         if (bver.gt.0) then
            wh(1) = fmver_x(bver) + fmtra_px(imc)/p*fmtra_leng(imc)
            wh(2) = fmver_y(bver) + fmtra_py(imc)/p*fmtra_leng(imc)
            wh(3) = fmver_z(bver) + fmtra_pz(imc)/p*fmtra_leng(imc)
            
*     **** projection
            call dipro(wh,xxx(npoint),yyy(npoint))
            zzz(npoint) = wh(3)
            oin(npoint) = 10000.
         endif
      endif
c===================
      
      lwid = widmczg
      spl = lsplinezg.and.abs(fmtra_pz(imc)).gt.1
      txci = comczg

      cnpart = ' '
      if (ltypezg) then         ! particle label option
         if (gcode.ge.1.and.gcode.le.maxgcode) then
            cnpart = cn(gcode)
         else
            cnpart = ' '
         endif
      endif

      call ditraj(npoint,xxx,yyy,zzz,oin,lwid,ltyp,spl,.true.,
     +     charged,0,txci,cnpart)


 999  end
