/* IndexRange_X class
   ------------------
   marks the range in one horizontal row.
   Contains [ix0, ix1) range along X
   and the row number iy (along Y)

   Can be read from/written to the iostream in the format [ix0:ix1, iy)
   Note the convention about braces: [...)

   IndexRange_Y class
   ------------------
   marks the range in one vertical column.
   Contains [iy0, iy1) range along Y
   and the column number ix (along X)

   Can be read from/written to the iostream in the format [ix, iy0:iy1)
   */

// Author R.Mizuk (mizuk@mail.desy.de)                       (19.02.99).
// Slightly modified by V.Balagura (balagura@mail.desy.de)   (27.02.99).

#ifndef index_range_h
#define index_range_h 1

#include <iostream>

struct IndexRange_X {
  int ix0, ix1, iy;
};
istream& operator>> (istream& is,       IndexRange_X& ir);
ostream& operator<< (ostream& os, const IndexRange_X& ir);

struct IndexRange_Y {
  int ix, iy0, iy1;
};
istream& operator>> (istream& is,       IndexRange_Y& ir);
ostream& operator<< (ostream& os, const IndexRange_Y& ir);

#endif
