// 
//  Author:  Rainer Mankel                     Created:  29-Sep-98
//           Humboldt University Berlin        Modified:  
//  Email:   mankel@ifh.de                     HERA-B Collaboration
// 
// Modifications:
// - Slight modification in inclusion of header files
//                                      14-Aug-00 Wouter Hulsbergen
//

// class rangerHitWire
// node class for drift chamber hit

#ifndef rangerHitWire_HH
#define rangerHitWire_HH

#ifndef rangerHit_HH
#include "rang/Hit.hh"
#endif

class rangerHitWire : public rangerHit {

public:

  rangerHitWire();
  rangerHitWire(ArtePointer<RHIT> rhit,rangerFitMode fm);
  rangerHitWire(ArtePointer<HITB>   hb,rangerFitMode fm);
  ~rangerHitWire();

  virtual void projectP(HepVector& resid,HepMatrix& HH,rangerStateP* s);
  virtual void projectPI(HepVector& resid,HepMatrix& HH,rangerStatePI* s);
  virtual void projectL(HepVector& resid,HepMatrix& HH,rangerStateL* s);
  virtual void projectLI(HepVector& resid,HepMatrix& HH,rangerStateLI* s);
  
  virtual int dim() const {return 1;};         // dimension of measurement
  virtual void updInternal();  // update internal degrees of freedom

  int getLRSign() const { return LRSign ; } ;
  void setLRSign(double s) { LRSign = (s>=0) ? 1 : -1; } ;
  void flipLRSign() { LRSign *= -1 ; } ;
private:

  int LRSign;

};

#endif
