// 
//  Author:  Alexander Spiridonov              Created:  18.11.01
//
//  Email:   spiridon@ifh.de                   HERA-B Collaboration
// 
// rgcheckhpt.C
//
//       check number of hit in hpt chambers for given track
//
#include <iostream.h>
#include <math.h>
#include <stdio.h>
#include <fstream.h>
#include <iomanip.h>
#include "arte/arte.hh"
#include "arte/RSEG_cmp.hh"
#include "rang/rgExtDef.hh"
#include "rang/zfparext.hh"

#undef DEBUG_PRINT
//#define DEBUG_PRINT

// Prototypes

extern "C" {
  //int rgauxremcs_(int& iseg, int& imcass, float& fracmc);
  //  void tfremcse_(int& iseg, int& imcass, float& fracmc);
  //void rgauxvtrcor_(ArtePointer<RTRA>, const int &);      
  //int rgmc_();
  //bool rgauxmrel_(int& mtra_vds, int& mtra_otr ); 
  //void rgauxvtrchi_(ArtePointer<RTRA> rtra, float& chi2_vtr);
  //bool rgauxtrigvt_(const int&);

  void rgauxsvm_(float&, float*, float&, float*);
  void rgauxsmv_(float&, float*, float&, float*);
}

extern "C" void rgcheckhpt_(ArtePointer<RSEG> rseg_vds, 
			    const float& p0,
			    float& dist_check,
			    int& n_cross)
{
  float pe_vds[5],p_check[5];
  float ze_vds;

  float zc[3],z1[3],z2[3],x1[3],x2[3],y1[3],y2[3];
  z1[0] = 467; z2[0] = 470.5; zc[0] = 0.5 * (z1[0] + z2[0]);
  z1[1] = 556.5; z2[1] = 560.; zc[1] = 0.5 * (z1[1] + z2[1]);
  z1[2] = 603.; z2[2] = 606.5; zc[2] = 0.5 * (z1[2] + z2[2]);
  x1[0] = -27.2; x2[0] = 27.2; y1[0] = -20.8; y2[0] = 20.8; 
  x1[1] = -32.4; x2[1] = 32.4; y1[1] = -24.8; y2[1] = 24.8; 
  x1[2] = -34.6; x2[2] = 34.6; y1[2] = -26.8; y2[2] = 26.8; 
  
  pe_vds[0] = rseg_vds->xe; 
  pe_vds[1] = rseg_vds->ye;
  pe_vds[2] = rseg_vds->txe;
  pe_vds[3] = rseg_vds->tye;
  pe_vds[4] = p0;
  ze_vds = rseg_vds->ze;
  
  float dist[3],distx[3];
  n_cross = 0;
  //                                           loop on hpt plane
  for (int i=0; i < 3; ++i)
    {
      
      float z_check = zc[i];
      rgauxsvm_(ze_vds, pe_vds, z_check, p_check);
      
      //if(i == 0) cout << " --1-- ";
      //cout << " chhpt: rseg " << rseg_vds 
      //   << " p " << 1./p_check[4] << " z " << z_check
      //   << " x,y " << p_check[0] << " " << p_check[1];
      //	   << endl;
      
      float din = z_check * 0.01;
      if( (p_check[0] > x1[i]  &&  p_check[0] < x2[i]
	   && p_check[1] > y1[i] && p_check[1] < y2[i] ) 
	  && (fabs(p_check[0]) > din || fabs(p_check[1]) > din) ) 
	{++n_cross;} //cout << " OK " << endl; }
      //else {cout << " bad " << endl;}
      
      // loop on hits
      dist[i] = 1000000;
      distx[i] = 1000000;
      for ( ArteTable<HITB>::iterator hitb = ArteTable<HITB>::begin();
	    hitb != ArteTable<HITB>::end(); ++hitb ) 
	{
	  if((*hitb)->gede->cmp != 4 || (*hitb)->gede->gvol[2] != 'C') continue; 
	  
	  //cout << " n " << nhit_hpt << " hit " << *hitb 
	  //	 << " z " << (*hitb)->z
	  // << " x " << (*hitb)->x
	  // << " y " << (*hitb)->y << endl;
	  
	  if((*hitb)->z < z1[i] || (*hitb)->z > z2[i]) continue;
	  float dx = (*hitb)->x - p_check[0];
	  float dy = (*hitb)->y - p_check[1];
	  float dist1 = dx*dx + dy*dy;
	  if( dist1 < dist[i]) {dist[i] = dist1; distx[i] = dx*dx;}
	}
      dist[i] = sqrtf(dist[i]);
      distx[i] = sqrtf(distx[i]);
    }                              // end of loop on hpt plane

  //  float dist_check;
  if(dist[0] > dist[1] && dist[0] > dist[2])
    dist_check = 0.5 * (dist[1] + dist[2]);
    //dist_check = 0.5 * (distx[1] + distx[2]);
  if(dist[1] > dist[0] && dist[1] > dist[2])
    dist_check = 0.5 * (dist[0] + dist[2]);
    //dist_check = 0.5 * (distx[0] + distx[2]);
  if(dist[2] > dist[0] && dist[2] > dist[1])
    dist_check = 0.5 * (dist[0] + dist[1]);
    //dist_check = 0.5 * (distx[0] + distx[1]);

  //cout << " +H+H+H+H+H+H+H+ rseg_vds " << rseg_vds; 
  //if(n_cross >= 2) 
  //  cout << " dist " << dist[0] << " " << dist[1] << " " << dist[2];
  //  cout << " dist " << distx[0] << " " << distx[1] << " " << distx[2];
  //cout << " check " << dist_check;
  //cout << " n " << n_cross << endl;

  return;
  
}
