// 
//  Author:  Alexander Spiridonov              Created:  10.06.99
//
//  Email:   spiridon@ifh.de                   HERA-B Collaboration
// 
// rgextcrse.C
//
//                     create eCAL-RICH seeds for ranger-external
//
#include <iostream.h>
#include <math.h>
#include <stdio.h>
#include "arte/RSEG_cmp.hh"
#include "arte/arte.hh"
#include "rang/rgExtDef.hh"
#include "rang/zfparext.hh"
#include "rang/zfextse.hh"

// Prototypes


extern "C" {
  void rgextcrse_() {

// initialization
#ifdef rgExtHist
  int id0 = zfparext_.id_hist; 
  int id;
  float w = 1.; float v;
  
#endif

  zfextse_.N_ext_seed = 0; 

//                                      loop on cluster in ECAL
 
    for( ArteTableIterator <RCCL> cluster; 
	 cluster.valid(); cluster.next() )
      {

	int CUT = 0;

//                                                                 CUT 1

	if(fabsf(cluster->x ) < zfparext_.xmin_clust &&
	   fabsf(cluster->y ) < zfparext_.ymin_clust )
	  {
	    CUT = 1;
	    goto NEXTcluster;
	  }

//                                                                 CUT 2

	if(cluster->esum < zfparext_.emin_clust )
	  {
	    CUT = 2;
	    goto NEXTcluster;
	  }

//                                                                 CUT 3

	if(cluster->esum * cluster->esum 
	   * ( cluster->tx * cluster->tx + cluster->ty * cluster->ty )
	   < zfparext_.ptmin_clust * zfparext_.ptmin_clust )
	  {
	    CUT = 3;
	    goto NEXTcluster;
	  }

//                                                                 CUT 4

	if(sqrt(cluster->cve[0]) > zfparext_.erxmax_clust ||
	   sqrt(cluster->cve[2]) > zfparext_.erymax_clust)
	  {
	    CUT = 4;
	    goto NEXTcluster;
	  }

//	cout << "rgextcrse :                      cluster is accepted" << endl;

//                                              loop on segments in rich
	for( ArteTableIterator <RSEG> segri;
	     segri.valid(); segri.next() )
	  {
	    if( segri->fit >= 0 && segri->cmp & Rsegc::rich
		&& (segri->cmp & Rsegc::bitsign)  == 0  )
	      {

#ifdef rgExtHist  
		hf1_(id=id0+221, v = cluster->ty - segri->tyf, w);
#endif
//                                                                 CUT 5

		if(fabsf(cluster->ty - segri->tyf) > zfparext_.dmax_ty_clri)
		  {
		    CUT = 5;
		    goto NEXTsegri;
		  }
#ifdef rgExtHist  
		hf1_(id=id0+222, v = cluster->tx - segri->txf, w);
#endif

		if(zfextse_.N_ext_seed < NMAX_SEED )
		{
//		  cout << "rgextcrse : N_ext_seed " 
//		       << zfextse_.N_ext_seed << endl;
		  int seed;
		  seed = zfextse_.N_ext_seed;

		  zfextse_.z_seed[seed] = cluster->z;
		  zfextse_.x_seed[seed] = cluster->x;
		  zfextse_.y_seed[seed] = cluster->y;
		  zfextse_.tx_seed[seed] = segri->txf;
		  zfextse_.ty_seed[seed] = segri->tyf;
//		  zfextse_.q_seed[seed] = 1./cluster->esum;
		  zfextse_.q_seed[seed] = 
		  - tfqptest_( cluster->z, cluster->x, segri->txf) 
                 * 1.031 * sqrt(1. + segri->txf * segri->txf)
                 / sqrt(1. + segri->txf * segri->txf 
			+ segri->tyf * segri->tyf);


		  zfextse_.cov_seed[seed][0] = cluster->cve[0];
		  zfextse_.cov_seed[seed][2] = cluster->cve[2];
//		  zfextse_.cov_seed[seed][5] = 0.40e-1;
		  zfextse_.cov_seed[seed][5] = 0.26e-6;
		  zfextse_.cov_seed[seed][9] = 0.26e-6;
		  zfextse_.cov_seed[seed][14] = zfextse_.q_seed[seed]
		    * zfextse_.q_seed[seed] * 0.06 * 0.06;
		  zfextse_.seg_VDS[seed] = 0; 
		  zfextse_.seg_MUON[seed] = 0; 
		  zfextse_.seg_ECAL[seed] = cluster.index();
		  zfextse_.seg_RICH[seed] = segri.index(); 
		  zfextse_.seg_OT[seed] = 0; 
		  zfextse_.track_MC[seed] = segri->fit; 

		  ++zfextse_.N_ext_seed;
				  }
	      NEXTsegri:
		CUT = 0;

	      }
	  }

      NEXTcluster:

#ifdef rgExtHist
//	cout << " rgextcrse :                                      crse CUT= " 
//	     << CUT << endl;  
#endif
	CUT = 0;

      }
  return;

// END998:

#ifdef rgExtHist
//  cout << " rgextcrse :                                      END998 CUT= " 
//       << CUT << endl;  
#endif

  return;
  }

}

