// 
//  Author:  Alexander Spiridonov              Created:  18.05.99
//
//  Email:   spiridon@ifh.de                   HERA-B Collaboration
// 
// rgextvdmu.C
//                      match of VDS and MUON segments


#include <iostream.h>
#include <math.h>
#include <stdio.h>
#include "arte/RSEG_cmp.hh"
#include "arte/arte.hh"
#include "rang/rgExtDef.hh"
#include "rang/zfparext.hh"

void rgextvdmu(ArteTableIterator <RSEG>& segvd  // segment in VDS
	       ,ArteTableIterator <RSEG>& segmu // segment in MUON
               ,float* p_vdmu                   // (x,y,tx,ty,Q/p) in MUON
	       ,int& OK_vdmu)                   // =1 for OK match, 0 no match 
{
    
  cout << "rgextvdmu : vds "  << segvd << " muon " << segmu << endl;
//  cout << "rgextvdmu : vds "  << segvd.index() 
//       << " muon " << segmu.index() << endl;
//  cout << "rgextvdmu : Txvd "  << segvd->tye 
//       << " Tymu " << segmu->tyf << endl;

  int CUT = 0;

#ifdef rgExtHist
  int id0 = zfparext_.id_hist; 
  int id;
  float w = 1.; float v;
  
#endif
  int isegvd,isegmu,imcvd,imcmu;
  float fracmcvd,fracmcmu;
  if(rgmc_())
    {

      isegvd=segvd.index();  
      tfremcse_(isegvd, imcvd, fracmcvd);
      isegmu=segmu.index();
      tfremcse_(isegmu, imcmu, fracmcmu);
    } 
  else
    {
      imcvd=-1; imcmu=0;
    }


  cout << "rgextvdmu : imcvd " << imcvd << " imcmu " << imcmu << endl;

#ifdef rgExtHist  
  hf1_(id=id0+201, v = segvd->tye - segmu->tyf, w);
  if(imcvd == imcmu && imcvd != 0 )                            // good pair
    {
      hf1_(id=id0+301, v = segvd->tye - segmu->tyf, w);
    }
#endif

//                                                                 CUT 1

  if(fabsf(segvd->tye - segmu->tyf) > zfparext_.dmax_ty_vdmu)
    {
      CUT = 1;
      //      goto END998;
      OK_vdmu = 0; 
      return; 
    }

  float y_vdmu,y_mu,x_mu; 
  y_vdmu = segvd->ye + (zfparext_.z_match_mu - segvd->ze) * segvd->tye;
  x_mu = segmu->xf + (zfparext_.z_match_mu - segmu->zf) * segmu->txf;
  y_mu = segmu->yf + (zfparext_.z_match_mu - segmu->zf) * segmu->tyf;

#ifdef rgExtHist

  hf1_(id=id0+202, v = y_vdmu - y_mu, w);

  if(imcvd == imcmu && imcvd != 0 )                         // good pair
    {
      hf1_(id=id0+302, v = y_vdmu - y_mu , w);
    } 

#endif
//                                                                 CUT 2
  if(fabsf(y_vdmu - y_mu) > zfparext_.dmax_y_vdmu)
    {
      CUT = 2;
      //goto END998;
      OK_vdmu = 0; 
      return; 
    }

//      qpt = - tfqptest(z,x,tx) * 1.031

  float q_mc = 1;
  float qmu1,tx_vdmu,x_vdmu;
  float zc_magn=450.;
  x_vdmu = segvd->xe + (zc_magn - segvd->ze) * segvd->txe;
  tx_vdmu =  (x_mu - x_vdmu) / (zfparext_.z_match_mu - zc_magn);
  qmu1 = - tfqptest_( zfparext_.z_match_mu, x_mu, tx_vdmu) * 1.031
    * sqrt(1. + segvd->txf * segvd->txf)
    / sqrt(1. + segvd->txf * segvd->txf + segvd->tyf * segvd->tyf);

#ifdef rgExtHist
  hf1_(id=id0+203, v=1./fabsf(qmu1), w);
#endif

  if(imcmu)
    {
      ArtePointer<MTRA> mtra(imcmu);
      q_mc = 1./sqrt(mtra->px*mtra->px + mtra->py*mtra->py
		     +mtra->pz*mtra->pz);
#ifdef rgExtHist
      hf1_(id=id0+303, v = 1./q_mc, w);
#endif
    }

//                                                                 CUT 3
  if(fabsf(1./fabsf(qmu1)) < zfparext_.min_p_vdmu)
    {
      CUT = 3;
      //      goto END998;
      OK_vdmu = 0; 
      return; 
    }

  if(imcvd == imcmu && imcvd != 0 )                            // good pair
    {
#ifdef rgExtHist
      hf1_(id=id0+304, v = q_mc/fabsf(qmu1)-1., w);
#endif
      cout << "rgextvdmu : pmc " << 1./q_mc
	   << " pmu " << 1./fabsf(qmu1) << " imcmu " << imcmu << endl;
    }

  float z_in, z_out, p_in[5], p_out[5];
  z_in = segvd->ze;
  z_out = zfparext_.z_match_mu;
  p_in[0] = segvd->xe;
  p_in[1] = segvd->ye;
  p_in[2] = segvd->txe;
  p_in[3] = segvd->tye;
//  p_in[4] = segvd->pe;
  p_in[4] = qmu1;

  rgextsvm_(z_in, p_in, z_out,p_out);

  for(int i=0; i < 5; i+=1){p_vdmu[i] = p_out[i];}

#ifdef rgExtHist
  hf1_(id=id0+205, v = x_mu - p_out[0], w);

  if(imcvd == imcmu && imcvd != 0 )                         // good pair
    {
      hf1_(id=id0+305, v = x_mu - p_out[0], w);
    } 
#endif

//                                                                 CUT 4
  if(fabsf(x_mu - p_out[0]) > zfparext_.dmax1_x_vdmu)
    {
      CUT =4;
      //      goto END998;
      OK_vdmu = 0; 
      return; 
    }

#ifdef rgExtHist
  hf1_(id=id0+206, v = y_mu - p_out[1], w);

  if(imcvd == imcmu && imcvd != 0 )                         // good pair
    {
      hf1_(id=id0+306, v = y_vdmu - p_out[1], w);
    }
  else                                                      // bad pair
    {
      hf1_(id=id0+406, v = y_mu - p_out[1], w);
    }

#endif

  OK_vdmu = 1;
  return;

  // END998:
  //OK_vdmu = 0;
  //return;

#ifdef rgExtHist
  cout << " rgextvdmu :                                      vdmu CUT= " 
       << CUT << endl;  
#endif


}   //   end of rgextvdmu_()

//  cout << "rgextvdmu : isegvd " << isegvd 
//       << " imcvd " << imcvd << " fracmcvd " << fracmcvd << endl;
 
//  cout << "rgextvdmu : isegmu " << isegmu 
//       << " imcmu " << imcmu << " fracmcmu " << fracmcmu << endl;

