// 
//  Author:  Rainer Mankel                     Created:  23-Apr-99
//           Humboldt University Berlin        Modified:  
//  Email:   mankel@ifh.de                     HERA-B Collaboration
// 

// rgnavig_
// Fortran callable shortcut to rangerDomainObject->xpro()->navig(...).
// Checks if a given domain window is navigable for x propagation.
// Being navigable (for vertical continuation) means that the window has
// been passed by the horizontal projection of the track candidate
// in the previous step.

#include "rang/DomObj.hh"
#include "rang/DomWin.hh"
#include "rang/XPro.hh"

extern rangerDomObj* rangerDO;   // global DO pointer

extern "C" {
  int rgnavig_(rangerDomWin*& dw) {
    if (dw) {
      return rangerDO->xpro()->navig(dw);
    }
    else {
      cout << "rgnavig: invalid dw=" << dw << endl;
      return 0;
    }
  }
}



    



