// 
//  Author:  Alexander Spiridonov              Created:  08/04/01
//
//  Email:   spiridon@ifh.de                   HERA-B Collaboration
// 
// rguniqchi.C
//
//       test of clones
//       check if two segments are very close according to chi2 criteria 
//       kill one of the close segments
//
#include <iostream.h>
#include <math.h>
#include <stdio.h>
#include <fstream.h>
#include <iomanip.h>
#include "arte/arte.hh"
#include "arte/RSEG_cmp.hh"
#include "rang/rgExtDef.hh"
#include "rang/zfextse.hh"
#include "rang/zfparext.hh"
#include "rang/Fit.hh"

// Prototypes

extern "C" { 			     
}

extern "C" void rguniqchi_() 
{
  
  static int FirstCall = 1;
  
  // initialization
  
  static float max_x, max_dx,max_dtx,max_dy, max_chi2;
  static float w_x,w_y,w_tx,w_ty;
  if(FirstCall)
    {
      FirstCall = 0;
      //      tfhbinit_();
      
      // s_x = 0.08
      // s_y = s_x * 12.
      // s_tx = s_x / 70.
      // s_ty = s_tx * 12.
      
      //w_x = 156.25;
      //w_y = 1.085;
      //w_tx = 765625.;
      //w_ty = 5317.;
      
      w_x = 4.;
      w_y = 0.11;
      w_tx = 4444.;
      w_ty = 5317.;
      max_x = 25.; max_dx = 2.; max_dtx = 0.1; max_dy = 15., max_chi2 = 4.;
    }                   
  
  float zt, xt, xt1, txt, txt1, yt, yt1, dx, dtx, dy, chi2t;
  
  for ( ArteTable<RSEG>::iterator rseg = ArteTable<RSEG>::begin();
	rseg != ArteTable<RSEG>::end(); ++rseg ) 
    {  
      if( (*rseg)->cmp & Rsegc::bitsign || (*rseg)->fit != 0 
	  || !((*rseg)->cmp & Rsegc::patt) ) continue; 
      
      if(( (*rseg)->cmp & Rsegc::slt) ) continue;
      if(fabs((*rseg)->xf) < max_x && fabs((*rseg)->yf) < max_x) continue;
      if(fabs((*rseg)->xe) < max_x && fabs((*rseg)->ye) < max_x) continue;
      
      //      cout << " rgauxstat20.C : rseg " << *rseg  << endl; 
      
      ArteTable<RSEG>::iterator rseg1 = rseg;
      ++rseg1;
      for (  ;
	     rseg1 != ArteTable<RSEG>::end(); ++rseg1 ) 
	{
	  
	  if( (*rseg1)->cmp & Rsegc::bitsign || (*rseg1)->fit != 0 
	      || !((*rseg1)->cmp & Rsegc::patt) ) continue; 
	  
	  if(  (*rseg1)->cmp & Rsegc::slt ) continue;
	  
	  if( rseg1 == rseg ) continue;
	  
	  txt  = 0.5 * ( (*rseg)->txf  + (*rseg)->txe );
	  txt1 = 0.5 * ( (*rseg1)->txf + (*rseg1)->txe);
	  dtx = txt - txt1;
  
	  if(fabs(dtx) > max_dtx) continue;
	  
	  if(fabs((*rseg1)->xf)<max_x && fabs((*rseg1)->yf)<max_x) continue;
	  if(fabs((*rseg1)->xe)<max_x && fabs((*rseg1)->ye)<max_x) continue;

	  //cout << " rgauxstat20.C : rseg1 " << *rseg1 << endl;
	  
	  zt = 0.25 * ((*rseg)->zf + (*rseg)->ze 
		       +(*rseg1)->zf + (*rseg1)->ze);
	  
	  xt =  (*rseg)->xf + (zt - (*rseg)->zf) * txt;
	  xt1 =  (*rseg1)->xf + (zt - (*rseg1)->zf) * txt1;
	  dx = xt - xt1;
  
	  if(fabs(dx) > max_dx) continue;
	  
	  yt =  (*rseg)->yf + (zt - (*rseg)->zf) * (*rseg)->tyf;
	  yt1 =  (*rseg1)->yf + (zt - (*rseg1)->zf) * (*rseg1)->tyf;
	  dy = yt - yt1;
 
	  if(fabs(dy) > max_dy) continue;
	  
	  chi2t = dx * dx * w_x + dy * dy * w_y 
	    + dtx * dtx * w_tx;
	  
	  if(chi2t > max_chi2) continue;
	  	  
	  //cout << "rguniqchi.C : s,1 " <<  *rseg << " " << *rseg1 
	  //     << " chi2 " << chi2t 
	  //     << " n1 " << (*rseg)->nhit << " n2 " << (*rseg1)->nhit
	  //     << endl;

	  if((*rseg)->nhit > (*rseg1)->nhit)
	    {
	      //cout << " KILL rseg " << *rseg1 << endl;
	      
	      (*rseg1)->cmp |= Rsegc::bitsign;  
	    }
	  else
	    {
	      //cout << "               KILL rseg " << *rseg << endl;
	      
	      (*rseg)->cmp |= Rsegc::bitsign;  
	    }
	} 
    }  
}         

