*-- Author :    Rainer Mankel   14/02/95

      subroutine tfdigi(imc,zmin,zmax)

*     **** monitor digitization
      implicit none
#include "arte/Arte.fi"

#include "pris/zmh.fi"

#include "rang/zf.fi"
#include "rang/zfmode.fi"

      integer nmx
      parameter (nmx=500)
      integer ih, imc, iso, nso, iih, mimp, mimp2, hit_array(nmx),
     +        nhits, jmc, n_mimp, ipl, cmp, icm, istereo, gcode
      real dz, xr, yr, u, t_u, dtx, dty, de, ems, ede, resid, zmin,
     +     zmax, xp, yp, txr, tyr, emstx, emsty

      logical init, electron, tfcharg
      character*4 c(3)

#include "auto/GEO.fi"
#include "auto/HITB.fi"
#include "auto/MTRA.fi"
#include "auto/MIMP.fi"
#include "auto/TOPP.fi"

#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/HITB.ff"
#include "auto/MTRA.ff"
#include "auto/MIMP.ff"
#include "auto/TOPP.ff"

      data c /'Si', 'HDC', 'MSGC'/
      data init /.false./

      if (.not.init) then
        do icm=1,3
         call hbook1(6000+icm,' residual '//c(icm),50,-0.1,0.1,0.)
         call hbook1(6003+icm,' residual/reso '//c(icm),50,-5.,5.,0.)
         call hbook1(6006+icm,' d(tx) '//c(icm),50,-.002,.002,0.)
         call hbook1(6009+icm,' d(ty) '//c(icm),50,-.002,.002,0.)
         call hbook1(6012+icm,' el d(e) '//c(icm),50,-.001,.001,0.)
         call hbook1(6015+icm,' mi d(e) '//c(icm),50,-.001,.001,0.)
         call hbook1(6018+icm,' d(tx) sc '//c(icm),50,-10.,10.,0.)
         call hbook1(6021+icm,' d(ty) sc '//c(icm),50,-10.,10.,0.)
         call hbook1(6024+icm,' el d(e) sc '//c(icm),50,-45.,5.,0.)
         call hbook1(6027+icm,' mi d(e) sc '//c(icm),50,-45.,5.,0.)
        enddo
        call hbook1(6101,' residual Si 0+e',50,-.002,.002,0.)
        call hbook1(6102,' residual Si 0-e',50,-.002,.002,0.)
        call hbook1(6103,' residual Si 90+e',50,-.002,.002,0.)
        call hbook1(6104,' residual Si 90-e',50,-.002,.002,0.)
        init = .true.
      endif

      if (l_diag) then
         print *,' tfdigi starting for imc=', imc
         call tfwait()
      endif

*     **** initialize /zmh/ if needed
      call tusomh()

*     **** check id
      if (.not.(tfcharg(imc))) go to 999

      gcode = itopp_gean(omtra_topp(imc))
      electron = (gcode.eq.2)  .or. (gcode.eq.3)

*     **** loop over hits in sorted order
      nso = nmimmh(imc)
      do 30 iso=nso,1,-1
         mimp = imimmh( istamh(imc) + iso )
*        **** get hits associated with mimp
         call tumimph(mimp,nmx,hit_array,nhits)
*        **** loop over associated hits
         do 40 iih=1,nhits
            ih = hit_array(iih)
            if (ih.le.0.or.ih.gt.iq(jhitb+2)) then
               print *,' () tfdigi: invalid ih=',ih,
     +              ' at iih,mimp=',iih,mimp
               go to 40
            endif

*           **** no merged points
            call tuhmimp(ih,jmc,mimp,n_mimp)
            if (n_mimp.gt.1) go to 30

*           **** check z
            if (fhitb_z(ih).lt.zmin.or.fhitb_z(ih).gt.zmax) go to 30

*           **** simulate digitization
            ipl = ihitb_gede(ih)
            cmp = igede_cmp(ipl)
            if (cmp.eq.1) then  ! Si strips
               dz = fhitb_z(ih) - fmimp_z(mimp)
               xp = fmimp_x(mimp) + fmimp_tx(mimp) * dz
               yp = fmimp_y(mimp) + fmimp_ty(mimp) * dz
               xr = xp * fgede_rot(1,ipl) - yp * fgede_rot(2,ipl)
               yr = xp * fgede_rot(2,ipl) + yp * fgede_rot(1,ipl)
               u = xr * fgede_cos(ipl) - yr * fgede_sin(ipl)
               resid = fhitb_x(ih) - u
            elseif (cmp.eq.2) then ! honeycombs
               dz = fhitb_z(ih) - fmimp_z(mimp)
               xp = fmimp_x(mimp) + fmimp_tx(mimp) * dz
               yp = fmimp_y(mimp) + fmimp_ty(mimp) * dz
               xr = xp * fgede_rot(1,ipl) - yp * fgede_rot(2,ipl)
               yr = xp * fgede_rot(2,ipl) + yp * fgede_rot(1,ipl)
               txr = fmimp_tx(mimp) * fgede_rot(1,ipl)
     +              - fmimp_ty(mimp) * fgede_rot(2,ipl)
               tyr = fmimp_tx(mimp) * fgede_rot(2,ipl)
     +              + fmimp_ty(mimp) * fgede_rot(1,ipl)

               u = xr * fgede_cos(ipl) - yr * fgede_sin(ipl)
     +              - fhitb_x(ih)


**               t_u = fmimp_tx(mimp) * fgede_cos(ipl)
**     +              - fmimp_ty(mimp) * fgede_sin(ipl)

               t_u = txr * fgede_cos(ipl) - tyr * fgede_sin(ipl)

               resid = fhitb_q(ih) - u / sqrt(1. + t_u**2)
            elseif (cmp.eq.3) then ! MSGCs
               dz = fhitb_z(ih) - fmimp_z(mimp)
               xp = fmimp_x(mimp) + fmimp_tx(mimp) * dz
               yp = fmimp_y(mimp) + fmimp_ty(mimp) * dz
               xr = xp * fgede_rot(1,ipl) - yp * fgede_rot(2,ipl)
               yr = xp * fgede_rot(2,ipl) + yp * fgede_rot(1,ipl)
               u = xr * fgede_cos(ipl) - yr * fgede_sin(ipl)
               resid = fhitb_x(ih) - u
            endif
            if (cmp.ge.1.and.cmp.le.3) then
               call hfill(6000+cmp,resid,0.,1.)
               call hfill(6003+cmp,resid/fhitb_r(ih),0.,1.)
            endif
            if (cmp.eq.1) then
               if (fgede_cos(ipl).gt.0.7) then
                  if (fgede_sin(ipl).gt.0.) then
                     istereo = 1
                  else
                     istereo = 2
                  endif
               else
                  if (fgede_cos(ipl).gt.0.) then
                     istereo = 3
                  else
                     istereo = 4
                  endif
               endif
               call hfill(6100+istereo,resid,0.,1.)
            endif
 40      continue

*        **** multiple scattering control
         if (iso.lt.nso) then
**            ems = sqrt(fgede_ms(ipl)) / abs(fmimp_p(mimp))
            ems = sqrt(fgede_ms(ipl)) / abs(fmimp_p(mimp))
     +           * (1. + fmimp_tx(mimp)**2 
     +                 + fmimp_ty(mimp)**2)**0.75
     +           * sqrt(1. + .105**2 / fmimp_p(mimp)**2)
            emstx = ems * sqrt(1. + fmimp_tx(mimp)**2)
            emsty = ems * sqrt(1. + fmimp_ty(mimp)**2)


            ede = fgede_ms(ipl) / 0.0136**2
            mimp2 = imimmh( istamh(imc) + iso + 1)
            if (min(fmimp_z(mimp),fmimp_z(mimp2)).gt.610.
     +           .or.max(fmimp_z(mimp),fmimp_z(mimp2)).lt.290.) then
               dtx = fmimp_tx(mimp2) - fmimp_tx(mimp)
               dty = fmimp_ty(mimp2) - fmimp_ty(mimp)
               de = (abs(fmimp_p(mimp2)) - abs(fmimp_p(mimp)))
     +              / abs(fmimp_p(mimp))
               if (cmp.ge.1.and.cmp.le.3) then
                  call hfill(6006+cmp,dtx,0.,1.)
                  call hfill(6009+cmp,dty,0.,1.)
                  if (electron) then
                     call hfill(6012+cmp,de,0.,1.)
                  else
                     call hfill(6015+cmp,de,0.,1.)
                  endif
                  if (ems.ne.0.) then
                     call hfill(6018+cmp,dtx/emstx,0.,1.)
                     call hfill(6021+cmp,dty/emsty,0.,1.)
                     if (electron) then
                        call hfill(6024+cmp,de/ede,0.,1.)
                     else
                        call hfill(6027+cmp,de/ede,0.,1.)
                     endif
                  endif
               endif
            endif
         endif
 30   continue

      if (l_diag) call tfwait()

 999  end




