*-- Author :    Rainer Mankel   30/01/97
*-- changed:   A.Spiridonov    21/05/98    !  call tfstam1 for ideal ranger
*-- changed:   A.Spiridonov    02/11/98    !  rlevel_zfpar = 4 
*-- changed:   A.Spiridonov    26/11/99    !  version for on-line reconstr.
* remove call of tfdownstr                                24/07/00 
* call rgsltre()                                   03/09/00  A. Spiridonov
* call of rgsltre  after normal ranger             04/11/00  A. Spiridonov
* call of OtrCats                                  10/11/00  A. Spiridonov
* call of tema_reco                                04/02/01  A. Spiridonov
* selective call of tfunco(),call of rgdef()       06/02/01  A. Spiridonov
* call rguniqchi()                                 08/04/01  A. Spiridonov 
* call tfmcren()                                   08/07/01  A. Spiridonov
* .and.slt_mode_zfpar.le.3) call rgsltre()
*      +   .and..not.cats_mode_zfpar) call rgsltre 10/09/01  A. Spiridonov
* call tfdownstr3,rgmatcha                         17/02/02  A. Spiridonov
*

      subroutine tfevntr()

*     **** mother routine for pattern recognition in main tracker system
*                ( clone of tfevnt )

      implicit none
#include "rang/zf.fi"
#include "rang/zfmode.fi"
#include "rang/zfpar.fi"
#include "arte/Arte.fi"

      integer istat
      integer message_id_1
      data message_id_1 /0/
      
      integer if_init
      data if_init/0/

      logical OK_tema

      integer whitmin_mag_zfpar_save,maxflt_mag_zfpar_save

#include "arte/Arte.ff"

      if (jgede.le.0.or.jgesl.le.0.or.jhitb.le.0) then
         call mepric(message_id_1,1,
     +        'tfevnt: one of tables GEDE/GESL/HITB is not booked')
         go to 998
      endif
      
*                                             Tema
*
      if(tema_mode_zfpar) then          !  use of Tema
         if (rlevel_zfpar.le.2) then ! rlevel_zfpar = 2          
            call tema_reco(OK_tema)     ! Tema
            go to 998
         elseif (rlevel_zfpar.eq.5) then !  rlevel_zfpar = 5          
            call tema_reco(OK_tema)     ! Tema
            if(tc_mode_zfpar) then
               call rginit()
               if(if_init.eq.0) then
                  call rgdef()
                  call rgdom()
                  if_init = 1
               endif
               call rghlevnt()
               call tftcren(istat) ! track reconstruction in TC chambers
            end if
            go to 998
         end if
      end if
*                                             OtrCats
*
      if(cats_mode_zfpar) then          !  use of OtrCats
         if (rlevel_zfpar.le.2) then ! rlevel_zfpar = 2          
            call rgcatsre()     ! OtrCats
            go to 998
         elseif (rlevel_zfpar.eq.5) then !  rlevel_zfpar = 5          
            call rgcatsre()     ! OtrCats
            if(tc_mode_zfpar) then
               call rginit()
               if(if_init.eq.0) then
                  call rgdef()
                  call rgdom()
                  if_init = 1
               endif
               call rghlevnt()
               call tftcren(istat) ! track reconstruction in TC chambers
            end if
            go to 998
         elseif (rlevel_zfpar.eq.4.or.rlevel_zfpar.eq.3) then !rlevel_zfpar=4 
            call rgcatsre()     ! OtrCats
            call rginit()
            if(if_init.eq.0) then
               call rgdef()
               call rgdom()
               if_init = 1
            endif
            call rghlevnt()
            call tfmcren()           ! track reconstruction in MC chambers
            if (rlevel_zfpar.eq.4)
     +           call tftcren(istat) ! track reconstruction in TC chambers
            go to 998
         end if
      end if
*                                       ! standard  Ranger      
*
      call rginit()
      if(if_init.eq.0) then
         call rgdef()     ! define geometry for ranger
         call rgdom()
         if_init = 1
      endif

      if (rlevel_zfpar.lt.0) then
         go to 998
      end if

      if (rlevel_zfpar.eq.0) then

         call rgideal(1.,29,190.,1330.,0) ! full ideal analysis

      elseif (rlevel_zfpar.le.2) then        ! rlevel_zfpar < 3          
         call tfmatripn(istat)  ! ranger/triplet
         if(uniq_mode_zfpar.gt.0) call tfunco()          ! weedout
         if(unchi_mode_zfpar) call rguniqchi()           ! weedout 

      elseif (rlevel_zfpar.eq.3) then        !  rlevel_zfpar = 3          
         call tfmatripn(istat)  ! ranger/triplet
         if(uniq_mode_zfpar.gt.0) call tfunco()          ! weedout

      elseif (rlevel_zfpar.eq.4) then         ! rlevel_zfpar = 4         
         rlevel_zfpar = 3
         call tfmatripn(istat)  ! ranger/triplet
         if(uniq_mode_zfpar.gt.0) call tfunco()          ! weedout
         call tftcren(istat)    ! track reconstruction in TC chambers
         rlevel_zfpar = 4 

      elseif (rlevel_zfpar.eq.5) then         ! rlevel_zfpar = 5
         rlevel_zfpar = 2
         call tfmatripn(istat)  ! ranger/triplet
         if(uniq_mode_zfpar.gt.0) call tfunco()          ! weedout
         if(unchi_mode_zfpar) call rguniqchi()           ! weedout
         call tftcren(istat)    ! track reconstruction in TC chambers
         rlevel_zfpar = 5
**         call tfunrfr()         ! segments fit
      endif

 998  if((slt_mode_zfpar.gt.0.and.slt_mode_zfpar.le.3)
     +   .and..not.cats_mode_zfpar ) 
     +     call rgsltre()       ! slt tracks reconstruction
      
      call tfunrfr()         ! segments fit

     
      if(mcmode_zfpar.ne.0) then
         whitmin_mag_zfpar_save = whitmin_mag_zfpar 
         whitmin_mag_zfpar = 2.
         maxflt_mag_zfpar_save = maxflt_mag_zfpar
         maxflt_mag_zfpar = 3

         if(rlevel_zfpar.le.0) then
            call tfdownstr3(1, 1.5)
         else
            call tfdownstr3(0, 1.5)
         endif

         whitmin_mag_zfpar = whitmin_mag_zfpar_save 
         maxflt_mag_zfpar = maxflt_mag_zfpar_save
      endif

      if(match_zfpar.ne.0) then
         call rgmatcha()       ! match vds-otr
      endif

 999  return
      end
