*-- Author :    A. Spiridonov   06/07/01
*-- canged :   
*   inr_zf(ii) = 0                                       22/07/01 A. Spiridonov
*   save old rsegc_cmp                                   12/12/01 A. Spiridonov
*

      subroutine tfmcren

*
*     track reconstruction in MC chambers by means
*     of propagation of track segments from PC 

      implicit none

#include "rang/zfmode.fi"
#include "rang/zfpar.fi"
#include "rang/zfpar_tc.fi"
#include "rang/zf.fi"
#include "rang/ztripl.fi"
#include "rang/zcut.fi"
#include "pris/zpstat.fi"
#include "arte/ArteFlag.fi"
#include "arte/Arte.fi"
#include "auto/MIMP.fi"
#include "auto/RSEG.fi"
#include "auto/RPNT.fi"
#include "arte/RSEG_cmp.fi"
#include "rang/descend.fi"

#include "rang/FIXtrit.hh"

*      integer maxlep
*      parameter (maxlep=10)

      integer ift,iiseg,ift1,ift2,nca_x,direction,
     +      begin_store,istat,nca_prep,ii

      logical init

      save init
      data init /.false./

*      integer muon1,muon2,pion1,pion2
*      integer nh,nh_PC,imimp,jaux,imc,nhmimp,imcass,NRSEG_rec
*      real fracmc

      integer NRSEG_stor,NRSEG_rec,NRSEG_1

*      equivalence ( pstat_gold(1,1),muon1 )
*      equivalence ( pstat_gold(2,1),muon2 )
*      equivalence ( pstat_gold(3,1),pion1 )
*      equivalence ( pstat_gold(4,1),pion2 )

      integer if_error
      integer iseg,irpnt,ind_rpnt,rpnt

#include "arte/Arte.ff"
#include "auto/MIMP.ff"
#include "auto/RSEG.ff"
#include "auto/RPNT.ff"

******************************************************************
*
*     Organization of storage:
*
*           1                  |
*           .                  | x candidates
*           .                  |
*         nca_x                |
*           .                   |
*           .                   | y candidates, 3d candidates
*         nca_y                 |
*           .                    |
*           .                    | magnet seeds
*         nca_prep               |
*           .                     |
*           .                     | magnet candidates
*           .                     |
*
******************************************************************

      l_diag = .false.
      diag_level = 0

      call rginit()
      if (.not.l_rinit) call tfrinit() ! restricted init

      l_term = .false.
      lremzc = .false.

*     **** do the work

*      call tftcms         ! study mult.scat. between PC and TC

      if(jrseg.le.0) go to 999
      if(NRSEG().lt.1) go to 999

      NRSEG_rec = NRSEG()

      do 10 iiseg=1,NRSEG_rec     ! loop over reconstructed segments
         
         if (irseg_fit(iiseg).ne.0) go to 10 ! select charged track 
 
         if( IAND(irseg_cmp(iiseg),rsegc_patt).ne.rsegc_patt.or.
     +        IAND(irseg_cmp(iiseg),rsegc_bitsign).eq.rsegc_bitsign)
     +        go to 10          !  reject segment

**        print '(" tfmcren.F : segment to be continued ",i4)',iiseg

        call tfclr()
        do ii=1,nzfmx
           inr_zf(ii) = 0
        enddo
        call tfrsegft(iiseg,ift,if_error)

*        call tfauxdft(ift)

        if(if_error.ne.0) go to 10

        call tfmprep(ift,istat) ! prepare for magnet trackin

        if(istat.ne.0 )  then
**           print *,'tfmcren : istat ',istat
           go to 10
        end if

        nca_prep = nca_ft       ! store new endpointer
        
        l_2dx = .false.
        l_2dy = .false.
        l_mag = .true.
        nca_prep = 1
        begin_ft = nca_prep + 1
        istat = 0

        call tfpropmn(2,-1,istat)

        begin_ft = nca_prep + 1
        call tfbest()

        NRSEG_1 = nrseg()

        do 40 ift=begin_ft,nca_ft         
           if (alive_ft(ift)) then
**              print *,'tfmcren : store ift ',ift
**              call tfauxdft(ift)

              call tfstor(ift)

           endif
 40     continue

*       kill PC segment
        if(nrseg().gt.NRSEG_1) then
*                                                         save old rsegc_cmp
           iq(iqrseg_cmp_l()) = IOR(iq(iqrseg_cmp_l())
     +          ,iq(iqrseg_cmp(iiseg)) )
*                                                         kill old segment
           iq(iqrseg_cmp(iiseg))=-iq(iqrseg_cmp(iiseg))

*     *** restore rseg end
           q(qrseg_ze(nrseg())) = frseg_ze(iiseg)
           q(qrseg_xe(nrseg())) = frseg_xe(iiseg)
           q(qrseg_ye(nrseg())) = frseg_ye(iiseg)
           q(qrseg_txe(nrseg())) = frseg_txe(iiseg)
           q(qrseg_tye(nrseg())) = frseg_tye(iiseg)
           q(qrseg_pe(nrseg())) = frseg_pe(iiseg)
           do ii =1,nrseg_cve
              q(qrseg_cve(ii,nrseg())) = frseg_cve(ii,iiseg)
           enddo

*q(qrseg_cvf(i_pack,iseg))

#ifdef TFMCREN_RPNT_TEST

           print *,' tfmcren.F: --- iiseg ',iiseg
     +          ,' zxyf ',frseg_zf(iiseg),frseg_xf(iiseg)
     +          ,frseg_yf(iiseg)
     +          ,' tp ',frseg_txf(iiseg),frseg_tyf(iiseg)
     +          ,frseg_pf(iiseg)
     +          ,' cov ',frseg_cvf(1,iiseg),frseg_cvf(3,iiseg)
     +          ,frseg_cvf(6,iiseg)
     +          ,frseg_cvf(10,iiseg),frseg_cvf(15,iiseg)
*#endif

           print *,' tfmcren.F: --- iiseg ',iiseg
     +          ,' zxye ',frseg_ze(iiseg),frseg_xe(iiseg)
     +          ,frseg_ye(iiseg)
     +          ,' tp ',frseg_txe(iiseg),frseg_tye(iiseg)
     +          ,frseg_pe(iiseg)
     +          ,' cov ',frseg_cve(1,iiseg),frseg_cve(3,iiseg)
     +          ,frseg_cve(6,iiseg)
     +          ,frseg_cve(10,iiseg),frseg_cve(15,iiseg)

           print *,' tfmcren.F: --- nrseg ',nrseg()
     +          ,' zxye ',frseg_ze(nrseg()),frseg_xe(nrseg())
     +          ,frseg_ye(nrseg())
     +          ,' tp ',frseg_txe(nrseg()),frseg_tye(nrseg())
     +          ,frseg_pe(nrseg())
     +          ,' cov ',frseg_cve(1,nrseg()),frseg_cve(3,nrseg())
     +          ,frseg_cve(6,nrseg())
     +          ,frseg_cve(10,nrseg()),frseg_cve(15,nrseg())
           
           do 20 irpnt=1,999    ! locate rpnt associated with iiseg
              if (irpnt.eq.1) then
                 ind_rpnt = prseg_rpnt(iiseg)
              else
                 ind_rpnt = xrseg_rpnt(ind_rpnt)
              endif
              if (ind_rpnt.le.0) go to 21
              rpnt = mrseg_rpnt(ind_rpnt)
              
              if(irpnt.lt.1) then
                 print *,' tfmcren.F: iiseg,rpnt ',iiseg,rpnt
     +                ,' zxy ',frpnt_zf(rpnt),frpnt_xf(rpnt)
     +                ,frpnt_yf(rpnt)
     +                ,' tp ',frpnt_txf(rpnt),frpnt_tyf(rpnt)
     +                ,frpnt_pf(rpnt)
     +                ,' cov ',frpnt_cvf(1,rpnt),frpnt_cvf(3,rpnt)
     +                ,frpnt_cvf(6,rpnt)
     +                ,frpnt_cvf(10,rpnt),frpnt_cvf(15,rpnt)
              endif
              
 20        continue
           print *,' tfmcren.F: end of loop iiseg ',iiseg 
 21        continue
           
           do 30 irpnt=1,999    ! locate rpnt associated with nrseg()
              if (irpnt.eq.1) then
                 ind_rpnt = prseg_rpnt(nrseg())
              else
                 ind_rpnt = xrseg_rpnt(ind_rpnt)
              endif
              if (ind_rpnt.eq.0) go to 31
              rpnt = mrseg_rpnt(ind_rpnt)
              
              if(irpnt.lt.1) then
                 print *,' tfmcren.F: nrseg,rpnt ',nrseg(),rpnt
     +                ,' zxy ',frpnt_zf(rpnt),frpnt_xf(rpnt)
     +                ,frpnt_yf(rpnt)
     +                ,' tp ',frpnt_txf(rpnt),frpnt_tyf(rpnt)
     +                ,frpnt_pf(rpnt)
     +                ,' cov ',frpnt_cvf(1,rpnt),frpnt_cvf(3,rpnt)
     +                ,frpnt_cvf(6,rpnt)
     +                ,frpnt_cvf(10,rpnt),frpnt_cvf(15,rpnt)
              endif
              
 30        continue
           print *,' tfmcren.F: end of loop iiseg ',iiseg 
 31        continue
           
**           call tfauxdrs(iiseg)
**           call tfauxdrs(nrseg())
#endif
           
*       print *,'tfmcren: iiseg,cmp,and',nrseg(),iq(iqrseg_cmp(nrseg()))
*     +          ,IAND(irseg_cmp(nrseg()),rsegc_patt)
           
*     *        print *,'tfmcren : iiseg,cmp ',iiseg,iq(iqrseg_cmp(iiseg))
        endif
        

 10   continue                  !  end of loop on segments

 999  end
