*-- Author :    Rainer Mankel   30/01/97
*-- changed :   A.Spiridonov    24/02/98

      subroutine tftrand(izf,dom,ecorr,istat)

*     **** construct transport matrix for electrons & non-electrons

*     **** clone of tftrans, output into domain prediction buffer

*     **** takes track parameters,cov matrix,z position, plane and
*     **** hit numbers from candidate izf and fills prediction into
*     **** domain prediction buffer for dom

      implicit none
      integer ndimmag
      parameter (ndimmag=5)

      integer izf,        ! row # of start candidate   (in)
     +        dom         ! domain # for target        (in)
      logical ecorr       ! energy correction flag     (in)
      integer istat       ! return status              (out)

*     double precision dz ! z difference for transport (in)

#include "arte/Arte.fi"
#include  "pris/zpstat.fi"

      integer npoints,ifstart,ifend,ii,jj,kk,ll,mm,iii,jjj,ipl,imc,
     +             mimp,nnmimp,iter
      integer message_id_1, message_id_2 , message_id_3,
     +     message_id_4, message_id_5
      double precision z_target, rrstart, x_in(5)
      real entry_pt(3), exit_pt(3), pnoise, dnoise, sqxy, 
     +     rad_thick, sum_wall, zmean
      double precision entry_z, exit_z, sum, cnoise(5,5)

      real pnoise1

#ifdef WALL
      integer tfwall
#endif

#include "rang/zf.fi"
#include "rang/zfmode.fi"
#include "rang/zdomain.fi"
#include "rang/zfpar.fi"
#include "rang/zma.fi"

      double precision f (ndimmag,ndimmag) ! transport matrix   
      double precision x_border(ndimmag)

      double precision z_in
      double precision buf(5),exe(5)
      real rk_error(2)

      real cov_e_corr

#include "auto/HITB.fi"
#include "auto/GEO.fi"
#include "auto/MIMP.fi"

#include "rang/descend.fi"

      data rk_error/0.005,0.01/
*      data rk_error/0.0005,0.0005/
      data message_id_1 /1/,message_id_2 /2/,message_id_3 /3/,
     +     message_id_4 /4/,message_id_5 /5/

      double precision f13,f15,f24,f25,f35,f45,x,y,z
      double precision F_1,F_2,F_3
      double precision G_1,G_2,G_3
      double precision FL_1,FL_2,FL_3
      double precision GL_1,GL_2,GL_3

      double precision c11 , c12 , c13 , c14 , c15
      double precision       c22 , c23 , c24 , c25
      double precision             c33 , c34 , c35
      double precision                   c44 , c45
      double precision                         c55
 
      double precision g11 , g12 , g13 , g14 , g15
      double precision g21 , g22 , g23 , g24 , g25
      double precision g31 , g32 , g33 , g34 , g35
      double precision g41 , g42 , g43 , g44 , g45
      double precision g51 , g52 , g53 , g54 , g55

      equivalence (f13,f(1,3)),(f15,f(1,5)),(f24,f(2,4))
     +           ,(f25,f(2,5)),(f35,f(3,5)),(f45,f(4,5))

      double precision fT,Tx2,Ty2,Txy,Ax,Ay
     +    ,Tx,Ty,d_z,c,qp,cd_z,cd_z2,Axqp,Ayqp
      real H(3),Xh(3)
      integer ndim

      integer if_last
      real H_last(3),X_last(3),Dx_max,Dy_max,Dz_max
      save H_last,X_last

      data c / 0.00029975d0/                     ! assume field in kG
      data Dx_max/0.2/,Dy_max/0.1/,Dz_max/0.1/
      data X_last/3*1.2345e10/

      double precision z1_buf,p1_buf(5),z2_buf,p2_buf(5)
      double precision f2(25),f2_buf(25)
      double precision z_in_old,p_buf(5),f_buf(25)
      integer if_buf,if_equal

      integer gold,jgold

#include "arte/Arte.ff"
#include "auto/HITB.ff"
#include "auto/GEO.ff"
#include "auto/MIMP.ff"
*
*     **** local statement functions
*
      entry_z() = dble( entry_pt(3) )
      exit_z()  = dble( exit_pt (3) )

      F_1(x,y,z) = x + f13*y + f15*z
      F_2(x,y  ) = x + f24*y 
      F_3(x,y  ) = x + f35*y

      G_1(x,y,z) = x + f13*y + f15*z
      G_2(x,y  ) = x + f24*y 
      G_3(x,y  ) = x + f35*y


      FL_1(x,y,z) = x + f13*y 
      FL_2(x,y  ) = x + f24*y 
      FL_3(x,y  ) = x 

      GL_1(x,y,z) = x + f13*y 
      GL_2(x,y  ) = x + f24*y 
      GL_3(x,y  ) = x 

*
*=========================================================
*
      istat = 0
      iter = 0
      z_target = z_dm(dom)
      d_z = z_target - z_zf(izf)      
      ipl = plane_zf(izf)

      if (izf.le.0.or.izf.gt.nzfmx) then
         print *,' () tftrand: invalid izf=',izf
         istat = -1
         go to 999
      endif

*     **** step 1: determine case flags
*            ifstart=0 : Runge-Kutta transport
*            ifstart=1 : starting point outside magnet
*                    2 :    ||          inside    ||
*            ifend  =1 : exit     point outside   ||
*                    2 :    ||          inside    ||
*
      if (amax1(z_zf(izf),sngl(z_target)).lt.zmin_mag_zfpar
     +     .or.amin1(z_zf(izf),sngl(z_target)).gt.zmax_mag_zfpar)
     +                                                          then
         ifstart = 1
         ifend   = 1
      else
         ifstart = 0
         ifend = 0
      endif
*
*     **** step 2: transport vector & fill derivative matrix f

      if (ifstart.eq.0) then
*
      if (abs(sngl(d_z)).lt.dzpara_mag_zfpar) then       ! short distance

        Xh(1) = xx_zf(1,izf)  
        Xh(2) = xx_zf(2,izf)   
        Xh(3) = z_zf(izf) 
*      
        if_last = 0
        if(abs(Xh(3)-X_last(3)).lt.Dz_max) then
          if(abs(Xh(1)-X_last(1)).lt.Dx_max) then
            if(abs(Xh(2)-X_last(2)).lt.Dy_max) then
              H(1) = H_last(1)
              H(2) = H_last(2)
              H(3) = H_last(3)
              if_last = 1
            end if
          end if
        end if
*      
        if(if_last.eq.0) then
          call utfeld(Xh,H)
          X_last(1) = Xh(1)
c          X_last(2) = Xh(2)
          X_last(3) = Xh(3)
          H_last(1) = H(1)
          H_last(2) = H(2)
          H_last(3) = H(3)
        end if
*      
        Tx = xx_zf(3,izf)
        Ty = xx_zf(4,izf)
        qp = xx_zf(5,izf)
        Tx2= Tx*Tx
        Ty2= Ty*Ty
        Txy= Tx*Ty
        fT = dsqrt( 1.d0 + Tx2 + Ty2 )
        cd_z = c * d_z
        cd_z2= cd_z * d_z * 0.5
        Ax  = fT * ( Txy       *H(1) - (1.d0+Tx2) * H(2) + Ty*H(3) )
        Ay  = fT * ( (1.d0+Ty2)*H(1) - Txy        * H(2) - Tx*H(3) )
        Axqp = Ax * qp
        Ayqp = Ay * qp
*
        x_db(1,dom) = xx_zf(1,izf) + Tx*d_z + Axqp*cd_z2
        x_db(2,dom) = xx_zf(2,izf) + Ty*d_z + Ayqp*cd_z2
        x_db(3,dom) = Tx + Axqp * cd_z
        x_db(4,dom) = Ty + Ayqp * cd_z
        x_db(5,dom) = qp
*
        f13         = d_z
        f15         = Ax * cd_z2
        f24         = d_z 
        f35         = Ax * cd_z
*
      else                                             ! long distance
        z_in = dble(z_zf(izf))
        if_buf = 0
        if_equal = 0
        if(z1_buf.eq.z_in) then
          if(p1_buf(1).eq.xx_zf(1,izf)) then
            if(p1_buf(2).eq.xx_zf(2,izf)) then
              if(p1_buf(3).eq.xx_zf(3,izf)) then
                if(p1_buf(4).eq.xx_zf(4,izf)) then
                  if(p1_buf(5).eq.xx_zf(5,izf)) then
                    if(dabs(z2_buf-z1_buf).le.dabs(z_target-z_in)) then
                      if_buf=1
                      if(z_target.eq.z2_buf) if_equal = 1
                    end if
                  end if
                end if
              end if
            end if
          end if
        end if
*
        if(if_buf.eq.1.and.if_equal.eq.0) then
          z_in = z2_buf
          d_z = z_target - z_in
          if (dabs(d_z).le.dzpara_mag_zfpar*3.) then
            call rk4fast(z_in,p2_buf,z_target,x_db(1,dom),f2,istat)
          else
            call rk5fast(z_in,p2_buf,rk_error,z_target
     +           ,x_db(1,dom),f2,istat)
          end if
*                                                ! f = f2 * f2_buf
          f13 = f2(11) + f2_buf(11)
          f15 = f2(21) + f2_buf(21) + f2(11) * f2_buf(23)
          f24 = f2(17) + f2_buf(17)
          f35 = f2(23) + f2_buf(23)
*
          z_in_old = z_zf(izf)
          if(dabs(z_target - z_in_old).le.dzpara_mag_zfpar*3.) then
*          
            call rk4fast(z_in_old,xx_zf(1,izf),z_target
     +           ,p_buf,f_buf,istat)
          else 
*            
            call rk5fast(z_in_old,xx_zf(1,izf),rk_error,z_target
     +           ,p_buf,f_buf,istat)
          end if
*
        else if(if_buf.eq.1.and.if_equal.eq.1) then    ! z_target = z2_buf
          do ii=1,5
            x_db(ii,dom)=p2_buf(ii)
          end do
          f13 = f2_buf(11)
          f24 = f2_buf(17)
          f15 = f2_buf(21)
          f35 = f2_buf(23)
*
        else                                      !  new parameters
          z1_buf = z_in
          do ii=1,5
            p1_buf(ii) = xx_zf(ii,izf)
          end do
          z2_buf = z_target
*           
          if(dabs(d_z).le.dzpara_mag_zfpar*3.) then
            z_in = dble(z_zf(izf))
            call rk4fast(z_in,xx_zf(1,izf),z_target
     +           ,x_db(1,dom),f,istat)
          else 
            z_in = dble(z_zf(izf))
            call rk5fast(z_in,xx_zf(1,izf),rk_error,z_target
     +           ,x_db(1,dom),f,istat)
          end if
*
          do ii=1,5
            p2_buf(ii) = x_db(ii,dom)
          end do
          f2_buf(11) = f13
          f2_buf(17) = f24
          f2_buf(21) = f15
          f2_buf(23) = f35
*
        end if                                     ! end of new parameters
*
      end if                                       ! end of transport
*    
      if (istat.lt.0) then
        call mepric(message_id_1,1,'tftrand: transport impossible (rk)')
        go to 999
      end if
*
      elseif (ifstart.eq.1.and.ifend.eq.1) then
*        **** start/end outside magnet
*        **** ignore possibility of WHOLE MAGNET in between
         x_db(1,dom) = xx_zf(1,izf) + d_z * xx_zf(3,izf)
         x_db(2,dom) = xx_zf(2,izf) + d_z * xx_zf(4,izf)
         x_db(3,dom) = xx_zf(3,izf)
         x_db(4,dom) = xx_zf(4,izf)
         x_db(5,dom) = xx_zf(5,izf)
*
*        **** f matrix
*
         f13 = d_z
         f24 = d_z
         f15 = 0.
         f35 = 0.
         

*
      endif                             ! end of options ifstart,ifend
*
*     **** step 3: propagate cov matrix

**      pnoise = 1./(dabs(xx_zf(5,izf))+dsqrt(cx_zf(5,5,izf))*2.)
      pnoise = 1./dabs(xx_zf(5,izf))
      pnoise = amax1(pnoise,1.)

*     **** get radiation thickness

#ifdef WALL
      sum_wall = tfwall(ipl,sngl(z_target),
     +     sngl(xx_zf(1,izf)),
     +     sngl(xx_zf(2,izf)),
     +     sngl(xx_zf(3,izf)),
     +     sngl(xx_zf(4,izf)))
#else
      sum_wall = fgede_ms(ipl)
#endif
*
      dnoise = f_moliere_zfpar * sum_wall / pnoise**2
*
*     **** correct for angle
      sqxy = dsqrt(1.d0 + x_db(3,dom)**2 + x_db(4,dom)**2)
      dnoise = dnoise * sqxy
      rad_thick = sum_wall * sqxy / 0.0136**2
*
*
      c11 = cx_zf(1,1,izf)
      c12 = cx_zf(1,2,izf)
      c13 = cx_zf(1,3,izf)
      c14 = cx_zf(1,4,izf)
      c15 = cx_zf(1,5,izf)
*
      c22 = cx_zf(2,2,izf)
      c23 = cx_zf(2,3,izf)
      c24 = cx_zf(2,4,izf)
      c25 = cx_zf(2,5,izf)
*
      c33 = cx_zf(3,3,izf) + (1.+x_db(3,dom)**2) * sqxy**2 * dnoise
      c34 = cx_zf(3,4,izf) - x_db(3,dom) * x_db(4,dom)*sqxy**2 * dnoise
      c35 = cx_zf(3,5,izf)
*
      c44 = cx_zf(4,4,izf) + (1.+x_db(4,dom)**2) * sqxy**2 * dnoise
      c45 = cx_zf(4,5,izf)
*
      c55 = cx_zf(5,5,izf)
*
      IF(ifstart.eq.0) THEN
*
        g11 = F_1( c11 , c13 , c15 )
        g12 = F_1( c12 , c23 , c25 )
        g13 = F_1( c13 , c33 , c35 )
        g14 = F_1( c14 , c34 , c45 )
        g15 = F_1( c15 , c35 , c55 )
*        
        g21 = F_2( c12 , c14       )
        g22 = F_2( c22 , c24       )
        g23 = F_2( c23 , c34       )
        g24 = F_2( c24 , c44       )
        g25 = F_2( c25 , c45       )
*
        g31 = F_3( c13 , c15       )
        g32 = F_3( c23 , c25       )
        g33 = F_3( c33 , c35       )
        g34 = F_3( c34 , c45       )
        g35 = F_3( c35 , c55       )
*
        g41 = c14             
        g42 = c24             
        g43 = c34             
        g44 = c44             
        g45 = c45             
*
        g51 = c15             
        g52 = c25             
        g53 = c35             
        g54 = c45             
        g55 = c55             
*
        cx_db(1,1,dom) = G_1( g11 , g13 , g15 )
        cx_db(2,1,dom) = G_1( g21 , g23 , g25 )
        cx_db(3,1,dom) = G_1( g31 , g33 , g35 )
        cx_db(4,1,dom) = G_1( g41 , g43 , g45 )
        cx_db(5,1,dom) = G_1( g51 , g53 , g55 )
* 
        cx_db(1,2,dom) = cx_db(2,1,dom)
        cx_db(2,2,dom) = G_2( g22 , g24       )
        cx_db(3,2,dom) = G_2( g32 , g34       )
        cx_db(4,2,dom) = G_2( g42 , g44       )
        cx_db(5,2,dom) = G_2( g52 , g54       )

        cx_db(1,3,dom) = cx_db(3,1,dom)
        cx_db(2,3,dom) = cx_db(3,2,dom)
        cx_db(3,3,dom) = G_3( g33 , g35       )
        cx_db(4,3,dom) = G_3( g43 , g45       )
        cx_db(5,3,dom) = G_3( g53 , g55       )

        cx_db(1,4,dom) = cx_db(4,1,dom)
        cx_db(2,4,dom) = cx_db(4,2,dom)
        cx_db(3,4,dom) = cx_db(4,3,dom)
        cx_db(4,4,dom) = g44             
        cx_db(5,4,dom) = g54             

        cx_db(1,5,dom) = cx_db(5,1,dom)
        cx_db(2,5,dom) = cx_db(5,2,dom)
        cx_db(3,5,dom) = cx_db(5,3,dom)
        cx_db(4,5,dom) = cx_db(5,4,dom)
        cx_db(5,5,dom) = g55             

*
      ELSE                                     !  ifstart.ne.0
*
        g11 = FL_1( c11 , c13 , c15 )
        g12 = FL_1( c12 , c23 , c25 )
        g13 = FL_1( c13 , c33 , c35 )
        g14 = FL_1( c14 , c34 , c45 )
        g15 = FL_1( c15 , c35 , c55 )
*        
        g21 = FL_2( c12 , c14       )
        g22 = FL_2( c22 , c24       )
        g23 = FL_2( c23 , c34       )
        g24 = FL_2( c24 , c44       )
        g25 = FL_2( c25 , c45       )
*
        g31 = FL_3( c13 , c15       )
        g32 = FL_3( c23 , c25       )
        g33 = FL_3( c33 , c35       )
        g34 = FL_3( c34 , c45       )
        g35 = FL_3( c35 , c55       )
*
        g41 = c14             
        g42 = c24             
        g43 = c34             
        g44 = c44             
        g45 = c45             
*
        g51 = c15             
        g52 = c25             
        g53 = c35             
        g54 = c45             
        g55 = c55             
*
        cx_db(1,1,dom) = GL_1( g11 , g13 , g15 )
        cx_db(2,1,dom) = GL_1( g21 , g23 , g25 )
        cx_db(3,1,dom) = GL_1( g31 , g33 , g35 )
        cx_db(4,1,dom) = GL_1( g41 , g43 , g45 )
        cx_db(5,1,dom) = GL_1( g51 , g53 , g55 )
* 
        cx_db(1,2,dom) = cx_db(2,1,dom)
        cx_db(2,2,dom) = GL_2( g22 , g24       )
        cx_db(3,2,dom) = GL_2( g32 , g34       )
        cx_db(4,2,dom) = GL_2( g42 , g44       )
        cx_db(5,2,dom) = GL_2( g52 , g54       )

        cx_db(1,3,dom) = cx_db(3,1,dom)
        cx_db(2,3,dom) = cx_db(3,2,dom)
        cx_db(3,3,dom) = GL_3( g33 , g35       )
        cx_db(4,3,dom) = GL_3( g43 , g45       )
        cx_db(5,3,dom) = GL_3( g53 , g55       )

        cx_db(1,4,dom) = cx_db(4,1,dom)
        cx_db(2,4,dom) = cx_db(4,2,dom)
        cx_db(3,4,dom) = cx_db(4,3,dom)
        cx_db(4,4,dom) = g44             
        cx_db(5,4,dom) = g54             

        cx_db(1,5,dom) = cx_db(5,1,dom)
        cx_db(2,5,dom) = cx_db(5,2,dom)
        cx_db(3,5,dom) = cx_db(5,3,dom)
        cx_db(4,5,dom) = cx_db(5,4,dom)
        cx_db(5,5,dom) = g55             
*
      END IF                                 ! end ifstart.ne.0
*
      filled_db(dom) = .true.
*
*     **** electron energy loss correction
      if (ecorr) then
         zmean = 0.5 * (z_zf(izf) + z_target)
         if ( (zmean.gt.zmin_ec_zfpar).and.
     +        (zmean.lt.zmax_ec_zfpar) ) then

            x_db(5,dom)=x_db(5,dom)*(1.+rad_thick*(0.5*rad_thick-1.))
            cov_e_corr = 0.41441588*x_db(5,dom)*x_db(5,dom)*rad_thick 
            cx_db(5,5,dom) = cx_db(5,5,dom) + cov_e_corr
         endif
      endif
*
      if( cx_db(4,4,dom).le.0..or.
     +    cx_zf(4,4,izf).le.0.) then

         print *,' tftrand: d_z, izf,is,ib,ieq='
     +    ,d_z,izf,ifstart,if_buf,if_equal
         print *,' tftrand: xx_zf(,izf)=',(xx_zf(iii,izf),iii=1,5)
         print *,' tftrand: x_db(,dom)=',(x_db(iii,dom),iii=1,5)
         print *,'f13,f24,f15,f35 ',f13,f24,f15,f35

      print '("old ")'        
      print '("cp 1:",5(e11.4))',(cx_zf(1,ii,izf),ii=1,5)
      print '("cp 2:",5(e11.4))',(cx_zf(2,ii,izf),ii=1,5)
      print '("cp 3:",5(e11.4))',(cx_zf(3,ii,izf),ii=1,5)
      print '("cp 4:",5(e11.4))',(cx_zf(4,ii,izf),ii=1,5)
      print '("cp 5:",5(e11.4))',(cx_zf(5,ii,izf),ii=1,5)
      print '("new ")'        
      print '("cp 1:",5(e11.4))',(cx_db(1,ii,dom),ii=1,5)
      print '("cp 2:",5(e11.4))',(cx_db(2,ii,dom),ii=1,5)
      print '("cp 3:",5(e11.4))',(cx_db(3,ii,dom),ii=1,5)
      print '("cp 4:",5(e11.4))',(cx_db(4,ii,dom),ii=1,5)
      print '("cp 5:",5(e11.4))',(cx_db(5,ii,dom),ii=1,5)
      endif
*

      if (diag_level.ge.6) then
         print *,' tftrand: d_z, izf,is,ib,ieq='
     +    ,d_z,izf,ifstart
         print *,' tftrand: xx_zf(,izf)=',(xx_zf(iii,izf),iii=1,5)
         print *,' tftrand: cx_zf(,,izf)',
     +        ((cx_zf(iii,jjj,izf),iii=1,5),jjj=1,5)
         print *,' tftrand: x_db=',(x_db(iii,dom),iii=1,5)
         print *,' tftrand: cx_db=',
     +        ((cx_db(iii,jjj,dom),iii=1,5),jjj=1,5)
      endif
*


*
 999  end


