// *****************************************************************************
//
// source:    kasltsim.hh
//
// type:      header file
//
// created:   21 Mar 2001
//
// author:    Lars Soezueer
//            email: soezueer@mail.desy.de
//
// purpose:   class declaration for the KUIP interface SLT/SIM of sltarte
//
// changes:   15 Oct 2001 members for SLT parameter commands
//
// *****************************************************************************
#ifndef _KASLTSIM_
#define _KASLTSIM_

#include <hash_map>
#include <string>

struct eqParams
{
 bool operator()(const char* p1, const char* p2) const {
  return strcmp(p1, p2) == 0;
 }
};
typedef hash_map<const char*, char*, hash<const char*>, eqParams> SLT_params_t;

class kasltsim
{
public:
  static kasltsim* Instance();
  static char* get_edcpath()    { return Instance()->m_edcpath; }
  static void  set_edcpath(char* arg)   {Instance()->m_edcpath    = arg; }
  static char* get_edcfile()    { return Instance()->m_edcfile; }
  static void  set_edcfile(char* arg)   {Instance()->m_edcfile    = arg; }
  static int   get_debuglevel() { return Instance()->m_debuglevel; }
  static void  set_debuglevel(int arg)  {Instance()->m_debuglevel = arg; }
  static int   get_runnumber()  { return Instance()->m_runnumber; }
  static void  set_runnumber(int arg)   {Instance()->m_runnumber  = arg; }
  static bool set_SLT_param(char* param, char* value, bool force);
    //returns true if parameter is successfully changed
  static bool unset_SLT_param(char* param);
    //returns true if parameter is unset successfully
  static char*const* get_SLT_params();
  static void dump_SLT_param();

protected:
  kasltsim();

private:
  static kasltsim* m_instance;
  char* m_edcpath;
  char* m_edcfile;
  int   m_debuglevel;
  int   m_runnumber;
  SLT_params_t m_SLT_params;
  SLT_params_t locked_SLT_params;
};

#endif
