*
*-- Author :    Vik   11/11/98
*

      SUBROUTINE TRD_TRA(N_MR,I,NN_BLOK)

**********************************************************************
*
* Description: determined the plane from straw with Reconstruction hit's 
*              in each of TRD blok
*
* Called from: TRD_REC
*
*          in: N_MR    - Matrix number
*              I       - Seed number for matrix N_MR
*              NN_BLOK - TRD blok 
*
*********************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "gean/gclink.fi"
#include "gean/gcvolu.fi"
#include "gean/gcflag.fi"
#include "gean/ZGMOTH.fi"
#include "auto/GEO.fi"
#include "gean/ZGESL.fi"
#include "gean/ZGDETV.fi"
#include "auto/MIMP.fi"
#include "auto/MTRA.fi"
#include "auto/TOPP.fi"
#include "auto/DIGB.fi"
#include "auto/HITB.fi"

      DOUBLE PRECISION A, B       
      REAL X_BL_LEFT, Z_BL_ST, D_STRAW, X_L_1, Y_L_1, Y_R_1,
     +     X_L_16, Y_L_16, Y_R_16, X_NEW_1_1, Y_NEW_1_1,
     +     X_NEW_1_2, Y_NEW_1_2, X_NEW_16_1, Y_NEW_16_1,
     +     X_NEW_16_2, Y_NEW_16_2, ANGL, PIRAD, Y_BL_LT, 
     +     Y_BL_RT, AP, BP, CP, DP, LAYER_A, LAYER_B, 
     +     LAYER_C, LAYER_D, SIGMA_2, SIGMA, X_BL_RT
      INTEGER ROAD, FLAG, N_STR_HIT, N_TR, N_ISEC, N_MAX,
     +        N_MR,I,NN_BLOK, ROW, LAYER_N, TRACK, N_TRA

      COMMON /TRD_ROAD/ ROAD, FLAG, N_STR_HIT, TRACK
      COMMON /TRD_LEFT/ X_BL_LEFT, Z_BL_ST, Y_BL_LT, Y_BL_RT, X_BL_RT
      COMMON /TRD_LAYER/ LAYER_A, LAYER_B, LAYER_C, LAYER_D, 
     +                   LAYER_N, SIGMA

      PARAMETER (N_MAX = 1000)
      PARAMETER (N_TRA = 100)

      DIMENSION X_BL_LEFT(12,16), Z_BL_ST(12,16)
      DIMENSION Y_BL_LT(12,16), Y_BL_RT(12,16), X_BL_RT(12,16)
      DIMENSION ROAD(N_MAX,15,16,N_TRA), N_STR_HIT(3)
      DIMENSION FLAG(N_MAX,15,16), TRACK(N_MAX,15,N_TRA)
      DIMENSION LAYER_A(N_MAX,15,N_TRA), LAYER_B(N_MAX,15,N_TRA)
      DIMENSION LAYER_C(N_MAX,15,N_TRA), LAYER_D(N_MAX,15,N_TRA)
      DIMENSION SIGMA(N_MAX,15,N_TRA)
      DIMENSION LAYER_N(N_MAX,15)
C...
      DATA N_ISEC /6/, PIRAD/3.14159/
C
#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/MIMP.ff"
#include "auto/MTRA.ff"
#include "auto/TOPP.ff"
#include "auto/DIGB.ff"
#include "auto/HITB.ff"
C
C TRD Event Analysis.
C
*      PRINT *,'START TRACK analysis for TRD', N_MR, I, NN_BLOK
C
      D_STRAW = 0.61
C
      DO N_TR = 1, 100
       IF(ROAD(N_MR,I,4,N_TR).NE.0) THEN  
C
         IF(FLAG(N_MR,I,16).NE.0) THEN
            ROW = 16
            GO TO 10
         END IF
         IF(FLAG(N_MR,I,15).NE.0) THEN
            ROW = 15
            GO TO 10
         END IF
C
         ROW = 14
C
 10      CONTINUE
C
         CALL TRD_CRTR(N_MR,I,NN_BLOK,ROW,N_TR,A,B,SIGMA_2)
C
         X_L_1 = A*Z_BL_ST(NN_BLOK,1) + B
         Y_L_1 = Y_BL_LT(NN_BLOK,1)  
         Y_R_1 = Y_BL_RT(NN_BLOK,1)
C
         X_L_16 = A*Z_BL_ST(NN_BLOK,ROW) + B
         Y_L_16 = Y_BL_LT(NN_BLOK,ROW)  
         Y_R_16 = Y_BL_RT(NN_BLOK,ROW)
C...
              IF(NN_BLOK.LE.N_ISEC) THEN
                 ANGL = -1.*PIRAD/3.
              ELSE
                 ANGL = PIRAD/3.
              END IF 
C
              X_NEW_1_1 =   X_L_1*COS(ANGL) + Y_L_1*SIN(ANGL)
              Y_NEW_1_1 = - X_L_1*SIN(ANGL) + Y_L_1*COS(ANGL)
C
              X_NEW_1_2 =   X_L_1*COS(ANGL) + Y_R_1*SIN(ANGL)
              Y_NEW_1_2 = - X_L_1*SIN(ANGL) + Y_R_1*COS(ANGL)
C
              X_NEW_16_1 =   X_L_16*COS(ANGL) + Y_L_16*SIN(ANGL)
              Y_NEW_16_1 = - X_L_16*SIN(ANGL) + Y_L_16*COS(ANGL)
C
              X_NEW_16_2 =   X_L_16*COS(ANGL) + Y_R_16*SIN(ANGL)
              Y_NEW_16_2 = - X_L_16*SIN(ANGL) + Y_R_16*COS(ANGL)
C
c              WRITE
c     +  (*,'(''TRACK_TRD==>'',8(1X,F8.3),I4)')
c     +    X_NEW_1_1, Y_NEW_1_1, X_NEW_1_2, Y_NEW_1_2,
c     +    X_NEW_16_1, Y_NEW_16_1, X_NEW_16_2, Y_NEW_16_2, NN_BLOK
C
              CALL TRD_LAY(X_NEW_1_1, Y_NEW_1_1,
     +                      X_NEW_16_1, Y_NEW_16_1,
     +                      X_NEW_16_2, Y_NEW_16_2, NN_BLOK,
     +                      AP,BP,CP,DP)
C
              LAYER_A(N_MR, I, N_TR) = AP
              LAYER_B(N_MR, I, N_TR) = BP
              LAYER_C(N_MR, I, N_TR) = CP
              LAYER_D(N_MR, I, N_TR) = DP
              SIGMA(N_MR, I, N_TR)   = SIGMA_2
C
              LAYER_N(N_MR, I)       = N_TR
C
       END IF
      END DO
C
c      PRINT *,'STOP TRACK analysis for TRD'
C
 900  END

*********************************************************************
* End of TRD_TRA
************************************************************************
